// Item.h
// Header File for the CItem class
////////////////////////////////////////
 
#ifndef CITEM
#define CITEM

#ifdef _DLL
//	#include "DLL_CONST.h"
#else
	#include <afx.h>
#endif
 
// Include version info
#ifdef _ALIUSE
	#include "..\Versions\versions.h"
#else
	#include "versions.h"
#endif

#include "BBox.h"

#include "PosArray.h"

#include "HatchFill.h"

/*** BARCODE ***/
#include "BarCode.h"

/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
#ifdef _ALIUSE
	#include ".\ImageData.h"
#else
	#include "ImageData.h"
#endif
/*** 1.0129 ****************************/

/// 1.0280 DAN 1/15/00 DRILL OBJECTS ///
#include "DrillData.h"
////1.0280//////////////////////////////////

//// 1.0683 PAT 27.06.02 DOT MATRIX FONT ////
#include "DotMatrixFont.h"
//// 1.0683 /////////////////////////////////

/// 1.0550 DAN 4/29/05 DAN RTF ///
///123#include "RichTextRend.h"
#include "RTFData.h"
////1.0550////////////////////////

//// PS091029A SIMPLE TEXT RTF ////
#include "RTFText.h"
//// PS091029A ////////////////////

//#define CI_VERSION	100

// File Name Extensions
#define	FONT_EXT	_T("ALF")
#define FONT_FLTR	_T("*.ALF")
#define OBJ_EXT		_T("ALF")
#define OBJ_FLTR	_T("*.ob2")
#define GRPH_EXT	_T("ALG")
#define GRPH_FLTR	_T("*.ALG")

// X/Y Justifications
#define JX_LEFT		0
#define JX_CENTER	1
#define JX_RIGHT	2
#define JY_BOTTOM	0
#define JY_CENTER	1
#define JY_TOP		2

/// 1.0550 DAN 4/29/05 DAN RTF ///
/// 1.0280 DAN 1/15/00 DRILL OBJECTS ///
// Item Types
//	#define CI_NUM_TYPES	10
#define CI_NO_TYPE	0
#define CI_FIXED	1
#define CI_VARTEXT	2
#define CI_GRAPHIC	3
#define CI_EMPTY	4
#define CI_LINK		5
#define CI_LINE		6
//// 1.0777 PAT 26.06.03 DATA OBJECT TYPE ////
//	#define CI_SPOT		7
#define CI_DATA		7
//// 1.0777 //////////////////////////////////
#define CI_DRILL	8
////1.0280//////////////////////////////////

#define CI_RTF		9
////1.0550////////////////////////

//// PS090722A WMF ITEM TYPE ////
//	#define CI_NUM_TYPES	10
#define CI_WMF		10
//// PS090722A //////////////////
#define CI_NUM_TYPES	11



// Text
#define CI_NUMTEXTLINES		10
//// 1.0237 PAT 27.09.99 IMGPAGE TEXT TRANSFER ////
//// 1.0543 PAT 21.05.01 256 CHAR PER LINE ////
//	#define CI_MAXCHARPERLINE	80
#define CI_MAXCHARPERLINE	256
//// 1.0543 ///////////////////////////////////
//// 1.0237 ///////////////////////////////////////


// Variable Text Types
#define CI_NOVARTEXT		32000
#define CI_KEYBOARD			0
#define	CI_DATE				1
/*** 1.0201 PAT 01.07.99 VAR TEXT DYNFILE TYPE ***/
// Renamed
//#define	CI_CODE_READER  	2
#define CI_DYNFILE			2
/*** 1.0201 **************************************/
#define CI_SERIAL_NUMBER    3
#define CI_FILE				4
//// 1.1181 PAT 25.08.06 RS232 VAR TEXT ////
#define CI_RS232			5
//// 1.1181 ////////////////////////////////

// Mark Info
#define CI_PASSES_MIN		1
#define CI_PASSES_MAX		7

#define CI_PRCNT_MIN		0
#define CI_PRCNT_MAX		2000
#define CI_WOBBLE_MIN		0
#define CI_WOBBLE_MAX		1500

// Font Types
#define	CI_FONT_ENGRAVING	0
#define	CI_FONT_TRUETYPE	1
#define	CI_FONT_BARCODE		2
//// 1.0683 PAT 27.06.02 DOT MATRIX FONT ////
#define CI_FONT_DOTMATRIX	3
//// 1.0683 /////////////////////////////////

/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
// Graphic Types
#define CI_GRAPHIC_VECTOR	0
#define CI_GRAPHIC_RASTER	1
/*** 1.0129 ****************************/

/*** DAN JAN 22 ***/
// Prompt timing
#define CI_PROMPT_PART		0
#define CI_PROMPT_BATCH		1
#define CI_PROMPT_NEVER		2
/******************/

/*** 1.0067 PAT 02.06.98 MORE RELATIVE / ABSOLUTE PATH ***/
#define ITEM_DEFAULT_FONT				_T("SIMPLEX.ALF")
#define ITEM_DEFAULT_GRAPHIC			_T("BOX.ALG")
/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
#define ITEM_DEFAULT_RASTER				_T("BMP.ALG")
/*** 1.0129 ****************************/
#define ITEM_DEFAULT_BOX				_T("BOX.ALG")
#define	ITEM_DEFAULT_CIRCLE				_T("CIRCLE.ALG")
/*********************************************************/

//// 1.0677 PAT 24.05.02 DATA MATRIX BITMAP ////
#define ITEM_DEFAULT_RASTERBARCODE		_T("2DCODE.ALG")
//// 1.0677 ////////////////////////////////////

// Default font names
/*** PAT 6 JAN 1998 ***/
//#define CI_ENGRAVING_DEFAULT	"C:\\DEV40\\WINSCRIBE\\SIMPLEX.ALF"
#define	CI_ENGRAVING_DEFAULT	_T("SIMPLEX.ALF")
/***/

/*** 1.0137 PAT 25.01.99 TTF CHAR SET INFO FIX ***/
//#define CI_TRUETYPE_DEFAULT		"Arial#____+05+00.TAT"
#define CI_TRUETYPE_DEFAULT		_T("Arial#____+05+00&&&00.TAT")
/*** 1.0137 **************************************/

/*** BARCODE ***/
#define	CI_BARCODE_DEFAULT		_T("Code 39.ABF")

//// 1.0683 PAT 27.06.02 DOT MATRIX FONT ////
#define CI_DOTMATRIX_DEFAULT	DMF_TYPE_5_BY_7_NAME + (CString)_T(".") + (CString)CVT_FE_ADM
//// 1.0683 /////////////////////////////////

/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
#define CI_VECTOR_DEFAULT		_T("BOX.ALG")
//// PS090611F L("PROLASE") REPLACEMENT FOR ECONOLASE ////
//	#define CI_RASTER_DEFAULT		"ProLase.BMP.ABM"
#define CI_RASTER_DEFAULT		_T("Raster.BMP.ABM")
//// PS090611F ///////////////////////////////////////////
/*** 1.0129 ****************************/

/*** 1.0105 PAT 02.09.98 NEW TEXT ASPECT MODES ***/
#define CI_ASPECTRATIO_RES			100
#define CI_ASPECTMODE_FREE			0
#define CI_ASPECTMODE_NATURAL		1
#define CI_ASPECTMODE_FIXED			2
#define CI_ASPECTMODE_SQUEEZE		3
/*************************************************/
//// 1.0945 PAT 17.09.04 SHRINK ASPECT MODE ////
#define CI_ASPECTMODE_SHRINK		4
//// 1.0945 ////////////////////////////////////

//// 1.0723 PAT 14.11.02 REAL SIZE PATCH ////
#define CI_REALSIZE_UNITS_NONE		0
#define CI_REALSIZE_UNITS_IN		1
#define CI_REALSIZE_UNITS_FT		2
#define CI_REALSIZE_UNITS_MM		3
#define CI_REALSIZE_UNITS_CM		4
#define CI_REALSIZE_UNITS_M			5

#define CI_REALSIZE_ERR_NONE		0
#define CI_REALSIZE_ERR_NOTREAL		1
#define	CI_REALSIZE_ERR_TOOBIG		2
#define CI_REALSIZE_ERR_TOOFAR		3
//// 1.0723 /////////////////////////////////

//// 1.0741 PAT 22.01.03 TTF AS STRINGS ////
#define CI_TRUETYPELINE_FONT		_T("ATNALI.ALF")
//// 1.0741 ////////////////////////////////

//// 1.1127 PAT 14.04.06 DYN LIST VAR TEXT ////
#define CI_DYNFILE_MODE_ORIG		0
#define CI_DYNFILE_MODE_LIST		1

#define CI_DYNFILE_LINES_MIN		1
#define CI_DYNFILE_LINES_MAX		CI_NUMTEXTLINES
//// 1.1395 PAT 02.11.07 DYN FILE LEGACY FIX ////
//	#define CI_DYNFILE_LINES_ORIG		CI_DYNFILE_LINES_MAX
#define CI_DYNFILE_LINES_ORIG		0
//// 1.1395 /////////////////////////////////////
//// 1.1127 ///////////////////////////////////

//// 1.1281 PAT 19.01.07 NO APPEND CHECKSUM MODE ////
#define CHECKSUM_MODE_APPEND		0
#define CHECKSUM_MODE_APPEND_NAME	_T("Append")

#define CHECKSUM_MODE_REPLACE		1
#define CHECKSUM_MODE_REPLACE_NAME	_T("Replace")
//// 1.1281 /////////////////////////////////////////

//// PS080619A HEX SERIAL NUMBER ////
#define SERIALNUM_INCMODE_ALPHANUMERIC		0
#define SERIALNUM_INCMODE_ALPHABETIC		1
#define SERIALNUM_INCMODE_DECIMAL			2
#define SERIALNUM_INCMODE_HEX				3

#define SERIALNUM_INCMODE_CASE_BOTH			0
#define SERIALNUM_INCMODE_CASE_UPPER		1
#define SERIALNUM_INCMODE_CASE_LOWER		2
//// PS080619A //////////////////////

//// PS091029A SIMPLE TEXT RTF ////
#define FIXEDTEXT_MODE_SIMPLE				0
#define FIXEDTEXT_MODE_RTF					1
//// PS091029A ////////////////////

/*
#ifdef _DLL
class __declspec( dllexport ) CItem : public CObject
#else
class CItem : public CObject
#endif
*/

#ifndef _PROLASEDLL
	#define DllExport
#else
	#define DllExport   __declspec( dllexport )
#endif // _PROLASEDLL
 
class DllExport CItem : public CObject
{


	DECLARE_SERIAL( CItem )

//Attributes
public:
	
	// CItem class version #
//	int		m_iVersion;
	UINT	m_nVersion;

	UINT	m_bItemUsed;		// Flag to tell if an item is being used

	BOOL	m_bShowBlanking;
	
// Variables for linked item
	UINT	m_bLinkedItem;		// Flag to tell if item is linked
	CString	m_sItemFileName;	// Linked Item file name

// Item Identification
	CString m_sItemName;		// Name of the item (user defined)


// Item Position / Orientation
	long	m_lXPos,			// X Position
			m_lYPos,			// Y Position
			m_lHeight,			// Height
			m_lLength;			// Length

	int		m_iAngle,			// Rotation Angle
			m_iItalic;			// Italic Angle

	long	m_lRadius;			// Ring Mode Radius

	int		m_nXJust,			// X Justification
			m_nYJust;			// Y Justification

	BOOL	m_bMirrorX,			// X Mirror
			m_bMirrorY;			// Y Mirror

	/*** 1.0105 PAT 02.09.98 NEW TEXT ASPECT MODES ***/
	// This variable is obsolete
	/*** PAT 6 DEC 97 ***/
	//BOOL	m_bFixedAspect;
	/***/
	// Variables for the new text modes
	UINT
		m_nAspectMode;
	/*** 1.0113 PAT 21.09.98 ASPECT MODE ADJUSTMENTS ***/
	// Made this variable a double
	//int
	//	m_iAspectRatio;
	float
		m_fAspectRatio;
	/***************************************************/

	/*************************************************/	


	// Item Type Information
	UINT	m_nItemType;		// Item Type

	// Text Specific Information
	CString	m_sText[CI_NUMTEXTLINES];		// Text Lines
	CString	m_sFixedText[CI_NUMTEXTLINES];	// Fixed Text Data
//// 1.0289 PAT 23.02.00 BAR CODE DATA LINK OBJECT ARRAY ////
	CString
		m_asLinkText[CI_NUMTEXTLINES];
//// 1.0289 /////////////////////////////////////////////////

	
	CString	m_sFont;			// FontName

	long	m_lCharSpace;		// Character Spacing
	long	m_lLineSpace;		// Line Spacing


	// Variable Text Information
	int		m_iVarTextType;		// Variable Text Type

	CString	m_sVarPrompt;		// Prompt for keyboard input or code reader
	CString m_sVarSample;
	CString	m_sVarFileName;		// FileName for variable text input
	CString m_sVarSerialNum;
	CString m_sVarStartSerialNum;
	int		m_iCarryOver;
	int		m_iVarSerialInc;	// Serial Increment
	long	m_lVarSerialNum;	// Serial Number for variable text input
	int		m_iVarDateCodeType;	// Date code style for variable text input
	/*** DAN BARCODE ***/
	CString m_sVarDateCode;		// Date code string
	/*******************/

	// Added by Keith 1/10/98
	BOOL	m_bVarSerializeObjectArrays;
	BOOL	m_bVarResetPart;
	BOOL	m_bVarResetLimit;
	BOOL	m_bVarResetDateChange;
	int		m_iDateChangeType;
	CTime	m_tLastDateMarked;
	BOOL	m_bVarResetBatch;

	CString	m_sVarResetLimitValue;
	int		m_iVarMarksPerIncrementValue;

	/*** 1.0123 PAT 13.10.98 SUPRESS LEADING ZEROS ***/
	BOOL
		m_bVarSerialSupressZeros;
	BOOL
		m_bAutoResetListFile;
	/*** 1.0123 **************************************/

	/*** 1.0125 PAT 13.10.98 FIX DATALINK TO BARCODE ***/
	CString
		m_sVarText;
	/*** 1.0125 ****************************************/

	/* DAN JAN 22 **/
	int		m_iPrompt;
	/***************/

	/*** 1.0205 PAT 05.07.99 OBJECT PET ***/
	BOOL
		m_bPETEnable;
	CString
		m_sPETName;
	/*** 1.0205 ***************************/

	// Item array information
	UINT	m_nXArray,			// X Dimension
			m_nYArray;			// Y Dimension
	long	m_lXInc,			// X Increment
			m_lYInc;			// Y Increment
	UINT	m_bLocalCoord;		// Local Coordinates Flag
	int		m_iCharSet;

	// Graphic Specific Information
	CString	m_sFileName;		// Graphic File Name

	// Linked Item Specific Information
	CString	m_sLinkItemName;
	int	m_iLinkLayer,
		m_iLinkItem;


	// Item Variable Mark Informatiom

	unsigned char	m_uCondMark,	// Item Conditional Mark
					m_uCondMask;	// Item Conditional Mask

	int		m_iSpeedFac,		// Speed Percentage Factor
			m_iPowerFac,		// Power Percentage Factor
			m_iFreqFac;			// Frequency Percentage Factor

	long	m_lWobbleWidth;		// Wobble Width
	int		m_iWobbleType;
	int		m_iWobbleDensity;

	int		m_iPasses;			// Number of Passes

	BOOL m_bMFPass[8];
	
	float m_fSpeed2;
	float m_fPower2;
	float m_fFreq2;
	BOOL m_bUseMaterialFile;


// Bounding Box information
	CBBox	m_BBox;

	BOOL	m_bCanBeFilled;		// can it have a fill
	BOOL	m_bUseOutline;		// Include the outline
	BOOL	m_bUseFill;			// Include the fill
	CHatchFill m_HatchFill;	// Hatch Fill vectors

/*** BARCODE ***/
/*** PAT 25 FEB 1998 ***/
	BOOL	m_bUseBarCode;
	CBarCode m_BCData;
/***/

// Item Specific Delays
	UINT	m_bProgramValues;	// Flag to use program values
	UINT	m_nResPos;			// Delays and timer values
	UINT	m_nTcAngle;
	UINT	m_nTcDistance;
	UINT	m_nTcEndSeg;
	UINT	m_nTcPoly;
	UINT	m_nTcPos;
	UINT	m_nTcStartSeg;

	/// 1.0228 DAN 7/23/99 QUEUE - REMOVAL OF PRELOADING ///
	// Now we are no longer using this variable... make it
	// a temp variable again
	///REMOVED int	m_iVarFileRecord;
	int m_iTemp1;
	////1.0228//////////////////////////////////////////////

	/*** 1.0147 PAT 17.02.99 BITMAP MARKING - GIDDYUP ***/
	//int  m_iTemp2;	- replaced
	int
		m_iSpeedUp;
	/*** 1.0147 *****************************************/

	/// 1.0340 DAN 11/25/00 PLOTTER MARKER DRIVER ADDITIONS 2 ///
   	//int	 m_iTemp3; - replaced
	//int	 m_iTemp4; - replaced
	int	m_nPlotterPenWidth;
	int	m_nPlotterPenColor;
	////1.0340///////////////////////////////////////////////////
	int	 m_iTemp5;

	CString  m_sTemp1;
	CString	 m_sTemp2;
	CString	 m_sTemp3;
	CString	 m_sTemp4;
	CString	 m_sTemp5;

	/*** 1.0117 PAT 08.10.98 MODIFIED LENGTH FLAG ***/
	// Replaced one temp flag
	//BOOL	 m_bTemp1;
	BOOL
		m_bModifiedLength;
	/*** 1.0117 **************************************/
	BOOL	 m_bTemp2;
	BOOL	 m_bTemp3;
	BOOL	 m_bTemp4;
	BOOL	 m_bTemp5;


	/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
	CImageData
		m_Image;
	/*** 1.0129 ****************************/


	/// 1.0550 DAN 4/29/05 DAN RTF ///
///123	static CRichTextRend	m_RichTextRend;
	////1.0550////////////////////////


//// 1.0837 PAT 08.03.04 GROUP UNDO FIX ////
//	private:
protected:
//// 1.0837 ////////////////////////////////
	int	m_iMarkCount;



/// 1.0250 DAN 10/3/99 TEMPORARY GROUP SELECTION ///
public:
	BOOL IsInGroup(void);
	void PlaceInGroup(void);
	void ClearFromGroup(void);

protected:
	BOOL	m_bTempGroupMember;
////1.0250//////////////////////////////////////////


	


// Operators
public:
	//// 1.0493 PAT 24.01.01 DEFAULT OBJECT VALUES ////
	//	CItem(void);		// Constructor
	CItem(UINT nType = CI_NO_TYPE);
	//// 1.0493 ///////////////////////////////////////

	~CItem(void);		// Destructor

 /*** PAT 1 FEB 1998 ***/
	// equate operator =
	void operator =( const CItem& src );
	// equivalence operator ==
	BOOL operator ==( const CItem& src );
/***/


	void Init(void);	// Initialization

	//// 1.0493 PAT 24.01.01 DEFAULT OBJECT VALUES ////
	void Init(UINT nType);	// Type specific initialization
	//// 1.0493 ///////////////////////////////////////


	
    void Serialize( CArchive& ar );
	// Resets Serial number to the Starting Number
	void ResetSerialText (void);
	// Resets MarkCount
	void ResetMarkCount (void);
	// Increments the Serial Text of an item
	void IncrementSerialText (void);
	/*** 1.0096 10.22.98 SERIAL NUMBER OVERFLOW ***/
	// Increments a single character, return TRUE if it flipped
	UINT IncrementChar (unsigned char *ch, int iInc);
	/****1.0096************************************/


	/// 1.0262 DAN 12/13/99 LIVE FILL SELECTION ///
	// Delete the fill
	/// Renamed to avoid confusion
	///void DeleteFill(void);
	void ClearFillFlag(void);
	////1.0262/////////////////////////////////////

	// Sets the output text
	void SetOutputText(void);

	/*** 1.0025 PAT 09.05.98 VERIFY FILES ***/
	// Ensures that the item's file references are valid
	void ConfirmLinks(int, int);
	// Obtains a new file name for an item
	BOOL ChooseNewFile(CString&, int);
	/***************************************/

	/*** 1.0053 PAT 21.05.98 RELATIVE/ABSOLUTE PATHS ***/
	CString MakeRelative(CString);
	CString MakeAbsolute(CString);
	/***************************************************/

	/*** 1.0123 PAT 13.10.98 SUPRESS LEADING ZEROS ***/
	CString RemoveLeadingZeros(CString);
	/*** 1.0123 **************************************/

	/*** 1.0129 PAT 21.12.98 NEW BITMAPS ***/
	void ValidateChildReferences(void);
	/*** 1.0129 ****************************/

	/*** 1.0137 PAT 25.01.99 TTF CHAR SET INFO FIX ***/
	CString UpdateTTFName(CString);
	/*** 1.0137 **************************************/

	/// 1.0244 DAN 9/7/99 GRAPHIC LIBRARY STATISTIC INFORMATION ///
public:
	CString m_sHashKey;
	////1.0244/////////////////////////////////////////////////////


/// 1.0280 DAN 1/15/00 DRILL OBJECTS ///
public:
	CDrillData	m_DrillData;
////1.0280//////////////////////////////////

//// 1.0307 PAT 23.03.00 TPO ADDITION TO VGRAPH ////
public:
	BOOL m_bTPO;
//// 1.0307 ////////////////////////////////////////

//// 1.0463 PAT 12.11.00 BAD DATA ABORT ////
public:
	BOOL
		m_bBadData;
//// 1.0463 ////////////////////////////////


//// 1.0359 PAT 17.05.00 ITEM DRILL CREATE ////
	void CreateDrillSpot(long lX, long lY, UINT nRepRate, UINT nPasses);
	//// 1.0605 PAT 27.09.01 DRILL SPOT 2 ////
	void CreateDrillSpot2(long lX, long lY, UINT nDuration);
	//// 1.0605 //////////////////////////////
	void CreateDrillLine(long lX1, long lY1, long lX2, long lY2, long lVel, UINT nRepRate, UINT nPasses);
	void CreateDrillCircle(long lCenX, long lCenY, long lX, long lY, long lVel, UINT nRepRate, UINT nPasses);
	//// 1.0469 PAT 16.11.00 DRILL DELTA ANGLE ////
	//	void CreateDrillTrepan(long lX, long lY, long lAngle, long lDiameter, long lVel, UINT nRepRate, UINT nPasses);
	//// 1.0509 PAT 27.02.01 TREPAN MODE ////
	//	void CreateDrillTrepan(long lX, long lY, long lAngle, long lDiameter, long lVel, UINT nRepRate, UINT nPasses, long lDeltaAngle = 0);
	void CreateDrillTrepan(long lX, long lY, long lAngle, long lDiameter, long lVel, UINT nRepRate, UINT nPasses, long lDeltaAngle = 0, UINT nMode = CDRILL_TREPANMODE_MIX);
	//// 1.0509 /////////////////////////////
	//	void CreateDrillSpiral(long lX, long lY, long lAngle, long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses);
	//// 1.0505 PAT 23.02.01 DRILL SPIRAL PATCH ////
	//	void CreateDrillSpiral(long lX, long lY, long lAngle, long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses, long lDeltaAngle = 0);
	void CreateDrillSpiral(long lX, long lY, long lAngle, long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses, long lDeltaAngle = 0, BOOL bRev = FALSE);
	//// 1.0505 ////////////////////////////////////
	//	void CreateDrillSpiral2(long lX, long lY, long lAngle, long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses);
	//// 1.0505 PAT 23.02.01 DRILL SPIRAL PATCH ////
	//	void CreateDrillSpiral2(long lX, long lY, long lAngle, long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses, long lDeltaAngle = 0);
	void CreateDrillSpiral2(long lX, long lY, long lAngle, long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses, long lDeltaAngle = 0, BOOL bRev = FALSE);
	//// 1.0505 ////////////////////////////////////
	//// 1.0469 ///////////////////////////////////
	void CreateDrillMove(long lX1, long lY1, long lX2, long lY2, long lVel, UINT nPasses);
//// 1.0359 ///////////////////////////////////

	//// 1.0625 PAT 07.01.02 DRILL RASTER ////
	void CreateDrillRaster(long lX, long lY, DrillRasterData *pRasterData);
	//// 1.0625 //////////////////////////////

//// 1.0469 PAT 16.11.00 DRILL DELTA ANGLE ////
public:
	long
		m_lAngleDelta;
//// 1.0469 ///////////////////////////////////


/// 1.0350 DAN 1/4/01 DLL OBJECT ALLOCATION - DEALLOCATION ROUTINES //
public:
	static CItem *NewItem(void);
	static void DeleteItem(CItem *pItem);
////1.0350////////////////////////////////////////////////////////////
	//// 1.0507 PAT 26.02.01 SIMPLE TEXT FUNCTION ////
	void CreateSimpleText(long lX, long lY, long lHeight, long lLength, long lAngle, long lNumChars, char *pText, long lVel, UINT nRepRate, UINT nPasses);
	//// 1.0507 //////////////////////////////////////

	//// 1.0545 PAT 22.05.01 BARCODE LISTFILE COMMAND ////
	BOOL SetBarCode(CString sName);
	//// 1.0545 //////////////////////////////////////////

	//// 1.0561 PAT 20.06.01 RTC WOBBLE ADDITIONS ////
	double
		m_dWobbleFreq;	// in Hertz
	//// 1.0561 //////////////////////////////////////

	//// 1.0571 PAT 02.07.01 NO ROLLOVER SERIAL NUMBER ////
	BOOL
		m_bVarSerialAbortOnReset,
		m_bVarSerialDidReset;
	//// 1.0571 ///////////////////////////////////////////

	//// 1.0629 PAT 28.01.02 OUTLINE-FILL ORDER OPTION ////
	BOOL
		m_bFillAfterOutline;
	//// 1.0629 ///////////////////////////////////////////

	//// 1.0675 PAT 20.05.02 DATA MATRIX FILL ////
	void BarcodeAsRaster(void);
	long
		m_lObjectHeight,
		m_lObjectLength;
	void SetObjectHeight(void);
	void SetObjectLength(void);
	BOOL IsRasterBarcode(void);
	//// 1.0675 //////////////////////////////////

	//// 1.0683 PAT 27.06.02 DOT MATRIX FONT ////
	CDotMatrixFont
		m_DMFData;

	BOOL
		m_bUseDotMatrixFont;

	void DotMatrixAsRaster(void);

	BOOL IsRasterDotMatrix(void);

	//// 1.0683 /////////////////////////////////

	//// 1.0703 PAT 06.08.02 RTC3 OBJECT DELAYS ////
	double
		m_dDispStartSegTC,
		m_dDispPolyTC,
		m_dDispAngleTC,
		m_dDispEndSegTC,
		m_dDispPosTC,
		m_dDispDistTC,
		m_dDispPosRes,
		m_dDispRasterStart;
	void UpdateDelays(void);
	//// 1.0703 ////////////////////////////////////
//102202
	BOOL SetSizeToReal(void);
	BOOL SetPosToReal(void);

	//// 1.0723 PAT 14.11.02 REAL SIZE PATCH ////
	int
		m_iRealSizeUnits;
	double
		m_dRealSizeExtraScale;

	int SetRealSize(int iImageUnits, int iCfgUnits,
					double *pUnitScale, double *pExtraScale, double *pTotalScale,
					double dSourceH, double dSourceW, double dSourceX, double dSourceY,
					double *pItemH, double *pItemW, double *pItemX, double *pItemY);
	void SetRealScales(int iUnits, double dExtraScale);
	
	
	//// 1.0723 /////////////////////////////////

	//// 1.0733 PAT 04.12.02 LOCKED ITEM ////
	BOOL
		m_bLocked;
	//// 1.0733 /////////////////////////////

	//// 1.0741 PAT 22.01.03 TTF AS STRINGS ////
	BOOL m_bTTFNaturalKerning;
	CString m_TTFFontLast;
	CString	m_TTFTextLast0;
	CString	m_TTFTextLast1;
	CString	m_TTFTextLast2;
	CString	m_TTFTextLast3;
	CString	m_TTFTextLast4;
	CString	m_TTFTextLast5;
	CString	m_TTFTextLast6;
	CString	m_TTFTextLast7;
	CString	m_TTFTextLast8;
	CString	m_TTFTextLast9;
	long	m_TTFFillLastAngle[CI_NUMTEXTLINES];
	long	m_TTFFillLastSpacing[CI_NUMTEXTLINES];
	long	m_TTFFillLastBeamWidth[CI_NUMTEXTLINES];
	long	m_TTFFillLastItalic[CI_NUMTEXTLINES];
	long	m_TTFFillLastHeight[CI_NUMTEXTLINES];
	long double	m_TTFFillLastXComp[CI_NUMTEXTLINES];
	long	m_TTFFillLastArcPolyLength[CI_NUMTEXTLINES];
	UINT	m_TTFFillLastArcResStyle[CI_NUMTEXTLINES];
	BOOL	m_TTFFillLastBiDir[CI_NUMTEXTLINES];
	//// 1.0985 PAT 31.01.05 FILL INTERLACING ////
	UINT	m_TTFFillLastInterlace[CI_NUMTEXTLINES];
	//// 1.0985 //////////////////////////////////
	//// 1.1343 PAT 21.06.01 MULTI HATCH FOR TTF W/ KERNING PAIRS ////
	long	m_TTFFillLastNumHatches[CI_NUMTEXTLINES];
	long	m_TTFFillLastAngle1[CI_NUMTEXTLINES];
	long	m_TTFFillLastAngle2[CI_NUMTEXTLINES];
	long	m_TTFFillLastAngle3[CI_NUMTEXTLINES];
	long	m_TTFFillLastAngle4[CI_NUMTEXTLINES];
	long	m_TTFFillLastAngle5[CI_NUMTEXTLINES];
	//// 1.1343 //////////////////////////////////////////////////////
	long m_TTFTextLineSizes[CI_NUMTEXTLINES];
	long m_TTFTextFillSizes[CI_NUMTEXTLINES];
	long *m_TTFTextLines[CI_NUMTEXTLINES];
	long *m_TTFTextFills[CI_NUMTEXTLINES];
	void ClearTTFLinesAndFills(void);
	int VectorizeTTFTextLine(int iLine);
	void RenderTTFLines(void);
	//// 1.0741 ////////////////////////////////

	/// 1.0550 DAN 4/29/05 DAN RTF ///
	long *GetRTFVectors(void);
	long *GetRTFFillVectors(void);

	bool LoadRTFData(void);
	long GetRTFTotalX(void);
	long GetRTFTotalY(void);

	long GetRTFVectorSize(void);
	long GetRTFFillVectorSize(void);

	
	void SetRTFFillVectors(long *Vectors, long Size);

	void SetRTFFile(CString sPathName, CString sDefaultText);


	long m_RTFFillLastAngle;
	long m_RTFFillLastSpacing;
	long m_RTFFillLastBeamWidth;
	long m_RTFFillLastItalic;
	long m_RTFFillLastHeight;
	long double m_RTFFillLastXComp;
	long m_RTFFillLastArcPolyLength;
	UINT m_RTFFillLastArcResStyle;
	BOOL m_RTFFillLastBiDir;
	UINT m_RTFFillLastInterlace;

	CRTFData	m_RTFData;

	////1.0550////////////////////////


	//// 1.0745 PAT 30.01.03 ALTERNATE IMPORTER ////
	int m_nVectorImporterType;
	//// 1.0745 ////////////////////////////////////

	//// 1.0749 PAT 03.03.03 IMPORT PATCH ////
	BOOL VerifyLinks(int iLayer, int iItem);	
	//// 1.0749 //////////////////////////////

	//// 1.0755 PAT 10.04.03 DYNAMIC FILE CHANGE ////
	CString m_sVT[CI_NUMTEXTLINES];
	//// 1.0755 /////////////////////////////////////

	//// 1.0761 PAT 24.04.03 REAL SIZE/POS PATCH ////
	BOOL m_bUseRealSize;
	BOOL m_bUseRealPos;
	long m_lRealX;
	long m_lRealY;
	long m_lRealW;
	long m_lRealH;

	BOOL IsAtRealSize(void);
	BOOL IsAtRealPos(void);
	double GetRealUnitScale(int iCfgUnits, int iGraphicUnits);
	BOOL IsRealCloseEnough(double Value1, double dValue2);
	//// 1.0761 /////////////////////////////////////

	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	void CreateDrillFromDrillPageData(void);
	void GetDrillPageData(DrillPageData *DPD );
	
	void StretchSetHeight(long lH);
	long StretchGetHeight(void);
	void StretchSetLength(long lL);
	long StretchGetLength(void);
	void RotateSetAngle(long lA);
	void MoveSetPosition(long lX, long lY);

	void SetDrillPageFromData(void);

	void CreateDrillObject(UINT nDrillType, long lSize);
	void CreateStockDrillSpot(long lX, long lY);
	void CreateStockDrillSpot2(long lX, long lY);
	void CreateStockDrillLine(long lX1, long lY1, long lX2, long lY2);
	void CreateStockDrillCircle(long lX1, long lY1, long lX2, long lY2);
	void CreateStockDrillTrepan(long lX1, long lY1, long lRadius);
	void CreateStockDrillSpiral(long lX1, long lY1, long lRadius);
	void CreateStockDrillSpiral2(long lX1, long lY1, long lRadius);
	void CreateStockDrillMove(long lX1, long lY1, long lX2, long lY2);
	//// 1.0699 /////////////////////////////////////

	//// 1.0771 PAT 12.06.03 DRILL IN GUI PATCHES ////
	void StretchSetSize(CPos End);
	//// 1.0771 //////////////////////////////////////

	//// 1.0779 PAT 27.06.03 TEXT PLUS ////
	CString
		m_sTextPlus[CI_NUMTEXTLINES];
	//// 1.0779 ///////////////////////////

	//// 1.0781 PAT 30.06.03 IMPORT FLAGS ////
	DWORD
		m_dwVectorImporterFlags,
		m_dwVectorImporterFlagsSpecial;
	//// 1.0781 //////////////////////////////

	//// 1.0813 PAT 05.12.03 LIMIT PROMTING TO VARTEXT ////
	BOOL IsLocked(void);
	//// 1.0813 ///////////////////////////////////////////

	//// 1.0863 PAT 30.04.04 FILE VERSION UPDATES ////
	long
		m_lMarkFlags;
	//// 1.0863 //////////////////////////////////////

	//// 1.0891 PAT 14.06.04 FILL ONLY FOR ENGRAVING FONTS ////
	int GetFontType(void);
	BOOL IsFontLaserEngraving(void);
	BOOL IsFontTTF(void);
	BOOL IsFontBarcode(void);
	BOOL IsFontDotMatrix(void);
	//// 1.0891 ///////////////////////////////////////////////

	//// 1.0953 PAT 26.09.04 COM FUNCTIONS FOR FONT ////
	void SetFontTTF(CString sFont, BOOL bBold, BOOL bItalic, BOOL bUnder, BOOL bStrike, int iCharSet, int iKernMode, int iHKern, int iLKern);
	void GetFontTTF(CString &sFont, BOOL *pBold, BOOL *pItalic, BOOL *pUnder, BOOL *pStrike, int *pCharSet, int *pKernMode, int *pHKern, int *pLKern); 
	//// 1.0953 ////////////////////////////////////////

	//// 1.0961 PAT 24.11.04 SHRINK MODE CONT ////
	double m_dShrinkHeight;
	//// 1.0961 //////////////////////////////////

	//// 1.0993 PAT 28.02.05 DATE PROMPT FIX ////
	CString m_sPromptResponse;
	//// 1.0993 /////////////////////////////////


	/// 1.0550 DAN 4/29/05 DAN RTF ///
	bool	m_bFixedRTF;
	////1.0550////////////////////////

	//// 1.1117 PAT 27.02.06 SPOTS IN 2DCODE ////
	BOOL IsBarcode(void);
	BOOL Is2DBarcode(void);
	BOOL IsSpotBarcode(void);
	//// 1.1117 /////////////////////////////////

	//// 1.1127 PAT 14.04.06 DYN LIST VAR TEXT ////
	int m_iDynFileMode;
	int m_iDynFileLines;
	//// 1.1127 ///////////////////////////////////

	//// 1.1201 PAT 21.09.06 3 WAY LAYER & OBJECTS ////
	BOOL m_bNoUpdate;
	//// 1.1201 ///////////////////////////////////////

	//// 1.1243 PAT 31.10.06 NUM PASSES AS LIST MODIFIER ////
	void SetActivePassesFromFlags(CString sFlags);
	//// 1.1243 /////////////////////////////////////////////

	//// 1.1245 PAT 31.10.06 GEOMETRY LINKAGE ////
	BOOL m_bLinkGeometry;

	BOOL IsFillable(void);
	//// 1.1245 //////////////////////////////////

	//// 1.1265 PAT 14.11.06 ZEROED ITEM DELAYS ////
	void UpdateDispDelays(void);
	//// 1.1265 ////////////////////////////////////

	//// 1.1273 PAT 05.12.06 TEXT CHECKSUM ////
	int	m_iChecksum;
	
	CString AppendChecksum(void);
	//// 1.1273 ///////////////////////////////

	//// 1.1281 PAT 19.01.07 NO APPEND CHECKSUM MODE ////
	int m_iChecksumMode;

	CString GetChecksum(void);
	//// 1.1281 /////////////////////////////////////////

	//// 1.1291 PAT 09.02.07 RASTER - TPO BUG ////
	BOOL IsTPO(void);
	//// 1.1291 //////////////////////////////////

	//// PS080513A DYNAMIC LIST FOR RTF ////
	bool LoadRTFGroup(int iGroup);
	//// PS080513A /////////////////////////

	//// PS080521A LIST FILE RICH TEXT ////
	void SetRTFData(CString sData);
	//// PS080521A ////////////////////////

	//// PS080619A HEX SERIAL NUMBER ////
	int	m_iVarSerialIncMode;
	int m_iVarSerialIncModeCase;
	bool m_bVarSerialIncModeCarryThrough;
	//// PS080619A //////////////////////

	//// PS080806B NO SERIAL INC WHEN SKIPPED ////
	BOOL m_bVarSerialIncWhenSkipped;
	//// PS080806B ///////////////////////////////

	//// PS091029A SIMPLE TEXT RTF ////
	int m_iFixedTextMode;
	CRTFText m_FixedRTFText;
	long *GetFixedRTFTextVectors(void);
	//// PS091029A ////////////////////

	//// PS091201A TTF KERNING PAIRS RENDERING ////
	BOOL IsTrueTypeFont(void);
	//// PS091201A ////////////////////////////////
	
};


#endif












