// LM50_constants.h

// This file contains definitions of constants used
// in the CLM50 class
//
// Pat Summers
// American LaserWare, Inc.


//// REV L000 - 20000809 - IN THE BEGINNING... ////
// Converted from LM45...
//// REV L000 /////////////////////////////////////

#ifndef LM50_CONSTANTS
#define LM50_CONSTANTS

// QSwitch Modes
const BOOL LM50_QSMODE_CW					=	TRUE;
const BOOL LM50_QSMODE_PULSED				=	FALSE;

// Specs
const int	LM50_SPEC_PUMP_PRIMECOUNT_MAX	=	10;
const float LM50_SPEC_WATER_FLOW_MAX		=	35.0f;
const float LM50_SPEC_WATER_FLOW_MIN		=	25.0f;
const float LM50_SPEC_QSD_FREQ_MIN			=	1.0f;
const float LM50_SPEC_QSD_FREQ_MAX			=	50.0f;
const float LM50_SPEC_PS_LDCURRENT_MIN		=	5.0f;
const float LM50_SPEC_PS_LDCURRENT_MAX		=	30.0f;
const float LM50_SPEC_PS_LDCURRENT_THRESHOLD=	LM50_SPEC_PS_LDCURRENT_MIN * 0.8f;
	// This value is NOT the min current setting.
	// It is used as the limit to decide if a reported
	// ADC value for LD current indicates proper
	// power supply activation.
const float LM50_SPEC_PS_LDCURRENT_GUIDEON	=	LM50_SPEC_PS_LDCURRENT_MIN * 1.25f;
//// REV L007 - 20020922 - MAX CURRENT LIMIT ////
//	const float LM50_SPEC_PS_LDCURRENTMAX_MIN	=	25.0f;
const float LM50_SPEC_PS_LDCURRENTMAX_MIN	=	15.0f;
//// REV L007 ///////////////////////////////////
const float LM50_SPEC_PS_LDCURRENTMAX_MAX	=	27.0f;
const float LM50_SPEC_PS_LDCURRENT_SHORT	=	20.0f;
const float LM50_SPEC_PS_LDCURRENTLIMIT_RANGE	=	0.10f;	// max fractional deviation
															// from specified value
const float LM50_SPEC_PS_LDCURRENTLIMIT_DELAY	=	2.0f;	// seconds 
const int	LM50_SPEC_ADC_SAMPLES_MIN		=	1;
const int	LM50_SPEC_ADC_SAMPLES_MAX		=	256;
const int	LM50_SPEC_ADC_SAMPLES_DEFAULT	=	64;

const int	LM50_SPEC_COMP_ONDELAY			=	180;	// seconds
const int	LM50_SPEC_COMP_ABORTDELAY		=	5;		// seconds

//// REV L002 - 20020408 - POWER RAMPING ////
//// REV L008 - 20021015 - DEFAULT RAMPING ////
//	const BOOL	LM50_SPEC_PS_RAMPLDCURRENTFLAG	=	FALSE;
const BOOL	LM50_SPEC_PS_RAMPLDCURRENTFLAG	=	TRUE;
//// REV L008 /////////////////////////////////
const float LM50_SPEC_PS_RAMPLDCURRENTDELAY	=	2.0f;	// seconds
//// REV L002 ///////////////////////////////

//// REV L003 - 20020409 - SIMMER CURRENT ////
const int	LM50_SPEC_PS_SIMMERLDCURRENTDELAY=	15;		// minutes
//// REV L003 ////////////////////////////////

//// REV L004 - 20020513 - ADC SAMPLING CHANGE ////
const int	LM50_SPEC_ADC_OVERSAMPLES		=	5;
const int	LM50_SPEC_ADC_SAMPLES_LDCURRENT	=	10;
const int	LM50_SPEC_ADC_SAMPLES_WATERFLOW	=	10;
//// REV L004 /////////////////////////////////////

#endif	// LM50_CONSTANTS
