// RCT2 Constants
//
/////////////////////////////////////

// RTC2Constants.h

// This file contains definitions for the RTC2 board

#ifndef RTC2CONSTANTS
#define RTC2CONSTANTS

const UINT	RTC2_BASEADDRESS_DEFAULT		=	0x0240;

#define RTC2_DLLNAME_DEFAULT				_T("RTC24W95.DLL")
#define	RTC2_PROGNAME_DEFAULT				_T("RTC24W95.HEX")
#define	RTC2_CTBNAME_DEFAULT				_T("COR_1TO1.CTB")

#define RTC2_DLLNAME_DEFAULT_NT				_T("RTC24NT4.DLL")
#define	RTC2_PROGNAME_DEFAULT_NT			_T("RTC24NT4.HEX")

#define RTC2_DLLNAME_NOTLOADED				_T("NOT LOADED")

const UINT	RTC2_VERSION_DEFAULT			=	0;

const UINT	RTC2_LASERTYPE_CO2				=	0;
const UINT	RTC2_LASERTYPE_YAG				=	1;
//// 1.0281 PAT 03.02.00 RTC2 DETAILS DLG FIX ////
const UINT	RTC2_LASERTYPE_LEE				=	2;
//// 1.0281 //////////////////////////////////////
const UINT	RTC2_LASERTYPE_DEFAULT			=	RTC2_LASERTYPE_CO2;

//// 1.0281 PAT 03.02.00 RTC2 DETAILS DLG FIX ////
// Removed
//const BOOL	RTC2_LEELASER_DEFAULT			=	FALSE;
//// 1.0281 //////////////////////////////////////

const UINT	RTC2_ARCRES_MIN					=	1;
const UINT	RTC2_ARCRES_MAX					=	10000;
const UINT	RTC2_ARCRES_DEFAULT				=	100;

// MIN/MAX
const unsigned short	RTC2_STEPPERIOD_MIN		=	30;
const unsigned short	RTC2_STEPPERIOD_MAX		=	65535;

const unsigned short	RTC2_JUMPDEL_MIN		=	30;
const unsigned short	RTC2_JUMPDEL_MAX		=	20000;

const unsigned short	RTC2_MARKDEL_MIN		=	30;
const unsigned short	RTC2_MARKDEL_MAX		=	20000;

const unsigned short	RTC2_POLYDEL_MIN		=	30;
const unsigned short	RTC2_POLYDEL_MAX		=	20000;

const unsigned short	RTC2_LASEROFFDEL_MIN	=	30;
const unsigned short	RTC2_LASEROFFDEL_MAX	=	20000;

const unsigned short	RTC2_LASERONDEL_MIN		=	30;
const unsigned short	RTC2_LASERONDEL_MAX		=	20000;

const unsigned short	RTC2_LASERT1_YAG_MIN	=	2;
const unsigned short	RTC2_LASERT1_YAG_MAX	=	65535;

const unsigned short	RTC2_LASERT2_YAG_MIN	=	2;
const unsigned short	RTC2_LASERT2_YAG_MAX	=	65535;

const unsigned short	RTC2_LASERT3_YAG_MIN	=	2;
const unsigned short	RTC2_LASERT3_YAG_MAX	=	65535;

const unsigned short	RTC2_LASERT1_CO2_MIN	=	1;
const unsigned short	RTC2_LASERT1_CO2_MAX	=	65535;

const unsigned short	RTC2_LASERT2_CO2_MIN	=	1;
const unsigned short	RTC2_LASERT2_CO2_MAX	=	65535;

const unsigned short	RTC2_LASERT3_CO2_MIN	=	0;
const unsigned short	RTC2_LASERT3_CO2_MAX	=	65535;

const unsigned short	RTC2_PRESCALER_MIN		=	2;
const unsigned short	RTC2_PRESCALER_MAX		=	65535;

const unsigned short	RTC2_DAC_MAX			=	255;

//// 1.0561 PAT 20.06.01 RTC WOBBLE ADDITIONS ////
const unsigned short	RTC2_WOBBLE_AMP_OFF			=	0;
const unsigned short	RTC2_WOBBLE_AMP_MIN			=	1;
const unsigned short	RTC2_WOBBLE_AMP_MAX			=	2;

const double			RTC2_WOBBLE_FREQ_MIN		=	1.0;
const double			RTC2_WOBBLE_FREQ_MAX		=	6000.0;
//// 1.0561 //////////////////////////////////////

// On-the-fly
const UINT				RTC2_FLY_FIELDBITS		=	65535;
const double			RTC2_FLY_PULSESCALER	=	0.25;
const double			RTC2_FLY_PPI_DEFAULT	=	250.0;
#define					RTC2_FLY_PPI_UNITS_BASE		_T("lines / ")

//// 1.0391 PAT 05.07.00 MORE RTC2 FLY ////
const double			RTC2_FLY_CPI_DEFAULT	=	1000.0;
#define					RTC2_FLY_CPI_UNITS_BASE		_T("counts / ")
//// 1.0391 ///////////////////////////////


//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
const UINT				RTC2_DLLVER_95_2D_MIN	=	200;
const UINT				RTC2_DLLVER_95_2D_MAX	=	299;
const UINT				RTC2_DLLVER_NT_2D_MIN	=	300;
const UINT				RTC2_DLLVER_NT_2D_MAX	=	399;
const UINT				RTC2_DLLVER_95_3D_MIN	=	400;
const UINT				RTC2_DLLVER_95_3D_MAX	=	499;
const UINT				RTC2_DLLVER_NT_3D_MIN	=	600;
const UINT				RTC2_DLLVER_NT_3D_MAX	=	699;
//// 1.0433 ////////////////////////////////

//// 1.0499 PAT 19.02.00 RTC START/STOP ////
const unsigned short	RTC2_CONTROLMODE_DEFAULT	=	0x0000;
const unsigned short	RTC2_CONTROLMODE_NOEXTSTART	=	0x0000;
const unsigned short	RTC2_CONTROLMODE_EXTSTART	=	0x0001;
const unsigned short	RTC2_CONTROLMODE_NOEXTBUSY	=	0x0000;
const unsigned short	RTC2_CONTROLMODE_EXTBUSY	=	0x0002;


const unsigned short	RTC2_STATUS_MASK_LOAD1		=	0x0001;
const unsigned short	RTC2_STATUS_MASK_LOAD2		=	0x0002;
const unsigned short	RTC2_STATUS_MASK_READY1		=	0x0004;
const unsigned short	RTC2_STATUS_MASK_READY2		=	0x0008;
const unsigned short	RTC2_STATUS_MASK_BUSY1		=	0x0010;
const unsigned short	RTC2_STATUS_MASK_BUSY2		=	0x0020;
const unsigned short	RTC2_STATUS_MASK_EXTSTOP	=	0x0040;
const unsigned short	RTC2_STATUS_MASK_EXTSTART	=	0x0080;
const unsigned short	RTC2_STATUS_MASK_TEMPOK		=	0x4000;
const unsigned short	RTC2_STATUS_MASK_POWEROK	=	0x8000;
//// 1.0499 ////////////////////////////////

//// 1.0501 PAT 21.02.01 RTC DIO ////
const unsigned short	RTC2_DIO_IN_MASK			=	0xff00;
const int				RTC2_DIO_IN_SHIFT			=	8;
const unsigned short	RTC2_DIO_OUT_MASK			=	0xff00;
const int				RTC2_DIO_OUT_SHIFT			=	8;
//// 1.0501 /////////////////////////

//// 1.0919 PAT 08.08.04 PORT C DIO FIX ////
const unsigned short	RTC2_DIO_IN_MASK_PROLASE	=	0xff0f;
const unsigned short	RTC2_DIO_OUT_MASK_PROLASE	=	0xfff0;
//// 1.0919 ////////////////////////////////

#endif	//RTC2CONSTANTS
