// RTC2Driver.h 
//
// Header file for the CRTC2Driver class
//////////////////////////////////////////
/// 1.0270 DAN 12/20/99 SCANLAB RTC2 DRIVER ///


#ifdef _ALIUSE
	#include "WSData\RTC2Data.h"
#else
	#include "RTC2Data.h"
#endif

//// 1.0405 PAT 26.07.00 RTC2 GRAYSCALE ////
// Updated the following from the latest ScanLab software
//// 1.0405 ////////////////////////////////

//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
// Updated the following from the latest ScanLab software
//// 1.0433 ////////////////////////////////
typedef short          (__stdcall *LOAD_PRO)(char* hexfile);
typedef short          (__stdcall *LOAD_COR)(char* ctbfile);
typedef short          (__stdcall *LOAD_Z_TABLE)(double A, double B, double C);
typedef unsigned short (__stdcall *GET_VERSION)(void);
typedef unsigned short (__stdcall *GET_DLL_VERSION)(void);
typedef unsigned short (__stdcall *GET_RTC2_VERSION)(void);
typedef unsigned short (__stdcall *GET_RTC2_MODE)(void);
typedef unsigned short (__stdcall *READ_STATUS)(void);
typedef unsigned short (__stdcall *READ_BYTE)(void);
typedef unsigned short (__stdcall *GET_WAIT_STATUS)(void);
typedef long           (__stdcall *GET_COUNTS)(void);
typedef unsigned short (__stdcall *READ_IO)(void);
typedef short          (__stdcall *GET_Z_DISTANCE)(short x, short y, short z);
//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
// Modified due to conflict with RTC3 function names
//	typedef short          (__stdcall *AUTO_CAL)(unsigned short command);
typedef short          (__stdcall *RTC2_AUTO_CAL)(unsigned short command);
//// 1.0445 /////////////////////////////

typedef void           (__stdcall *DSP_START)(void);
typedef void           (__stdcall *SET_BASE)(unsigned short base);
typedef void           (__stdcall *SET_SPEED)(double jump_sp, double mark_sp);
typedef void           (__stdcall *ENABLE_LASER)(void);
typedef void           (__stdcall *DISABLE_LASER)(void);
typedef void           (__stdcall *SET_START_LIST_1)(void);
typedef void           (__stdcall *SET_START_LIST_2)(void);
typedef void           (__stdcall *SET_END_OF_LIST)(void);
typedef void           (__stdcall *EXECUTE_LIST_1)(void);
typedef void           (__stdcall *EXECUTE_LIST_2)(void);
typedef void           (__stdcall *STOP_EXECUTION)(void);
typedef void           (__stdcall *AUT_CHANGE)(void);
typedef void           (__stdcall *START_LOOP)(void);
typedef void           (__stdcall *QUIT_LOOP)(void);
typedef void           (__stdcall *SET_CONTROL_MODE)(unsigned short mode);
typedef void           (__stdcall *SET_MODE)(unsigned short mode);
typedef void           (__stdcall *SET_EXT1_MODE)(void);
//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
// Modified due to conflict with RTC3 function names
//	typedef void           (__stdcall *SET_EXT2_MODE)(void);
typedef void           (__stdcall *RTC2_SET_EXT2_MODE)(void);
//// 1.0445 /////////////////////////////
typedef void           (__stdcall *SET_YAG_PARAMETER)(unsigned short prescaler);
typedef void           (__stdcall *SET_GAIN)(double gain_x, double gain_y, short offset_x, short offset_y);
typedef void           (__stdcall *SET_CO2_STANDBY)(unsigned short half_period, unsigned short standby_pulse);
typedef void           (__stdcall *WRITE_DA)(unsigned short value);
typedef void           (__stdcall *WRITE_DAC0)(unsigned short value);
typedef void           (__stdcall *WRITE_DAC1)(unsigned short value);
typedef void           (__stdcall *WRITE_BYTE)(unsigned short value);
typedef void           (__stdcall *GOTO_XY)(short x, short y);
typedef void           (__stdcall *Z_OUT)(short value);
typedef void           (__stdcall *RELEASE_WAIT)(void);
typedef void           (__stdcall *GET_XY_POS)(short *x, short *y);
typedef void           (__stdcall *SET_XY_POS)(short xpos, short ypos);
typedef void           (__stdcall *SET_LIST_POINTER)(unsigned short list, unsigned short position);
typedef void           (__stdcall *EXECUTE_AT_POINTER)(unsigned short position);
typedef void           (__stdcall *SET_Z_OFFSET)(unsigned short zoffset);
typedef void           (__stdcall *SELECT_LIST)(unsigned short list);
typedef void           (__stdcall *SET_MAX_COUNTS)(long counts);
typedef void           (__stdcall *GET_ENCODER)(short *Zx, short *Zy);
typedef void           (__stdcall *WRITE_IO)(unsigned short value);
typedef void           (__stdcall *STOP_LIST)(void);
typedef void           (__stdcall *RESTART_LIST)(void);
typedef void           (__stdcall *GET_GALVO_POS)(unsigned short *x, unsigned short *y, unsigned short *z);
//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
// Modified due to conflict with RTC3 function names
//	typedef void           (__stdcall *SET_MATRIX)(double M00, double M01, double M10, double M11,
//	                                               short offset_x,short offset_y);
typedef void           (__stdcall *RTC2_SET_MATRIX)(double M00, double M01, double M10, double M11,
                                               short offset_x,short offset_y);
//// 1.0445 /////////////////////////////
typedef void           (__stdcall *SET_WOBBEL)(unsigned short amplitude, double frequency);

typedef void           (__stdcall *JUMP_ABS)(short x, short y);
typedef void           (__stdcall *MARK_ABS)(short x, short y);
typedef void           (__stdcall *POLA_ABS)(short x, short y);
typedef void           (__stdcall *POLB_ABS)(short x, short y);
typedef void           (__stdcall *POLC_ABS)(short x, short y);
typedef void           (__stdcall *FIELD_JUMP)(short x, short y);
typedef void           (__stdcall *HOME_JUMP)(short x, short y);
typedef void           (__stdcall *LASER_ON)(unsigned short delay);
typedef void           (__stdcall *SET_DELAYS)(unsigned short step_period,
                                               unsigned short jump_del,
                                               unsigned short mark_del,
                                               unsigned short poly_del,
                                               unsigned short laser_off_del,
                                               unsigned short laser_on_del,
                                               unsigned short t1,
                                               unsigned short t2,
                                               unsigned short t3);
typedef void           (__stdcall *SET_CO2_STANDBY_LIST)(unsigned short half_period,
                                                         unsigned short standby_pulse);
typedef void           (__stdcall *LONG_DELAY)(unsigned short delay);
typedef void           (__stdcall *WRITE_8BIT_PORT)(unsigned short value);
typedef void           (__stdcall *WRITE_16BIT_PORT)(unsigned short value);
typedef void           (__stdcall *WRITE_BYTE_LIST)(unsigned short value);
typedef void           (__stdcall *WRITE_DA_LIST)(unsigned short value);
typedef void           (__stdcall *WRITE_DAC0_LIST)(unsigned short value);
typedef void           (__stdcall *WRITE_DAC1_LIST)(unsigned short value);
typedef void           (__stdcall *Z_OUT_LIST)(short value);
typedef void           (__stdcall *SET_WAIT)(unsigned short wait_word);
typedef void           (__stdcall *LIST_NOP)(void);
typedef void           (__stdcall *SET_ENCODER_VALUES)(double Kx, double Ky, short Zx, short Zy);
typedef void           (__stdcall *WRITE_IO_LIST)(unsigned short value);
typedef void           (__stdcall *SET_LINE)(short dx, short dy, unsigned short N,
                                             unsigned short Period, unsigned short *Ptr);

//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
// These commands are repeats of existing commands
// but adding a z axis
//// 1.0433 ////////////////////////////////
typedef void           (__stdcall *GOTO_XYZ)(short x, short y, short z);
typedef void           (__stdcall *GET_XYZ_POS)(short *x, short *y, short *z);
typedef void           (__stdcall *SET_XYZ_POS)(short xpos, short ypos, short zpos);
typedef void           (__stdcall *Z_JUMP_ABS)(short x, short y, short z);
typedef void           (__stdcall *Z_MARK_ABS)(short x, short y, short z);
typedef void           (__stdcall *Z_POLA_ABS)(short x, short y, short z);
typedef void           (__stdcall *Z_POLB_ABS)(short x, short y, short z);
typedef void           (__stdcall *Z_POLC_ABS)(short x, short y, short z);
typedef void           (__stdcall *Z_FIELD_JUMP)(short x, short y, short z);
typedef void           (__stdcall *Z_HOME_JUMP)(short x, short y, short z);


//// 1.0391 PAT 05.07.00 MORE RTC2 FLY ////
// Changed m_dFlyPPI_X to m_dFlyCPI_X
//// 1.0391 ///////////////////////////////

// Class specific constants

class CRTC2Driver
{
public:
	FILE	*m_fpDebug;
// Attributes
public:
	HINSTANCE m_gLibRTC2;
	BOOL	m_bDLLPresent;
	BOOL	m_bBoardPresent;
	BOOL	m_bCorrTablePresent;
	BOOL	m_bHexPresent;

	BOOL	m_bRTC2Working;

	//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
	UINT
		m_nBaseAddress;
	CString
		m_sDLLFileName,
		m_sProgFileName,
		m_sCTBFileName;
	UINT
		m_nBoardVersion,
		m_nSoftwareVersion,
		m_nDLLVersion;
	UINT
		m_nLaserType;
	
	//// 1.0281 PAT 03.02.00 RTC2 DETAILS DLG FIX ////
	// Removed
	//BOOL
	//	m_bLeeLaser;
	//// 1.0281 //////////////////////////////////////
	
	UINT
		m_nArcRes;
	//// 1.0269 PAT 29.12.99 TEMP CONFIG FOR CONFIG PAGES ////
	BOOL
		m_bVariableAngleDelay;
	//// 1.0269 //////////////////////////////////////////////

	UINT
		m_nTicklePeriod,	// microseconds
		m_nTickleWidth;		// microseconds
	UINT
		m_nQSWidth,			// microseconds
		m_nFPSWidth;		// microseconds
	double
		m_dPowerFraction;
	UINT
		m_nPeriod;			// microseconds
	//// 1.0263 /////////////////////////////////


	//// 1.0375 PAT 01.06.00 RTC2 FLY ADD-ON ////
	//// 1.0475 PAT 22.11.00 RTC2 FLY Y AXIS ////
	//	BOOL
	//		m_bFlyEnable,
	//		m_bFlyResetEncoder;
	//	double
	//		m_dFlyCPI_X;
	//	double
	//		m_dFlyKX;
	BOOL
		m_bFlyEnableX,
		m_bFlyEnableY,
		m_bFlyResetEncoder;
	double
		m_dFlyCPI_X,
		m_dFlyCPI_Y;
	double
		m_dFlyKX,
		m_dFlyKY;
	//// 1.0475 /////////////////////////////////
	//// 1.0375 /////////////////////////////////

	//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
	BOOL
		m_bVarioEnabled;

	short
		m_siZ;
	double 
		m_dZOffset;

	BOOL
		m_bVarioZCal;
	double
		m_dVarioZCalA,
		m_dVarioZCalB,
		m_dVarioZCalC;
	//// 1.0433 ////////////////////////////////

	//// 1.0533 PAT 02.05.01 RTC I/O PATCH ////
	BOOL
		m_bUseRTCStart,
		m_bUseRTCIO;
	//// 1.0533 ///////////////////////////////


protected:
	CString
		m_sLoadedDLLFileName;

	unsigned short
		m_usJumpTC,
		m_usMarkTC,
		m_usPolyTC,
		m_usLaserOnTC,
		m_usLaserOffTC;

	BOOL
		m_bCO2LaserMode;

	double
		m_dJumpSpeed,
		m_dMarkSpeed;

	//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
	unsigned short
		m_usStepPeriod;
	
	unsigned short
		m_usLaserT1,
		m_usLaserT2,
		m_usLaserT3;

	unsigned short
		m_usPreScaler;
	//// 1.0263 /////////////////////////////////

	// List Control Flags
	BOOL	m_bPrevWasLine;
	UINT	m_nListSize;
	UINT	m_nListFlushLimit;
	UINT	m_nMaxListSize;
	BOOL	m_bUsingList1;


	UINT	m_nArcPolyLength;

	//// 1.0375 PAT 01.06.00 RTC2 FLY ADD-ON ////
	double
		m_dFieldSize;
	//// 1.0375 /////////////////////////////////

	//// 1.0479 PAT 16.01.01 RTC2 XFORM FIX ////
	BOOL
		m_bFieldSwapXY,
		m_bFieldNegateX,
		m_bFieldNegateY;
	//// 1.0479 ////////////////////////////////

	//// 1.0387 PAT 25.06.00 RTC2 CO2 DELAY REMOVAL ////
	UINT
		m_nPrevPeriod,
		m_nDelay;
	//// 1.0387 ////////////////////////////////////////


	//// 1.0405 PAT 26.07.00 RTC2 GRAYSCALE ////
	unsigned short
		m_usRasterPeriod;
	UINT
		m_nRasterListSize;
	//// 1.0405 ////////////////////////////////

	//// 1.0501 PAT 21.02.01 RTC DIO ////
	unsigned short
		m_usDigOut;	// Shadow for output port
	//// 1.0501 /////////////////////////

	//// 1.0561 PAT 20.06.01 RTC WOBBLE ADDITIONS ////
	double
		m_dWobbleAmp,
		m_dWobbleFreq;
	//// 1.0561 //////////////////////////////////////

// Operators
public:

	CRTC2Driver (void);
	~CRTC2Driver (void);

	void Init (void);

	BOOL LoadDLL (void);

	UINT InitCard(void);

	void CenterGalvos(void);

	void MoveGalvos (short *, short *, short *, short *, long *, short *);
	void MoveGalvosRaster(short *, short *, short *, short *, long *, short *, BYTE *);
	//// 1.0283 PAT 05.02.00 SPOT CODE ////
	void Spot(short *, short *, short *);
	//// 1.0283 ///////////////////////////

	void AddMove (short siX, short siY);
	void AddLine (short siX, short siY, short iNextCmdType);
	void AddArc(long *lVecInfo, short *siVecInfo);

	BOOL GetNextArcSegment(long *lVecInfo, short *siVecInfo, short *siX, short *siY, UINT m_nArcPolyLength);


	void OpenList (void);
	void FlushList (void);
	void SetMode (void);


	void WaitOnList(UINT nList = 0);

	void SetDelayValues(int iJumpTC, int iMarkTC, int iPolyTC, int iLaserOffTC, int iLaserOnTC);
	void SetSpeedValues(double dJump, double dMark);
	//// 1.0539 PAT 14.05.01 RTC2 MIN SPEED FIX ////
	void SetSpeed(int iPosRes, double dFieldSize, double dMarkSpeed);
	//// 1.0539 ////////////////////////////////////

	void Abort(void);

	//// 1.0279 PAT 02.02.00 RTC2 TICKLE FIX ////
	int IsBusy(void);
	//// 1.0279 /////////////////////////////////

	//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
	BOOL IsWorking(void);
	UINT GetBoardVersion(void);
	UINT GetSoftwareVersion(void);
	UINT GetDLLVersion(void);

	//// 1.0281 PAT 03.02.00 RTC2 DETAILS DLG FIX ////
	// Removed a parameter
	//// 1.0269 PAT 29.12.99 TEMP CONFIG FOR CONFIG PAGES ////
	// Add a parameter
	//void SetConfigValues(UINT nBaseAddress, CString sDLLName, CString sProgName, CString sCTBName, UINT nLaserType, BOOL bLeeLaser, UINT nArcRes);
	//void SetConfigValues(UINT nBaseAddress, CString sDLLName, CString sProgName, CString sCTBName, UINT nLaserType, BOOL bLeeLaser, UINT nArcRes, BOOL bVarAngleDelay);
	//void SetConfigValues(CRTC2Data *pData);
	//// 1.0269 //////////////////////////////////////////////
	void SetConfigValues(UINT nBaseAddress, CString sDLLName, CString sProgName, CString sCTBName, UINT nLaserType, UINT nArcRes, BOOL bVarAngleDelay);
	void SetConfigValues(CRTC2Data *pData);
	//// 1.0281 //////////////////////////////////////
	
	void SetConfigLaserValues(int iTicklePeriod, int iTickleWidth, int iQSWidth, int iFPSWidth);
	void SetPowerAndPeriod(double dFraction, int iPeriod);
	void SetLaserDelayValues(void);

	void SetPeriodCO2(UINT nPeriod);
	void SetPowerYAG(double dFraction);
	void SetPreScaler(unsigned short usPS);
	void TickleOn(void);
	void TickleOff(void);
	//// 1.0263 /////////////////////////////////

	//// 1.0387 PAT 25.06.00 RTC2 CO2 DELAY REMOVAL ////
	//	//// 1.0369 PAT 25.05.00 RTC2 PAUSE COMMAND ////
	//	UINT Pause(void);
	//	//// 1.0369 ////////////////////////////////////
	UINT Pause(int iDelay = -1);
	//// 1.0387 ////////////////////////////////////////

	//// 1.0371 PAT 30.05.00 RTC2 POWER CALIBRATE ////
	void LaserOn(double dOnTime = 1000.0);
	void LaserOff(void);
	//// 1.0371 //////////////////////////////////////

	//// 1.0375 PAT 01.06.00 RTC2 FLY ADD-ON ////
	/// 1.0475 PAT 22.11.00 RTC2 FLY Y AXIS ////
	//	void SetConfigFlyValues(BOOL bFlyEnable, double dFlyCPI_X);
	//	void SetFlyKX(double *pCPI = NULL);
	void SetConfigFlyValues(BOOL bFlyEnableX, double dFlyCPI_X, BOOL bFlyEnableY, double dFlyCPI_Y);
	void SetFlyKFactor(double *pCPI_X = NULL, double *pCPI_Y = NULL);
	//// 1.0475 /////////////////////////////////
	void SetFieldSize(double dSize);
	//// 1.0375 /////////////////////////////////
	
	//// 1.0387 PAT 25.06.00 RTC2 CO2 DELAY REMOVAL ////
	void InitCO2Period(void);
	//// 1.0387 ////////////////////////////////////////
	
	//// 1.0393 PAT 05.07.00 RTC2 FLY GET COUNTS ////
	//// 1.0475 PAT 22.11.00 RTC2 FLY Y AXIS ////
	//	BOOL GetFlyCounts(long *pCounts);
	BOOL GetFlyCounts(long *pCountsX, long *pCountsY);
	//// 1.0475 /////////////////////////////////
	//// 1.0393 /////////////////////////////////////


	//// 1.0379 PAT 07.06.00 GRAYSCALE ////
	void MoveGalvosRaster8(short *, short *, short *, short *, long *, short *, BYTE *, BYTE *);
	//// 1.0379 ///////////////////////////

	//// 1.0405 PAT 26.07.00 RTC2 GRAYSCALE ////
	void AddRasMove (short siX, short siY);
	void AddRasDot (short siDX, short siDY, short siSteps, unsigned short *pwData);
	unsigned short SetRasterSpeed(UINT nPeriod);
	UINT SetRasterListSize(UINT nPixels);
	//// 1.0405 ////////////////////////////////

	//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
	BOOL IsVarioEnabled(void);
	double GetZOffset(void);
	void SetZOffset(double dZOffset);
	//// 1.0433 ////////////////////////////////
	


	//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
	void GotoPos(short x, short y, short z = 0);
	void GetPos(short *x, short *y, short *z = NULL);
	void SetPos(short x, short y, short z = 0);
	void JumpAbs(short x, short y, short z = 0);
	void MarkAbs(short x, short y, short z = 0);
	void PolyAAbs(short x, short y, short z = 0);
	void PolyBAbs(short x, short y, short z = 0);
	void PolyCAbs(short x, short y, short z = 0);
	void FieldJump(short x, short y, short z = 0);
	void HomeJump(short x, short y, short z = 0);

	//// 1.0479 PAT 16.01.01 RTC2 XFORM FIX ////
	void TransformXYZ(short *psiX, short *psiY, short *psiZ);
	//// 1.0479 ////////////////////////////////

	// These added because it might not be present in
	// the selected DLL
	void SetLine(short dx, short dy, unsigned short N, unsigned short Period, unsigned short *Ptr);
	//// 1.0433 ////////////////////////////////

	
	//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
	BOOL IsDLL2D(void);
	BOOL IsDLL3D(void);
	BOOL IsDLLWin95(void);
	BOOL IsDLLWinNT(void);

	void SetConfigVarioValues(BOOL bZCal, double dA, double dB, double dC);

	//// 1.0433 ////////////////////////////////


	//// 1.0499 PAT 19.02.00 RTC START/STOP ////
	BOOL IsExtStartSignal(void);
	BOOL IsExtStopSignal(void);

	BOOL EnableExtStartSignal(BOOL bEnable);
	BOOL SetNullLists(void);
	BOOL ClearExtStopSignal(void);
	//// 1.0499 ////////////////////////////////
	
	//// 1.0501 PAT 21.02.01 RTC DIO ////
	BOOL ReadDigIns(BYTE *pIn);
	BOOL WriteDigOuts(BYTE byOut);
	BOOL GetDigOuts(BYTE *pOut);
	//// 1.0501 /////////////////////////

	//// 1.0533 PAT 02.05.01 RTC I/O PATCH ////
	void SetConfigIOValues(BOOL bUseStart, BOOL bUseIO);
	BOOL IsExtStartStopEnabled(void);
	BOOL IsIOExtensionEnabled(void);
	//// 1.0533 ///////////////////////////////

	//// 1.0561 PAT 20.06.01 RTC WOBBLE ADDITIONS ////
	void SetWobble(BOOL bOn);
	void SetWobbleValues(double dWidth, double dFreq);
	//// 1.0561 //////////////////////////////////////

	//// 1.0867 PAT 06.05.04 COM/DLL LASE/POS CONTROL ////
	void SetGalvoPosition(short sX, short sY);
	//// 1.0867 //////////////////////////////////////////


//// 1.0405 PAT 26.07.00 RTC2 GRAYSCALE ////
// Updated the following from the latest ScanLab software
//// 1.0405 ////////////////////////////////

//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
// Updated the following from the latest ScanLab software
//// 1.0433 ////////////////////////////////
	LOAD_PRO               load_pro;
	LOAD_COR               load_cor;
	LOAD_Z_TABLE           load_z_table;
	GET_VERSION            get_version;
	GET_DLL_VERSION        get_dll_version;
	GET_RTC2_VERSION       get_rtc2_version;
	GET_RTC2_MODE          get_rtc2_mode;
	READ_STATUS            read_status;
	READ_BYTE              read_byte;
	GET_WAIT_STATUS        get_wait_status;
	GET_COUNTS             get_counts;
	READ_IO                read_io;
	GET_Z_DISTANCE         get_z_distance;
	//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
	// Modified due to conflict with RTC3 function names
	//	AUTO_CAL               auto_cal;
	RTC2_AUTO_CAL               auto_cal;
	//// 1.0445 /////////////////////////////

	DSP_START              dsp_start;
	SET_BASE               set_base;
	SET_SPEED              set_speed;
	ENABLE_LASER           enable_laser;
	DISABLE_LASER          disable_laser;
	SET_START_LIST_1       set_start_list_1;
	SET_START_LIST_2       set_start_list_2;
	SET_END_OF_LIST        set_end_of_list;
	EXECUTE_LIST_1         execute_list_1;
	EXECUTE_LIST_2         execute_list_2;
	STOP_EXECUTION         stop_execution;
	AUT_CHANGE             aut_change;
	START_LOOP             start_loop;
	QUIT_LOOP              quit_loop;
	SET_CONTROL_MODE       set_control_mode;
	SET_MODE               set_mode;
	SET_EXT1_MODE          set_ext1_mode;
	//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
	// Modified due to conflict with RTC3 function names
	//	SET_EXT2_MODE          set_ext2_mode;
	RTC2_SET_EXT2_MODE          set_ext2_mode;
	//// 1.0445 /////////////////////////////
	SET_YAG_PARAMETER      set_yag_parameter;
	SET_GAIN               set_gain;
	SET_CO2_STANDBY        set_co2_standby;
	WRITE_DA               write_da;
	WRITE_DAC0             write_dac0;
	WRITE_DAC1             write_dac1;
	WRITE_BYTE             write_byte;
	GOTO_XY                goto_xy;
	Z_OUT                  z_out;
	RELEASE_WAIT           release_wait;
	GET_XY_POS             get_xy_pos;
	SET_XY_POS             set_xy_pos;
	SET_LIST_POINTER       set_list_pointer;
	EXECUTE_AT_POINTER     execute_at_pointer;
	SET_Z_OFFSET           set_z_offset;
	SELECT_LIST            select_list;
	SET_MAX_COUNTS         set_max_counts;
	GET_ENCODER            get_encoder;
	WRITE_IO               write_io;
	STOP_LIST              stop_list;
	RESTART_LIST           restart_list;
	GET_GALVO_POS          get_galvo_pos;
	//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
	// Modified due to conflict with RTC3 function names
	//	SET_MATRIX             set_matrix;
	RTC2_SET_MATRIX             set_matrix;
	//// 1.0445 /////////////////////////////
	SET_WOBBEL             set_wobbel;

	JUMP_ABS               jump_abs;
	MARK_ABS               mark_abs;
	POLA_ABS               pola_abs;
	POLB_ABS               polb_abs;
	POLC_ABS               polc_abs;
	FIELD_JUMP             field_jump;
	HOME_JUMP              home_jump;
	LASER_ON               laser_on;
	SET_DELAYS             set_delays;
	SET_CO2_STANDBY_LIST   set_co2_standby_list;
	LONG_DELAY             long_delay;
	WRITE_8BIT_PORT        write_8bit_port;
	WRITE_16BIT_PORT       write_16bit_port;
	WRITE_BYTE_LIST        write_byte_list;
	WRITE_DA_LIST          write_da_list;
	WRITE_DAC0_LIST        write_dac0_list;
	WRITE_DAC1_LIST        write_dac1_list;
	Z_OUT_LIST             z_out_list;
	SET_WAIT               set_wait;
	LIST_NOP               list_nop;
	SET_ENCODER_VALUES     set_encoder_values;
	WRITE_IO_LIST          write_io_list;
	SET_LINE               set_line;

//// 1.0433 PAT 12.09.00 RTC2 3D UPDATE ////
// These commands are repeats of existing commands
// but add z axis values
//// 1.0433 ////////////////////////////////
	GOTO_XYZ               goto_xyz;
	GET_XYZ_POS            get_xyz_pos;
	SET_XYZ_POS            set_xyz_pos;
	Z_JUMP_ABS             z_jump_abs;
	Z_MARK_ABS             z_mark_abs;
	Z_POLA_ABS             z_pola_abs;
	Z_POLB_ABS             z_polb_abs;
	Z_POLC_ABS             z_polc_abs;
	Z_FIELD_JUMP           z_field_jump;
	Z_HOME_JUMP            z_home_jump;

	
	//// 1.0919 PAT 08.08.04 PORT C DIO FIX ////
	BOOL ReadDigInsEx(unsigned short *pIn, BOOL bOverride);
	BOOL WriteDigOutsEx(unsigned short byOut, BOOL bOverride);
	BOOL GetDigOutsEx(unsigned short *pOut, BOOL bOverride);
	//// 1.0919 ////////////////////////////////

	//// PS080318A RTC Q WIDTH CONTROL ////
	UINT m_nQSWidthConfig;
	void SetLaserPeriodAndWidth(int nPeriod, int nWidth);
	//// PS080318A ////////////////////////

	//// PS090128A PREMOVE DELAY FOR DAC ////
	double	m_dPreJumpTC;	// microseconds
	void AddDelay(double dDelay);
	//// PS090128A //////////////////////////

protected:
};