// Header file for the CRTC3CTBXform class
//
// RTC3CTBXform.h

// This class is the data structure for holding data
// for transforming the Correction file data for an
// RTC3 board

//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
// Added this file
//// 1.0445 /////////////////////////////

#ifndef CRTC3CTBXFORM
#define CRTC3CTBXFORM

#include <afx.h>

#define RTC3CTBXFORM_2000_10_11			0

#define VER_RTC3CTBXFORM				RTC3CTBXFORM_2000_10_11

#ifdef _ALIUSE
	#include ".\RTC3Constants.h"
#else
	#include "RTC3Constants.h"
#endif

class CRTC3CTBXform : public CObject
{

	DECLARE_SERIAL( CRTC3CTBXform )

// Attributes
private:
	// Version info
	UINT
		m_nVersion;
public:
	double
		m_dGainX,
		m_dGainY,
		m_dOffsetX,
		m_dOffsetY,
		m_dRot;
		
// Implementations
public:
	CRTC3CTBXform(void);
	~CRTC3CTBXform(void);

	void Init(void);

    void Serialize( CArchive& ar );

// Operators
	void operator =( const CRTC3CTBXform& src );
	BOOL operator ==( const CRTC3CTBXform& src );
public:
};

#endif // CRTC3CTBXFORM

