// Header file for the CRTCSA4CTBXform class
//
// RTCSA4CTBXform.h

// This class is the data structure for holding data
// for transforming the Correction file data for an
// RTCSCANAlone4 board

//// 1.1037 PAT 25.07.05 SCANALONE ////
// Added this file
//// 1.1037 ///////////////////////////

#ifndef CRTCSA4CTBXFORM
#define CRTCSA4CTBXFORM

#include <afx.h>

#define RTCSA4CTBXFORM_2005_07_25			1

#define VER_RTCSA4CTBXFORM				RTCSA4CTBXFORM_2005_07_25

#ifdef _ALIUSE
	#include ".\RTCSA4Constants.h"
#else
	#include "RTCSA4Constants.h"
#endif

class CRTCSA4CTBXform : public CObject
{

	DECLARE_SERIAL( CRTCSA4CTBXform )

// Attributes
private:
	// Version info
	UINT
		m_nVersion;
public:
	double
		m_dGainX,
		m_dGainY,
		m_dOffsetX,
		m_dOffsetY,
		m_dRot;
		
// Implementations
public:
	CRTCSA4CTBXform(void);
	~CRTCSA4CTBXform(void);

	void Init(void);

    void Serialize( CArchive& ar );

// Operators
	void operator =( const CRTCSA4CTBXform& src );
	BOOL operator ==( const CRTCSA4CTBXform& src );
public:
};

#endif // CRTCSA4CTBXFORM

