// RTCSA4 Constants
//
/////////////////////////////////////

// RTCSA4Constants.h

// This file contains definitions for the RTCSA4 board

//// 1.1037 PAT 25.07.05 SCANALONE ////
// Addes this file
//// 1.1037 ///////////////////////////


#ifndef RTCSA4CONSTANTS
#define RTCSA4CONSTANTS

const long RTCSA4_USB_CONNECTED						=	0;


#define RTCSA4_DLLNAME_DEFAULT					_T("SCANalone4.DLL")
#define RTCSA4_DLLNAME_NOTLOADED				_T("NOT LOADED")

#define	RTCSA4_PROGNAME_DEFAULT					_T("RTC4D2.HEX")

#define	RTCSA4_CTBNAME_DEFAULT					_T("COR_1TO1.CTB")

const UINT				RTCSA4_CTB_NUM				=	2;
const UINT				RTCSA4_CTB_MIN				=	0;
const UINT				RTCSA4_CTB_MAX				=	1;

const double			RTCSA4_CTB_GAIN_MIN			=	0.8;
const double			RTCSA4_CTB_GAIN_MAX			=	1.2;
const int				RTCSA4_CTB_OFFSET_MIN		=	-30000;
const int				RTCSA4_CTB_OFFSET_MAX		=	30000;
const int				RTCSA4_CTB_ROT1_MIN			=	-10;
const int				RTCSA4_CTB_ROT1_MAX			=	10;
const int				RTCSA4_CTB_ROT90_MIN		=	0;
const int				RTCSA4_CTB_ROT90_MAX		=	3;

const int				RTCSA4_CTB_FILE_SIZE_3D		=	17000;

const unsigned short	RTCSA4_HARDWAREVER_MASK		=	0x00ff;

const unsigned short	RTCSA4_OPT_FLY				=	0x0100;
const unsigned short	RTCSA4_OPT_2HEADS			=	0x0200;
const unsigned short	RTCSA4_OPT_3D				=	0x0400;
const unsigned short	RTCSA4_OPT_IO				=	0x0800;

const UINT	RTCSA4_HEAD_A							=	0;
const UINT	RTCSA4_HEAD_B							=	1;
const UINT	RTCSA4_HEAD_NUM							=	2;
const UINT	RTCSA4_HEAD_MODE_OFF					=	0;	// Always off
const UINT	RTCSA4_HEAD_MODE_1_1					=	1;	// Always CTB 1
const UINT	RTCSA4_HEAD_MODE_2_2					=	2;	// Always CTB 2
const UINT	RTCSA4_HEAD_MODE_1_2					=	3;	// 1=Mark / 2=Setup
const UINT	RTCSA4_HEAD_MODE_2_1					=	4;	// 2=Mark / 1=Setup

const UINT	RTCSA4_CARD_MAX							=	1;
const UINT	RTCSA4_CARD_DEFAULT						=	1;

const UINT	RTCSA4_LIST_MAX							=	499990;
//const UINT	RTCSA4_LIST_FLUSHLIMIT					=	499000;
const UINT	RTCSA4_LIST_FLUSHLIMIT					=	10000;
const UINT	RTCSA4_LIST_START1						=	0;
const UINT	RTCSA4_LIST_START2						=	500000;

const UINT	RTCSA4_VERSION_DEFAULT					=	0;

const UINT	RTCSA4_LASERTYPE_CO2					=	0;
const UINT	RTCSA4_LASERTYPE_YAG1					=	1;
const UINT	RTCSA4_LASERTYPE_YAG2					=	2;
const UINT	RTCSA4_LASERTYPE_YAG3					=	3;
const UINT	RTCSA4_LASERTYPE_MODE4					=	4;
const UINT	RTCSA4_LASERTYPE_DEFAULT				=	RTCSA4_LASERTYPE_CO2;

const UINT	RTCSA4_ARCRES_MIN						=	1;
const UINT	RTCSA4_ARCRES_MAX						=	10000;
const UINT	RTCSA4_ARCRES_DEFAULT					=	100;

const unsigned short	RTCSA4_STATUS_NOTBUSY		=	0x0000;
const unsigned short	RTCSA4_STATUS_LOAD1			=	0x0001;
const unsigned short	RTCSA4_STATUS_LOAD2			=	0x0002;
const unsigned short	RTCSA4_STATUS_READY1		=	0x0004;
const unsigned short	RTCSA4_STATUS_READY2		=	0x0008;
const unsigned short	RTCSA4_STATUS_BUSY1			=	0x0010;
const unsigned short	RTCSA4_STATUS_BUSY2			=	0x0020;

const unsigned short	RTCSA4_CONTROLMODE_DEFAULT	=	0x0000;
	// Only bit 0 is used.  Bit 0 = 0 disables the
	// hardware START input signal.  If enabled,
	// RTC could start without ProLase knowing.
const unsigned short	RTCSA4_CONTROLMODE_NOEXTSTART	=	0x0000;
const unsigned short	RTCSA4_CONTROLMODE_EXTSTART	=	0x0001;


const unsigned short	RTCSA4_LISTMODE_NORMAL		=	0;
const unsigned short	RTCSA4_LISTMODE_RINGMODE	=	1;
const unsigned short	RTCSA4_LISTMODE_DEFAULT		=	RTCSA4_LISTMODE_NORMAL;

// MIN/MAX
const unsigned short	RTCSA4_JUMPDELAY_MIN		=	0;
const unsigned short	RTCSA4_JUMPDELAY_MAX		=	65500;
	// 1 bit = 10 us
const unsigned short	RTCSA4_MARKDELAY_MIN		=	0;
const unsigned short	RTCSA4_MARKDELAY_MAX		=	65500;
	// 1 bit = 10 us
const unsigned short	RTCSA4_POLYDELAY_MIN		=	0;
const unsigned short	RTCSA4_POLYDELAY_MAX		=	65500;
	// 1 bit = 10 us
const unsigned short	RTCSA4_POLYDELAYLIMIT_MIN	=	0;
const unsigned short	RTCSA4_POLYDELAYLIMIT_MAX	=	65499;
const unsigned short	RTCSA4_POLYDELAYLIMIT_OFF	=	65500;
	// 1 bit = 10 us

const unsigned short	RTCSA4_LASEROFFDELAY_MIN	=	2;
const unsigned short	RTCSA4_LASEROFFDELAY_MAX	=	8000;
	// 1 bit = 1 us
const short				RTCSA4_LASERONDELAY_MIN		=	-8000;
const unsigned short	RTCSA4_LASERONDELAY_MAX		=	8000;
	// 1 bit = 1 us

const double			RTCSA4_JUMPSPEED_MIN		=	1.0;
const double			RTCSA4_JUMPSPEED_MAX		=	50000.0;
const double			RTCSA4_JUMPSPEED_DEFAULT	=	10000.0;
	// in bits/ms
const double			RTCSA4_MARKSPEED_MIN		=	1.0;
const double			RTCSA4_MARKSPEED_MAX		=	50000.0;
const double			RTCSA4_MARKSPEED_DEFAULT	=	2500.0;
	// in bits/ms

const unsigned short	RTCSA4_STANDBY_HALFPER_MIN	=	0;
const unsigned short	RTCSA4_STANDBY_HALFPER_MAX	=	65500;
	// 1 bit = 1/8 us
const unsigned short	RTCSA4_STANDBY_WIDTH_MIN	=	0;
const unsigned short	RTCSA4_STANDBY_WIDTH_MAX	=	65500;
	// 1 bit = 1/8 us
const unsigned short	RTCSA4_FPS_WIDTH_MIN		=	0;
const unsigned short	RTCSA4_FPS_WIDTH_MAX		=	65500;
	// 1 bit = 1/8 us

const unsigned short	RTCSA4_TIMEBASE_1MHZ		=	0;
const unsigned short	RTCSA4_TIMEBASE_8MHZ		=	1;
	// 8 MHZ clock for any non-zero value
const unsigned short	RTCSA4_LASER_HALFPER_MIN	=	2;
const unsigned short	RTCSA4_LASER_HALFPER_MAX	=	65500;
	// 1 bit = 1 us or 1/8 us
const unsigned short	RTCSA4_LASER_WIDTH_MIN		=	2;
const unsigned short	RTCSA4_LASER_WIDTH_MAX		=	65500;
	// 1 bit = 1 us or 1/8 us

const double			RTCSA4_TIMERES_SCANNER_DELAY	=	0.1;
	// 1 bit = 10 us
const double			RTCSA4_TIMERES_LASER_DELAY	=	1.0;
const double			RTCSA4_TIMERES_1MHZ			=	1.0;
	// 1 bit = 1 us
const double			RTCSA4_TIMERES_FPS			=	8.0;
const double			RTCSA4_TIMERES_STANDBY_HALFPER=	8.0;
const double			RTCSA4_TIMERES_STANDBY_WIDTH	=	8.0;
const double			RTCSA4_TIMERES_8MHZ			=	8.0;
	// 1 bit = 1/8 us

const unsigned short	RTCSA4_WOBBLE_AMP_OFF		=	0;
const unsigned short	RTCSA4_WOBBLE_AMP_MIN		=	1;
const unsigned short	RTCSA4_WOBBLE_AMP_MAX		=	2;

const double			RTCSA4_WOBBLE_FREQ_MIN		=	1.0;
const double			RTCSA4_WOBBLE_FREQ_MAX		=	6000.0;

const unsigned short	RTCSA4_PIXEL_MODE_0			=	0;
const unsigned short	RTCSA4_PIXEL_MODE_1			=	1;
const unsigned short	RTCSA4_PIXEL_MODE_DEFAULT		=	RTCSA4_PIXEL_MODE_1;
const double			RTCSA4_PIXEL_PERIOD_FACTOR	=	0.1;
const unsigned short	RTCSA4_PIXEL_PW_MASK			=	0x00ff;
const unsigned short	RTCSA4_PIXEL_PW_FACTOR		=	8;
const unsigned short	RTCSA4_PIXEL_DAC_MASK			=	0xff00;
const unsigned short	RTCSA4_PIXEL_DAC_SHIFT		=	6;

const unsigned short	RTCSA4_PIXEL_ADC_NONE		=	0;
const unsigned short	RTCSA4_PIXEL_ADC_1			=	1;
const unsigned short	RTCSA4_PIXEL_ADC_2			=	2;
const unsigned short	RTCSA4_PIXEL_ADC_3			=	3;


const UINT				RTCSA4_FIELD_BITS			=	65535;
const UINT				RTCSA4_DAC_MAX				=	0x03ff;
const UINT				RTCSA4_DACPORTS_MIN			=	1;
const UINT				RTCSA4_DACPORTS_MAX			=	6;
const unsigned short	RTCSA4_DAC_CHANNEL_POWER	=	1;
//// PS090924A ANALOG FREQ CONTROL IN RTC ////
const unsigned short	RTCSA4_DAC_CHANNEL_FREQ		=	2;
//// PS090924 ////////////////////////////////
const unsigned short	RTCSA4_DAC_CHANNEL_RASTER	=	2;
const unsigned short	RTCSA4_DAC_CHANNEL_FOCUS	=	5;
const short				RTCSA4_Z_MAX				=	32767;

const UINT				RTCSA4_LASEREXT_MAX			=	0x00ff;

const unsigned short	RTCSA4_SCANNER_CABLE_MIN	=	10;
const unsigned short	RTCSA4_SCANNER_CABLE_MAX	=	75;

const unsigned short	RTCSA4_JUMPMIN_MAX			=	32500;
const unsigned short	RTCSA4_JUMPLIMIT_MAX		=	32500;

// Errors
// RTCSA4 functions return codes are positive,
// so we use negative values
const int				RTCSA4_ERR_NOERROR			=	0;
const int				RTCSA4_ERR_NOFUNCTION		=	-1;
const int				RTCSA4_ERR_BADINPUT			=	-2;


// Versions
const UINT				RTCSA4_VER_HARDWARE_DEFAULT	=	0;
const UINT				RTCSA4_VER_SOFTWARE_DEFAULT	=	0;
const UINT				RTCSA4_VER_DLL_DEFAULT		=	0;
const UINT				RTCSA4_VER_SERIAL_DEFAULT	=	0;

// On-the-fly
const double			RTCSA4_FLY_PPI_DEFAULT		=	250.0;
#define					RTCSA4_FLY_PPI_UNITS_BASE	_T("lines / ")
const double			RTCSA4_FLY_CPI_DEFAULT		=	1000.0;
#define					RTCSA4_FLY_CPI_UNITS_BASE	_T("counts / ")
const double			RTCSA4_FLY_K_DEFAULT		=	2.0;

const UINT				RTCSA4_FLY_AXIS_NUM			=	2;
const UINT				RTCSA4_FLY_AXIS_X			=	0;
const UINT				RTCSA4_FLY_AXIS_Y			=	1;

// 3D
const double			RTCSA4_3D_A_DEFAULT			=	0.0;
const double			RTCSA4_3D_B_DEFAULT			=	0.0;
const double			RTCSA4_3D_C_DEFAULT			=	0.0;
const double			RTCSA4_3D_ZOFFSET_DEFAULT	=	0.0;

const unsigned short	RTCSA4_STARTSTOP_MASK_INTSTART		=	0x0001;
const unsigned short	RTCSA4_STARTSTOP_MASK_EXTSTART		=	0x0002;
const unsigned short	RTCSA4_STARTSTOP_MASK_INTSTOP		=	0x0004;
const unsigned short	RTCSA4_STARTSTOP_MASK_EXTSTOP		=	0x0008;
const unsigned short	RTCSA4_STARTSTOP_MASK_EXTSTOPLEVEL	=	0x0010;
const unsigned short	RTCSA4_STARTSTOP_MASK_RESERVED		=	0x0100;
const unsigned short	RTCSA4_STARTSTOP_MASK_LASERENABLED	=	0x0200;
const unsigned short	RTCSA4_STARTSTOP_MASK_LASERACTIVELO	=	0x0400;
const unsigned short	RTCSA4_STARTSTOP_MASK_EXTSTARTLEVEL	=	0x1000;

const unsigned short	RTCSA4_DIO_IN_MASK				=	0xff00;
const int				RTCSA4_DIO_IN_SHIFT				=	8;
const unsigned short	RTCSA4_DIO_OUT_MASK				=	0xff00;
const int				RTCSA4_DIO_OUT_SHIFT			=	8;

const unsigned short	RTCSA4_LASEREXT_MASK			=	0x00ff;

const int				RTCSA4_DIOMODE_DDA				=	0;
const int				RTCSA4_DIOMODE_IOEXT			=	1;
const int				RTCSA4_DIOMODE_LASEREXT			=	2;

const int				RTCSA4_DIOMODE_DEFAULT			=	RTCSA4_DIOMODE_IOEXT;

const unsigned short	RTCSA4_DIO_IN_MASK_PROLASE		=	0xff0f;
const unsigned short	RTCSA4_DIO_OUT_MASK_PROLASE		=	0xfff0;

//// 1.1263 PAT 13.11.06 RTC FOCUS CONTROL ////
const unsigned short	RTCSA4_ANALOG_1_MODE_POWER		=	0;
const unsigned short	RTCSA4_ANALOG_1_MODE_FOCUS		=	1;
//// 1.1263 ///////////////////////////////////

const unsigned short	RTCSA4_VER_SOFT_3D_MIN			=	3000;

#endif	//RTCSA4CONSTANTS
