#pragma once

#ifdef _DLL
//	#include "DLL_CONST.h"
#else
	#include <afx.h>
#endif
 
// Include version info
#ifdef _ALIUSE
	#include "..\Versions\versions.h"
#else
	#include "versions.h"
#endif


class CRTFData : public CObject
{

	DECLARE_SERIAL( CRTFData )

// Operators
public:
	CRTFData();
	~CRTFData();

	void SetRTFFile(CString sPathName, CString sDefaultText);
	bool LoadRTFData(void);
	CString TextAsRTF(CString sText);

	void operator =( const CRTFData& src );
	BOOL operator ==( const CRTFData& src );

	long GetTotalX(void);
	long GetTotalY(void);

	long *GetVectors(void);
	long *GetFillVectors(void);

	long GetVectorSize(void);
	long GetFillVectorSize(void);

	void SetFillVectors(long *Vectors, long Size);

    void Serialize( CArchive& ar );

	//// PS080513A DYNAMIC LIST FOR RTF ////
	bool LoadRTFGroup(long lGroup);
	bool FindNextGroup(CFile *pFile, char *buf, long maxbuf);
	//// PS080513A /////////////////////////

	//// PS080521A LIST FILE RICH TEXT ////
	void SetRTFData(CString sData);
	//// PS080521A ////////////////////////

protected:
	void Init(void);
	void RenderRTF(void);
	void ClearVectorsAndFills(void);


// Attributes
protected:
	UINT	m_nVersion;

	CString	m_sRTFData;
	CString m_sRTFDataLast;

	long	*m_RTFVectors;
	long	*m_RTFFillVectors;

	long	m_SizeRTFVectors;
	long	m_SizeRTFFillVectors;


	bool	m_bRTFVectorsValid;

	long	m_XTotal;
	long	m_YTotal;

	CString	m_sRTFFileName;
	CString m_sRTFDefaultText;

	//// PS080513A DYNAMIC LIST FOR RTF ////
	long	m_lGroupIndex;
	long	m_lGroupStart;
	long	m_lGroupLength;
	//// PS080513A /////////////////////////

	//// PS080714A RICHTEXT CRASH - MISSING ALI_RENDERER ////
	void SubstituteVectors(void);
	//// PS080714A //////////////////////////////////////////


};