#pragma once

//// PS091029A SIMPLE TEXT RTF ////
//// PS091029A ////////////////////

#ifdef _DLL
//	#include "DLL_CONST.h"
#else
	#include <afx.h>
#endif
 
#include "FillData.h"

// Original Version
#define	RTFTEXT_2009_10_29			0

#define VER_RTFTEXT					RTFTEXT_2009_10_29


class CRTFText : public CObject
{

	DECLARE_SERIAL( CRTFText )

// Operators
public:
	CRTFText();
	~CRTFText();

	BOOL IsRTFString(CString sText);
	CString TextAsRTF(CString sText);
	void Init(void);

	void operator =( const CRTFText& src );
	BOOL operator ==( const CRTFText& src );
	BOOL operator !=( const CRTFText& src );

	long GetTotalX(void);
	long GetTotalY(void);

	long *GetVectors(void);
	long *GetFillVectors(void);

	long GetVectorSize(void);
	long GetFillVectorSize(void);

	void SetFillVectors(long *Vectors, long Size);

    void Serialize( CArchive& ar );

	CString GetRTFText(void);
	void SetRTFText(CString sData);
	void RenderRTF(void);

	void GetFillData(CFillData *pFillData);
	void SetFillData(CFillData& FillData);

protected:
	void ClearVectorsAndFills(void);
	void SubstituteVectors(void);


// Attributes
protected:
	UINT m_nVersion;

	CString	m_sRTFText;
	CString m_sRTFTextLast;
	CString m_sRTFTextDefault;

	long *m_RTFVectors;
	long *m_RTFFillVectors;

	long m_SizeRTFVectors;
	long m_SizeRTFFillVectors;

	bool m_bRTFVectorsValid;

	long m_XTotal;
	long m_YTotal;

	CFillData m_FillData;

};