// Header file for the CBarCodeParser class
//
// BarCodeParser.h

//// PS090913B BAR CODE SCAN 2 ////
//// PS090913B ////////////////////


#ifndef CBARCODEPARSER
#define CBARCODEPARSER

#include <afx.h>

#define BARCODEPARSER_2009_09_13			0
#define BARCODEPARSER_2010_02_28			20100228
#define VER_BARCODEPARSER					BARCODEPARSER_2010_02_28

#define BCP_FILENAME_DEFAULT				_T("default.bcp")

#define BCP_ENTERKEY_MODE_EDIT				0
#define BCP_ENTERKEY_MODE_AUTOACCEPT		1

//// PS20100228A BC PARSE TRIM CHARS ////
#define BCP_DOC_TRIM_CHARS_MIN				1
#define BCP_DOC_TRIM_CHARS_MAX				99
//// PS20100228A ////////////////////////

#define BCP_FILETOPIC_TITLE					_T("[BAR CODE PARSE SETTINGS FILE - VERSION]")
#define BCP_FILETOPIC_DATE					_T("[FILE DATE]")
#define BCP_FILETOPIC_ENTERKEYMODE			_T("[ENTER KEY MODE]")
#define BCP_FILETOPIC_DOC_PATH				_T("[DOCUMENT FILE FOLDER]")
#define BCP_FILETOPIC_DOC_PRE				_T("[DOCUMENT FILE PREFIX]")
#define BCP_FILETOPIC_DOC_POST				_T("[DOCUMENT FILE SUFFIX]")
#define BCP_FILETOPIC_DOC_TRIMWSLEAD		_T("[DOCUMENT FILE TRIM WS LEADING]")
#define BCP_FILETOPIC_DOC_TRIMWSTRAIL		_T("[DOCUMENT FILE TRIM WS TRAILING]")

//// PS20100228A BC PARSE TRIM CHARS ////
#define BCP_FILETOPIC_DOC_TRIMCHARSLEAD		_T("[DOCUMENT FILE TRIM CHARS LEADING]")
#define BCP_FILETOPIC_DOC_TRIMCHARSLEADNUM	_T("[DOCUMENT FILE TRIM CHARS LEADING NUMBER]")
#define BCP_FILETOPIC_DOC_TRIMCHARSTRAIL	_T("[DOCUMENT FILE TRIM CHARS TRAILING]")
#define BCP_FILETOPIC_DOC_TRIMCHARSTRAILNUM	_T("[DOCUMENT FILE TRIM CHARS TRAILING NUMBER]")
//// PS20100228A ////////////////////////

class CBarCodeParser : public CObject
{

// Attributes
protected:
	// Version info
	UINT m_nVersion;
	
	CString m_sDataFile;
	
	UINT m_nFileVersion;
	CTime m_tFileDate;
	
	UINT m_nEnterKeyMode;

	CString m_sDocFolder;
	CString m_sDocPrefix;
	CString m_sDocSuffix;
	BOOL m_bDocTrimWSLeading;
	BOOL m_bDocTrimWSTrailing;

	//// PS20100228A BC PARSE TRIM CHARS ////
	BOOL m_bDocTrimCharsLeading;
	int m_iDocTrimCharsLeadingNum;
	BOOL m_bDocTrimCharsTrailing;
	int m_iDocTrimCharsTrailingNum;
	//// PS20100228A ////////////////////////

	CString m_sSource;
	
	CString m_sElementDocName;
	CString m_sParsedDocName;
	
// Implementations
public:
	CBarCodeParser(void);
	~CBarCodeParser(void);

	void Init(void);

	int Open(CString sFileName);
	int Load(void);
	int SaveAs(CString sFileName);
	int Save(void);

protected:
	int LoadData(void);
	int SaveData(void);

	int LoadVersion0(CStdioFile *pFile);
	//// PS20100228A BC PARSE TRIM CHARS ////
	int LoadVersion2009_09_13(CStdioFile *pFile);
	int LoadVersion2010_02_28(CStdioFile *pFile);
	//// PS20100228A ////////////////////////
	
public:
// Operators
	void operator =( const CBarCodeParser& src );
	BOOL operator ==( const CBarCodeParser& src );

	void SetDataFile(CString sFile);

protected:
	int GetFileDate(CStdioFile *pFile);

public:
	// Get/Set variables
	UINT GetEnterKeyMode(void);
	void SetEnterKeyMode(UINT nMode);
	CString GetDocFolder(void);
	void SetDocFolder(CString sFolder);
	CString GetDocPrefix(void);
	void SetDocPrefix(CString sPrefix);
	CString GetDocSuffix(void);
	void SetDocSuffix(CString sSuffix);
	BOOL GetDocTrimWSLeading(void);
	void SetDocTrimWSLeading(BOOL bTrim);
	BOOL GetDocTrimWSTrailing(void);
	void SetDocTrimWSTrailing(BOOL bTrim);
	//// PS20100228A BC PARSE TRIM CHARS ////
	BOOL GetDocTrimCharsLeading(void);
	void SetDocTrimCharsLeading(BOOL bTrim);
	int GetDocTrimCharsLeadingNum(void);
	int SetDocTrimCharsLeadingNum(int iNum);
	BOOL GetDocTrimCharsTrailing(void);
	void SetDocTrimCharsTrailing(BOOL bTrim);
	int GetDocTrimCharsTrailingNum(void);
	int SetDocTrimCharsTrailingNum(int iNum);
	//// PS20100228A ////////////////////////

	// Parsing
	int ParseBarCodeString(CString sCode);
	CString GetParsedDocName(void);

	//// PS20100228A BC PARSE TRIM CHARS ////
	CString TrimCharsLeading(CString sText, int iNum);
	CString TrimCharsTrailing(CString sTextg, int iNum);
	//// PS20100228A ////////////////////////

};

#endif // CBARCODEPARSER


