// Header file containing definitions for the bar code
// descriptions and samples

// bcinfo.h

#ifndef BCINFO
#define BCINFO

#define BC_DESCRIPT_NOINFO				_T("No data is availible for the bar code.")
#define BC_SAMPLE_NOINFO				_T("*NO SAMPLE*")
#define BC_DESCRIPT_2of5				_T("2 of 5 is a non-continuous format.\nThe character set includes the digits '0' through '9'.\nNo size restrictions.")
#define BC_SAMPLE_2of5					_T("12345")
#define BC_DESCRIPT_INT2of5				_T("Interleaved 2 of 5 is a continuous format.\nThe character set includes the digits '0' through '9'.\nThe program will pad the data with a leading zero to make the number of digits even.\nA check character can be optionally added.")
#define BC_SAMPLE_INT2of5				_T("123456")
#define BC_DESCRIPT_CODE39				_T("Code 39 is a non-continuous format.\nThe character set includes '0'-'9', 'A'-'Z', space, '$', '/', '+', '-', '.' and '%'.\nThere are no size restrictions.\nA check character can be optionally added.")
#define BC_SAMPLE_CODE39				_T("A 12.34%")
#define BC_DESCRIPT_CODE93				_T("Code 93 is a continuous format.\nThe character set includes '0'-'9', 'A'-'Z', space, '$', '/', '+', '-', '.' and '%'.\nThere are no size restrictions.")
#define BC_SAMPLE_CODE93				_T("A 12.34%")
#define BC_DESCRIPT_CODABAR				_T("Codabar is a non-continuous format.\nThe character set includes '0'-'9','$', '-', ':', '/', '.','+' and four special purpose start/stop characters, 'A'-'D'.\nThere are no size restrictions.")
#define BC_SAMPLE_CODABAR				_T("12:34")
#define BC_DESCRIPT_EAN8				_T("EAN-8 is a fixed length format.\nThe character set includes '0'-'9'.\nEAN-8 has a length of eight (8).  Seven (7) digits are supplied as data.\nThe final check character is added automatically.\nOnly the first seven (7) characters are used as data.")
#define BC_SAMPLE_EAN8					_T("1234567")
#define BC_DESCRIPT_EAN8_2				_T("EAN-8+2 is a fixed length format.\nThe character set includes '0'-'9'.\nEAN-8+2 follows the same rules as EAN-8, but also has two (2) add on digits.\nSeven (7) digits are supplied as data.\nThe eighth (check) character is added automatically.\nThe two (2) add on digits are separated from the rest by a plus sign '+'.\nOnly the first seven (7) characters before the plus sign and\nthe first two (2) following it are used as data.")
#define BC_SAMPLE_EAN8_2				_T("1234567+12")
#define BC_DESCRIPT_EAN8_5				_T("EAN-8+5 is a fixed length format.\nThe character set includes '0'-'9'.\nEAN-8+5 follows the same rules as EAN-8, but also has five (5) add on digits.\nSeven (7) digits are supplied as data.\nThe eighth (check) character is added automatically.\nThe five (5) add on digits are separated from the rest by a plus sign '+'.\nOnly the first seven (7) characters before the plus sign and\nthe first five (5) following it are used as data.")
#define BC_SAMPLE_EAN8_5				_T("1234567+12345")
#define BC_DESCRIPT_EAN13				_T("EAN-13 is a fixed length format.\nThe character set includes '0'-'9'.\nEAN-13 has a length of thirteen (13).  Twelve (12) digits are supplied as data.\nThe final check character is added automatically.\nOnly the first twelve (12) characters are used as data.")
#define BC_SAMPLE_EAN13					_T("123456789012")
#define BC_DESCRIPT_EAN13_2				_T("EAN-13+2 is a fixed length format.\nThe character set includes '0'-'9'.\nEAN-13+2 follows the same rules as EAN-13, but also has two (2) add on digits.\nTwelve (12) digits are supplied as data.\nThe thirteenth (check) character is added automatically.\nThe two (2) add on digits are separated from the rest by a plus sign '+'.\nOnly the first twelve (12) characters before the plus sign and\nthe first two (2) following it are used as data.")
#define BC_SAMPLE_EAN13_2				_T("123456789012+12")
#define BC_DESCRIPT_EAN13_5				_T("EAN-13+5 is a fixed length format.\nThe character set includes '0'-'9'.\nEAN-13+5 follows the same rules as EAN-13, but also has five (5) add on digits.\nTwelve (12) digits are supplied as data.\nThe thirteenth (check) character is added automatically.\nThe five (5) add on digits are separated from the rest by a plus sign '+'.\nOnly the first twelve (12) characters before the plus sign and\nthe first five (5) following it are used as data.")
#define BC_SAMPLE_EAN13_5				_T("123456789012+12345")
#define BC_DESCRIPT_UPCA				_T("UPC-A is a fixed length format.\nThe character set includes '0'-'9'.\nUPC-A has a length of twelve (12).  Eleven (11) digits are supplied as data.\nThe final check character is added automatically.\nOnly the first eleven (11) characters are used as data.")
#define BC_SAMPLE_UPCA					_T("12345678901")
#define BC_DESCRIPT_UPCA_2				_T("UPC-A+2 is a fixed length format.\nThe character set includes '0'-'9'.\nUPC-A+2 follows the same rules as UPC-A, but also has two (2) add on digits.\nEleven (11) digits are supplied as data.\nThe twelfth (check) character is added automatically.\nThe two (2) add on digits are separated from the rest by a plus sign '+'.\nOnly the first eleven (11) characters before the plus sign and\nthe first two (2) following it are used as data.")
#define BC_SAMPLE_UPCA_2				_T("12345678901-12")
#define BC_DESCRIPT_UPCA_5				_T("UPC-A+2 is a fixed length format.\nThe character set includes '0'-'9'.\nUPC-A+5 follows the same rules as UPC-A, but also has five (5) add on digits.\nEleven (11) digits are supplied as data.\nThe twelfth (check) character is added automatically.\nThe five (5) add on digits are separated from the rest by a plus sign '+'.\nOnly the first eleven (11) characters before the plus sign and\nthe first five (5) following it are used as data.")
#define BC_SAMPLE_UPCA_5				_T("12345678901+12345")
#define BC_DESCRIPT_UPCE				_T("UPC-E is a fixed length format.\nThe character set includes '0'-'9'.\nUPC-E has a length of eight (8).  Seven (7) digits are supplied as data.\nThe final check character is added automatically.\nOnly the first seven (7) characters are used as data.")
#define BC_SAMPLE_UPCE					_T("1234567")
#define BC_DESCRIPT_UPCE_2				_T("UPC-E+2 is a fixed length format.\nThe character set includes '0'-'9'.\nUPC-E+2 follows the same rules as UPC-E, but also has two (2) add on digits.\nSeven (7) digits are supplied as data.\nThe eighth (check) character is added automatically.\nThe two (2) add on digits are separated from the rest by a plus sign '+'.\nOnly the first seven (7) characters before the plus sign and\nthe first two (2) following it are used as data.")
#define BC_SAMPLE_UPCE_2				_T("1234567+12")
#define BC_DESCRIPT_UPCE_5				_T("UPC-E+5 is a fixed length format.\nThe character set includes '0'-'9'.\nUPC-E+5 follows the same rules as UPC-E, but also has five (5) add on digits.\nSeven (7) digits are supplied as data.\nThe eighth (check) character is added automatically.\nThe five (5) add on digits are separated from the rest by a plus sign '+'.\nOnly the first seven (7) characters before the plus sign and\nthe first five (5) following it are used as data.")
#define BC_SAMPLE_UPCE_5				_T("1234567+12345")
#define BC_DESCRIPT_EAN128A				_T("EAN 128A is a continuous format.\nThe character set includes ASCII values 0 through 95.\nThere are no size restrictions.")
#define BC_SAMPLE_EAN128A				_T("ABC 123")
#define BC_DESCRIPT_EAN128B				_T("EAN 128B is a continuous format.\nThe character set includes ASCII values 32 through 127.\nThere are no size restrictions.")
#define BC_SAMPLE_EAN128B				_T("Abc 123")
#define BC_DESCRIPT_EAN128C				_T("EAN 128C is a continuous format.\nThe character set includes the digits '0'-'9'.\nThe data will be padded with a leading zero to make the number of digits even.")
#define BC_SAMPLE_EAN128C				_T("Abc 123")
#define BC_DESCRIPT_CODE128A			_T("Code 128A is a continuous format.\nThe character set includes ASCII values 0 through 95.\nThere are no size restrictions.")
#define BC_SAMPLE_CODE128A				_T("ABC 123")
#define BC_DESCRIPT_CODE128B			_T("Code 128B is a continuous format.\nThe character set includes ASCII values 32 through 127.\nThere are no size restrictions.")
#define BC_SAMPLE_CODE128B				_T("Abc 123")
#define BC_DESCRIPT_CODE128C			_T("Code 128C is a continuous format.\nThe character set includes the digits '0' through '9'.\nThe data will be padded with a leading zero to make the number of digits even.")
#define BC_SAMPLE_CODE128C				_T("123456")
#define BC_DESCRIPT_POSTNET				_T("POSTNET is a fixed length format.\nThe character set includes '0'-'9'.\nPOSTNET may be either the 5 or 9 digits Representing a U.S. zip code.\nA hyphen '-' may be added to separate the first five (5) digits from the last four (4)." )
#define BC_SAMPLE_POSTNET				_T("32792-4850")
#define BC_DESCRIPT_CODE128OPT			_T("Code 128 (optimized) is a continuous format.\nThe character set includes ASCII values 0 through 127.\nThis is a full implementation of Code 128 that switches between the subsets (Code 128 A, B and C) as needed to minimize the encoded length.")
#define BC_SAMPLE_CODE128OPT			_T("123456")
#define BC_DESCRIPT_IDMATRIX			_T("ID Matrix is two dimensional (2D) code format.\nThe character set includes all ASCII values\nThere are no size restrictions." )
#define BC_SAMPLE_IDMATRIX				_T("A1B2C3")
#endif
