// CConfig.h
//
// Header file for CConfig class
//////////////////////////////////
#ifndef CONFIG
#define CONFIG

#define	CLOCK_PER_SEC	1193180
#define GALVO_PER_SEC	73000
#define PIXELS			32767
//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
#define SYNRAD_PER_SEC	33000
//// 1.0253 ////////////////////////////////////

//// 1.0541 PAT 16.05.01 SOFT FPS ////
#define YAGMODE_0		0
	// YAG mod signal starts after FPS
#define	YAGMODE_1		1
	// YAG mod signal starts after delayed gate
//// 1.0541 //////////////////////////

//// 1.1181 PAT 25.08.06 RS232 VAR TEXT ////
#define RS232_TIMEOUT_MIN				1
#define RS232_TIMEOUT_MAX				9999

#define	RS232_SEPARATOR_CRLF			0
#define RS232_SEPARATOR_ANYNOPRINT		1
#define RS232_SEPARATOR_FIXEDNUMCHARS	2
#define RS232_SEPARATOR_1WHITESPACE		3

#define RS232_DATACHARS_MIN				1
#define RS232_DATACHARS_MAX				255

//// 1.1393 PAT 31.10.07 RS232 CTRL CHAR OPTIONS ////
#define RS232_CTRLCHAR_LEAVE			0
#define RS232_CTRLCHAR_REMOVE			1
#define RS232_CTRLCHAR_USESPACE			2
#define RS232_CTRLCHAR_USEA				3
//// 1.1397 PAT 03.12.07 RS232 CTRL CHAR +64 OPTION ////
#define RS232_CTRLCHAR_ADD64			4
//// 1.1397 ////////////////////////////////////////////

#define RS232_PURGE_OFF					FALSE
#define RS232_PURGE_ON					TRUE
//// 1.1393 /////////////////////////////////////////

#define RS232_PORT_DEFAULT				_T("COM1")
#define RS232_BAUDRATE_DEFAULT			CBR_9600
#define RS232_BYTESIZE_DEFAULT			8
#define RS232_STOPBITS_DEFAULT			ONESTOPBIT
#define RS232_PARITY_DEFAULT			NOPARITY
#define RS232_TIMEOUT_DEFAULT			5
#define RS232_SEPARATOR_DEFAULT			RS232_SEPARATOR_CRLF
#define RS232_DATACHARS_DEFAULT			RS232_DATACHARS_MIN
//// 1.1181 ////////////////////////////////
//// 1.1393 PAT 31.10.07 RS232 CTRL CHAR OPTIONS ////
#define RS232_CTRLCHAR_DEFAULT			RS232_CTRLCHAR_USESPACE
#define RS232_PURGE_DEFAULT				RS232_PURGE_OFF
//// 1.1393 /////////////////////////////////////////

//// 1.1307 PAT 01.03.07 COM APPLETS ////
#define COMAPP_COUNT_MAX			5

// Termination Delay (seconds)
#define COMAPP_TERMDELAY_MIN		0
#define COMAPP_TERMDELAY_MAX		30

// Applet ID Masks
#define	COMAPP_MASK_1				0x01
#define COMAPP_MASK_2				0x02
#define COMAPP_MASK_3				0x04
#define COMAPP_MASK_4				0x08
#define COMAPP_MASK_5				0x10

#define COMAPP_MASK_ALL				0x1f


//// 1.1405 PAT 11.12.07 POWER CAL TABLE TEXT FILE ////
#define EXTPOWCALTABLE_FILENAME_DEFAULT		_T("ExtPowCal.txt")
#define EXTPOWCALTABLE_FILE_IDSTRING		_T("PROLASE EXTERNAL POWER CALIBRATION TABLE")

// File versions
#define EXTPOWCALTABLE_VER_20071211			0
// Original version
#define EXTPOWCALTABLE_VER_ORIGINAL			EXTPOWCALTABLE_VER_20071211
// Current version
#define EXTPOWCALTABLE_VER					EXTPOWCALTABLE_VER_20071211
//// 1.1405 ///////////////////////////////////////////


#include ".\ComApp.h"
//// 1.1307 /////////////////////////////


#ifdef _ALIUSE
//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
	#include ".\Lens.h"
//// 1.0253 ////////////////////////////////////

	#include ".\caldata.h"

//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
// This stuff moved to ver_config.h
//	//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
//	#define CONFIG_1999_12_06		100
//	#define VER_CONFIG				CONFIG_1999_12_06
//	//// 1.0253 ////////////////////////////////////
	#include "..\Versions\Versions.h"
//// 1.0263 /////////////////////////////////

//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
	#include ".\RTC2Data.h"
//// 1.0263 /////////////////////////////////

	//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
	#include ".\RTC3Data.h"
	//// 1.0445 /////////////////////////////
	
	//// 1.0835 PAT 02.03.04 RTC4 ////
	#include ".\RTC4Data.h"
	//// 1.0835 //////////////////////
	
	//// 1.1037 PAT 25.07.05 SCANALONE ////
	#include ".\RTCSA4Data.h"
	//// 1.1037 ///////////////////////////

#else
	#include "Lens.h"
	#include "caldata.h"
	#include "Versions.h"
	#include "RTC2Data.h"
	//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
	#include "RTC3Data.h"
	//// 1.0445 /////////////////////////////

	//// 1.0835 PAT 02.03.04 RTC4 ////
	#include "RTC4Data.h"
	//// 1.0835 //////////////////////

	//// 1.1037 PAT 25.07.05 SCANALONE ////
	#include "RTCSA4Data.h"
	//// 1.1037 ///////////////////////////
#endif

//// JT080128A Adding Custom Pulse Width Table for RTC4 ////
#define PT_MAX_ENTRIES 1000
//// JT080128A /////////////////////////////////////////////
//// PS080718A PULSE TABLE ANALOG MODE ////
#define PT_MODE_OFF			0
#define PT_MODE_ANALOG		1
#define	PT_MODE_DIGITAL		2

#define PT_MODE_OFFSET		10
//// PS080718A ////////////////////////////

//// 1.1405 PAT 11.12.07 POWER CAL TABLE TEXT FILE ////
struct ExtPowCalTableData
{
	int m_iVersion;
#ifdef _UNICODE
	TCHAR m_sName[256];
#else
	char m_sName[256];
#endif	
	int m_iDateYear;
	int m_iDateMonth;
	int m_iDateDay;
	int m_iDateHour;
	int m_iDateMin;
	int m_iDateSec;
#ifdef _UNICODE
	TCHAR m_sNotice[256];
	TCHAR m_sWarning[256];

	TCHAR m_sDomainLabel[256];
	TCHAR m_sDomainUnits[256];
	TCHAR m_sDomainPrompt[256];
	
	TCHAR m_sRangeLabel[256];
	TCHAR m_sRangeUnits[256];
	TCHAR m_sRangePrompt[256];
#else
	char m_sNotice[256];
	char m_sWarning[256];

	char m_sDomainLabel[256];
	char m_sDomainUnits[256];
	char m_sDomainPrompt[256];
	
	char m_sRangeLabel[256];
	char m_sRangeUnits[256];
	char m_sRangePrompt[256];
#endif

	int m_iLimitEnabled;

	int m_iTableSize;

	double m_dDomainElements[100];
	
	double m_dRangeElements[100];



};

//// 1.1405 ///////////////////////////////////////////


//// PS080204B SPI LASER ////
// Laser Types
const int LASER_TYPE_CO2_YAG							=	0;
const int LASER_TYPE_FIBER								=	1;
const int LASER_TYPE_FIBER_WFSELECT						=	2;

const int LASER_TYPE_NOTYPE								=	-1;
const int LASER_TYPE_MIN								=	0;
const int LASER_TYPE_MAX								=	2;

// Waveform selection indecies

const int WAVEFORM_FIBER_WFSELECT_MIN				=	0;
const int WAVEFORM_FIBER_WFSELECT_MAX				=	255;
const int WAVEFORM_FIBER_WFSELECT_DEFAULT			=	WAVEFORM_FIBER_WFSELECT_MIN;
//// PS080204B //////////////

//// PS090424B PROGRAMMABLE FREQ BOUNDING ////
// Config copies of the same values as Marh.h's MARK_... constants
const unsigned short IPGLASER_FREQ_MIN				=	20;
const unsigned short IPGLASER_FREQ_MAX				=	80;
const unsigned short IPGLASER_PER_MIN				=	13;
const unsigned short IPGLASER_PER_MAX				=	50;

//	1 Hz or 1 microsecond resolution
const double FREQLIMIT_MAX							=	250.000;
const double FREQLIMIT_MIN							=	0.0;
const int FREQLIMIT_CWMODE_YES						=	0;
const int FREQLIMIT_CWMODE_NO						=	1;
const int FREQLIMIT_CWMODE_ONLY						=	2;
const double FREQLIMIT_PERIOD_MAX					=	1.0 * 1000.0 * 1000.0;
const double FREQLIMIT_PERIOD_MIN					=	1000.0 / FREQLIMIT_MAX;
//// PS090424B ///////////////////////////////

//// PS20100421A ALLOW INVERTED LASER ACTIVATE/RESET SIGNAL ////

const int LASER_ACTIVATE_ACTIVE_HI					=	0;
const int LASER_ACTIVATE_ACTIVE_LO					=	1;

const int LASER_ACTIVATE_MODE_A						=	0;
const int LASER_ACTIVATE_MODE_B						=	1;
//// PS20100421A ///////////////////////////////////////////////

#ifndef _PROLASEDLL
	#define DllExport
#else
	#define DllExport   __declspec( dllexport )
#endif // _PROLASEDLL


class DllExport CConfig : public CObject
{
// Attributes
public:

	/// Delays
	short	m_iResPos;

	float	m_fAngleTC,
			m_fDACTC,
			m_fDistanceTC,
			m_fEndSegTC,
			m_fPolyTC,
			m_fPosTC,
			m_fStartSegTC;

	short	m_iAngleTC,
			m_iDACTC,
			m_iDistanceTC,
			m_iEndSegTC,
			m_iPolyTC,
			m_iPosTC,
			m_iStartSegTC;

	// Field Parameters
	UINT	m_bDisCorr;
	UINT	m_bSwapXY;
	UINT	m_bNegateX;
	UINT	m_bNegateY;
	UINT	m_bSquareField;
	UINT	m_bCircleField;

	float	m_fXCorr,
			m_fYCorr;

	long	m_lFieldSize;

	/// 1.0320 DAN 8/1/00 PLOTTER MARKER DRIVER ADDITIONS ///
	long	m_lFieldSizeX,  // NOTE: Do not need to archive
			m_lFieldSizeY;	// NOTE: Do not need to archive
	////1.0320///////////////////////////////////////////////

	/// 1.0340 DAN 11/25/00 PLOTTER MARKER DRIVER ADDITIONS 2 ///
	CString	m_sPlotterName;
	////1.0340///////////////////////////////////////////////////

	// Driver
	int		m_iDriver;

	// Calibrate
	int		m_iQSwitchWidth,
			m_iTickleWidth,
			m_iTickleFreq,
			m_iFPSDelay;
			
	CString	m_sDistanceUnits;
	CString	m_sPowerFile,
			m_sFreqFile,
			m_sFocusFile;
	CCalData m_PowerCD,
			 m_FreqCD,
			 m_FocusCD;

	// FileName
	CString	m_sFileName;

	// Floats after Versioning
	float	m_fIdlePower;
	BOOL	m_bAutoIdlePower;
	BOOL	m_bAutoCenter;
	BOOL	m_bAutoRetry;

	// Temps to reserve space in file for additions
		// Reserve Temps
		// CStrings
		// *** ProLase + ***
		CString m_sAStepperID;
		CString m_sXStepperID;
		CString m_sYStepperID;
		CString m_sZStepperID;
		CString m_sMoveCmdCall;
		CString m_sInitCmdCall;
		CString m_sGetStatusCmd;
		CString m_sStatusValue;

	//	CString sTemp0;
	//	CString sTemp1;
	//	CString sTemp2;
	//	CString sTemp3;
	//	CString sTemp4;
	//	CString sTemp5;
	//	CString sTemp6;
	//	CString sTemp7;
		// *** ProLase + ***
	
		CString sTemp8;
		CString sTemp9;
		CString sTemp10;

		// Integers
		// *** ProLase + ***
		int m_iStepperDelay;
		int m_iAStepperRes;
		int m_iXStepperRes;
		int m_iYStepperRes;
		int m_iZStepperRes;

	//	int iTemp0;
	//	int iTemp1;
	//	int iTemp2;
	//	int iTemp3;
	//	int iTemp4;
		// *** ProLase + ***
		/*** 1.0147 PAT 17.02.99 BITMAP MARKING - GIDDYUP ***/
		// UINT iTemp5;	- removed for m_iSpeedupSteps
		int
			m_iSpeedUp;
		// int iTemp6; - removed for IdleState
		unsigned char m_uIdleState;
		unsigned char m_uIdleStateMask;
		unsigned char uTemp1;
		unsigned char uTemp2;
		/*** 1.0147 *****************************************/
	//	int iTemp7;
	//	int iTemp8;
		float m_fXScaleFac;
		float m_fYScaleFac;
		//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
		// Adding version data
		//int iTemp9;
		UINT m_nVersion;
		//// 1.0253 ////////////////////////////////////
	//	int iTemp10;
		float m_fIOTimeOut;

		// Binary
//		UINT bTemp0;  used for m_bSquareField
//		UINT bTemp1;  used for m_bCircleField

		// *** ProLase + *** //
		UINT m_bAStepperOn;
		UINT m_bXStepperOn;
		UINT m_bYStepperOn;
		UINT m_bZStepperOn;
		UINT m_bIndexerLPT;
		UINT m_bAbsolutePos;
		UINT m_bInternalPos;
		UINT m_bPCITimer;
		UINT m_bPCIDDA;
	//	UINT bTemp2;
	//	UINT bTemp3;
	//	UINT bTemp4;
	//	UINT bTemp5;
	//	UINT bTemp6;
	//	UINT bTemp7;
	//	UINT bTemp8;
		// *** ProLase + *** //

	//	UINT bTemp9;
	//	UINT bTemp10;

	
	/*** 1.0072 4.9.98 CONFIG / MAT / FIX IN TREE ***/
	BOOL m_bOpenInTree;
	/****1.0072**************************************/
	BOOL m_bVick;
	/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
	BOOL	m_bModified;
	/****1.0070*************************************/

	//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
	CLens
		m_Lens;
	//// 1.0253 ////////////////////////////////////

	//// 1.0263 PAT 22.12.99 RTC2 DRIVER DLG ////
	CRTC2Data
		m_RTC2Data;
	//// 1.0263 /////////////////////////////////

	//// 1.0437 PAT 26.09.00 SOFT STARTSEG ////
	BOOL
		m_bUseSoftStartSeg;
	//// 1.0437 ///////////////////////////////

	//// 1.0541 PAT 16.05.01 SOFT FPS ////
	UINT
		m_nYAGMode;
	//// 1.0541 //////////////////////////
	
	//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
	CRTC3Data
		m_RTC3Data;
	//// 1.0445 /////////////////////////////

	//// 1.0835 PAT 02.03.04 RTC4 ////
	CRTC4Data
		m_RTC4Data;
	//// 1.0835 //////////////////////

	//// 1.1037 PAT 25.07.05 SCANALONE ////
	CRTCSA4Data
		m_RTCSA4Data;
	//// 1.1037 ///////////////////////////
	
	//// 1.0497 PAT 15.02.01 ULS PLOTTER PATCH # 1 ////
	short
		m_siPageOrientation,
		m_siPagePaperSize,
		m_siPagePaperLength,
		m_siPagePaperWidth;
	//// 1.0497 ///////////////////////////////////////

	//// 1.0655 PAT 3.04.02 IDLE TIMEOUT ////
	double
		m_dIdleTimeout;
	//// 1.0655 /////////////////////////////

	//// 1.0655 PAT 3.04.02 IDLE TIMEOUT ////
	double
		m_dPowerRampTime;
	//// 1.0655 /////////////////////////////

	//// 1.0713 PAT 11.10.02 GS8 POWER ////
	BOOL
		m_bGS8PowerModulateOn;
	//// 1.0713 ///////////////////////////

// Operators
public:

	CConfig (void);
	~CConfig (void);

	void Init(void);
	/*** 1.0039 PAT 14.05.98 CALDATA INIT VALUES ***/
	void InitPowerCD(void);
	void InitFreqCD(void);
	void InitFocusCD(void);
	/***********************************************/

	void ConvertTC(void);

	// Load and Save routines
	void New(void);

	void Open(void);

	void Save(void);

	void SaveAs(void);

	void SaveData(void);
	//// 1.0873 PAT 18.05.04 CFG BACKUP PATCH ////
	void SaveData(CString sFileName);
	BOOL SaveDataEx(DWORD dwFlags = 0x00000000, CString sFileName = _T("\\*"));
	//// 1.0873 //////////////////////////////////
	UINT LoadData(CString sFileName = _T(""));

	/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
	void SetModified(void);
	/****1.0070*************************************/
	
	CString MakeAbsolute(CString);
	CString MakeRelative(CString);

	//// 1.0253 PAT 23.11.99 SYNRAD FLCC DRIVER ////
	void DoLensCorrection(void);
	//// 1.0253 ////////////////////////////////////


	// DLL
	UINT Load(LPCTSTR sFileNamePtr);

	//// 1.0267 PAT 28.12.99 CONFIG = & == OPERATORS ////
	void operator = (const CConfig& src);
	BOOL operator == (const CConfig& src);
	//// 1.0267 /////////////////////////////////////////

	//// 1.0441 PAT 29.09.00 DRIVER BITNESS ////
	UINT GetDriverBitness(void);
	UINT GetDriverPixels(void);
	long double GetGalvoStepsPerUnit(void);
	//// 1.0441 ////////////////////////////////

	
	/// 1.0350 DAN 1/4/01 DLL OBJECT ALLOCATION - DEALLOCATION ROUTINES //
public:
	static CConfig *NewConfig(void);
	static void DeleteConfig(CConfig *pConfig);
	////1.0350////////////////////////////////////////////////////////////

	//// 1.0497 PAT 15.02.01 ULS PLOTTER PATCH # 1 ////
	void GetPrinterPageData(short *psiOrientation, short *psiPaperSize, short *psiLength, short *psiWidth);
	void SetPrinterPageData(short siOrientation, short siPaperSize, short siLength, short siWidth);
	//// 1.0497 ///////////////////////////////////////

	//// 1.0863 PAT 30.04.04 FILE VERSION UPDATES ////
	long
		m_lMarkFlags;
	//// 1.0863 //////////////////////////////////////

	//// 1.0873 PAT 18.05.04 CFG BACKUP PATCH ////
	DWORD
		m_dwDriverFlags1,
		m_dwDriverFlags2;

	void SaveBackup(void);
	BOOL RestoreBackup(void);
	//// 1.0873 //////////////////////////////////

	//// 1.0877 PAT 04.06.04 IDLE POWER DELAY ////
	BOOL
		m_bAutoIdlePowerDelay;
	//// 1.0877 //////////////////////////////////

	//// 1.0879 PAT 07.06.04 CFG DUMP TO FILE ////
	CString
		m_sBackupFilePath;
	void TextOutline(void);
	BOOL CreateCfgTextDumpFile(CString sFileName);
	CString TextDumpFieldPage(void);
	CString TextDumpDelaysPage(void);
	CString TextDumpDriverPage(void);
	CString TextDumpCalPage(void);
	//// 1.1179 PAT 16.08.06 TEXT DUMP UPDATE ////
	CString TextDumpIocPage(void);
	//// 1.1179 //////////////////////////////////
	//// PS080625A UPDATE TO TEXTOUTLINE ////
	CString TextDumpProcessPage(void);
	//// PS080625A //////////////////////////
	CString TextDumpExtAxisPage(void);
	CString TextDumpDriverRTC2(void);
	CString TextDumpDriverRTC3(void);
	CString TextDumpDriverRTC4(void);
	//// 1.0879 //////////////////////////////////
	//// 1.1037 PAT 25.07.05 SCANALONE ////
	CString TextDumpDriverRTCSA4(void);
	//// 1.1037 ///////////////////////////

	//// 1.0903 PAT 25.06.04 VERSION DISPLAYS ////
	UINT m_nFileVersion;
	//// 1.0903 //////////////////////////////////

	//// 1.0917 PAT 03.08.04 LASER ENABLE SIGNAL ////
	BOOL m_bLaserEnableActive;
	BOOL IsLaserEnableActive(void);
	void SetLaserEnableActive(BOOL bOn);

	double m_dLaserEnableOnTime;
	double GetLaserEnableOnTime(void);
	void SetLaserEnableOnTime(double dSeconds);
	
	double m_dLaserEnableOffTime;
	double GetLaserEnableOffTime(void);
	void SetLaserEnableOffTime(double dSeconds);

	double m_dLaserEnableCycleDelay;
	double GetLaserEnableCycleDelay(void);
	void SetLaserEnableCycleDelay(double dSeconds);

	BOOL m_bLaserEnableInvert;
	BOOL IsLaserEnableInvert(void);
	void SetLaserEnableInvert(BOOL bOn);
	//// 1.0917 /////////////////////////////////////

	//// 1.0921 PAT 19.08.04 IPG LASER ////
	BOOL m_bIPGLaser;
	BOOL IsIPGLaserActive(void);
	void SetIPGLaserActive(BOOL bOn);
	//// 1.0921 ///////////////////////////

	//// 1.1035 PAT 20.07.05 DISABLE START INPUT ////
	BOOL m_bNoStartDigInputs;
	//// 1.1035 /////////////////////////////////////

	//// 1.1139 PAT 01.05.06 DISABLE <ENTER> START OVERRIDE ////
	BOOL m_bNoEnterOverride;
	//// 1.1139 ////////////////////////////////////////////////

	//// 1.1143 PAT 23.05.06 FIELD GUIDES ////
	BOOL	m_bFieldOptical;
	BOOL	m_bFieldFlipAB;
	BOOL	m_bFieldCustom;
	double 	m_dFieldCustomSize;
	//// 1.1143 //////////////////////////////

	//// 1.1173 PAT 08.08.06 USER CONTROL FOR BATCH COMPLETE AND ABORT ////
	unsigned char m_uAbortState;
	unsigned char m_uAbortStateMask;

	BOOL m_bIdleUCEnabled;
	CString m_sIdleUCFile;
	CString m_sIdleUCArgs;
	BOOL m_bIdleUCShow;
		
	BOOL m_bAbortUCEnabled;
	CString m_sAbortUCFile;
	CString m_sAbortUCArgs;
	BOOL m_bAbortUCShow;
	//// 1.1173 ///////////////////////////////////////////////////////////

	//// 1.1181 PAT 25.08.06 RS232 VAR TEXT ////
	BOOL m_bRS232Enabled;
	CString m_sRS232Port;
	int m_iRS232BaudRate;
	int m_iRS232ByteSize;
	int m_iRS232Parity;
	int m_iRS232StopBits;
	int m_iRS232Timeout;
	int m_iRS232DataSeparator;
	int m_iRS232DataChars;
	//// 1.1181 ////////////////////////////////

	//// 1.1219 PAT 09.10.06 LOST CAL DATA FIX ////
	BOOL UpdateCalData(UINT nArcVer);
	//// 1.1219 ///////////////////////////////////

	//// 1.1247 PAT 01.11.06 POWER CAL FREQ SETTING ////
	double m_dPowerCalibrationFreq;	// in Hertz (not kHz)!!!
	BOOL m_bPowerCalibrationFreqCW;
	//// 1.1247 ////////////////////////////////////////


	//// 1.1307 PAT 01.03.07 COM APPLETS ////
	int m_iComAppsCount;
	CComApp m_aComApps[COMAPP_COUNT_MAX];
	//// 1.1307 /////////////////////////////

	//// 1.1347 PAT 25.06.07 VICKERS CHANGES ////
	BOOL m_bVickLocalFix;
	BOOL m_bVickRemap;
	CString m_sVickRemapA;
	CString m_sVickRemapB;
	//// 1.1347 /////////////////////////////////

	//// 1.1369 PAT 21.08.07 LAYER MARK MODES REVISIT ////
	void TestStartSettings(void);
	BOOL GetStartDedicatedAllowed(void);
	BOOL GetStartDedicated(void);
	BOOL GetStartEnterKey(void);
	BOOL GetStartInputMask(void);

	void SetStartDedicated(BOOL bEnable);
	//// 1.1369 //////////////////////////////////////////

	//// 1.1383 PAT 04.10.07 PRE MOVE DELAY FOR RTC ////
	double m_dPreMoveDelay;
	//// 1.1383 ////////////////////////////////////////

	//// 1.1393 PAT 31.10.07 RS232 CTRL CHAR OPTIONS ////
	BOOL m_bRS232PurgeOnMark;
	int m_iRS232CtrlCharAction;
	//// 1.1393 /////////////////////////////////////////

	//// 1.1403 PAT 10.12.07 SCREEN REFRESH DURING MARK ////
	int m_iScreenRefreshMode;
	//// 1.1403 ////////////////////////////////////////////
	
	//// 1.1405 PAT 11.12.07 POWER CAL TABLE TEXT FILE ////
	BOOL m_bExternalPowerCalTableEnable;
	CString m_sExternalPowerCalTableFile;
	ExtPowCalTableData m_ExternalPowerCalTable;

	BOOL ImportExternalPowerCalTable(void);
	BOOL ExportExternalPowerCalTable(int iVersion);
	void UpdateExternalPowerCalTable(BOOL bToFile);
	//// 1.1405 ///////////////////////////////////////////

	//// JT080128A Adding Custom Pulse Width Table for RTC4 ////
	bool	m_bUsePulseTable;
	bool	m_bPTLeadingEdge;
	double	m_dPTRestartDelay;
	short	m_iSizePulseTable;
	double	m_dPulseTableValues[1000];
	short	m_iDefaultWaveform;
	//// JT080128A /////////////////////////////////////////////

	//// PS080204B SPI LASER ////
	int	m_iLaserType;
	//// PS080204B //////////////

	//// PS080228A RING MODE FIX ////
	BOOL m_bAltRingModeScheme;
	//// PS080228A //////////////////

	//// PS080303A RS232 DATA LOGGING ////
	BOOL m_bRS232LoggingEnabled;
	//// PS080303A ///////////////////////

	//// PS080718A PULSE TABLE ANALOG MODE ////
	int m_iPTMode;
	double m_dPTFinalAnalog;
	double m_dPTFinalDigital;
	//// PS080718A ////////////////////////////

	//// PS090126A DISABLE QUICKMARK ////
	BOOL m_bAutoMarkModeOnly;
	//// PS090126A //////////////////////

	//// PS090225A DIG POWER PORT TOGGLE ////
	BOOL m_bEnable9513OutPort;
	//// PS090225A //////////////////////////

	//// PS090424B PROGRAMMABLE FREQ BOUNDING ////
	double m_dFreqLimitMax;
	double m_dFreqLimitMin;
	int m_iFreqLimitCWMode;
	//// PS090424B ///////////////////////////////

	//// PS20100316B ISO8601 WEEK OF YEAR ////
	BOOL m_bDateCodeISO8601WeekEnabled;
	//// PS20100316B /////////////////////////

	//// PS20100421A ALLOW INVERTED LASER ACTIVATE/RESET SIGNAL ////
	BOOL m_bLaserActivateInvert;
	BOOL GetLaserActivateInvert(void);
	void SetLaserActivateInvert(BOOL bInvert);

	int m_iLaserActivateMode;
	int GetLaserActivateMode(void);
	int SetLaserActivateMode(int iMode);
	//// PS20100421A ///////////////////////////////////////////////

};

#endif