/// 1.0280 DAN 1/15/00 DRILL OBJECTS ///
//
// DrillData.h
//
// Header file for CDrillData class
////////////////////////////////////////////////////////
#include "afx.h"


//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
// Original verison
#define DRILLDATA_2003_06_01		1

//// PS20100201A UNICODE BUGS ////
#define DRILLDATA_2010_02_01		100
//// PS20100201A /////////////////

#define VER_DRILLDATA		DRILLDATA_2010_02_01
//#define VER_DRILLDATA		DRILLDATA_2003_06_01

#include "BBox.h"
//// 1.0699 /////////////////////////////////////


// Drill Types
#define CDRILL_SPOT		0
#define CDRILL_LINE		1
#define CDRILL_CIRCLE	2
#define CDRILL_TREPAN	3
#define CDRILL_SPIRAL	4
//// 1.0297 PAT 17.03.00 NEW SPIRAL2 DRILLDATA TYPE ////
#define CDRILL_SPIRAL2	5
//// 1.0297 ////////////////////////////////////////////
//// 1.0357 PAT 16.05.00 MOVE DRILL OBJECT ////
#define CDRILL_MOVE		6
//// 1.0357 ///////////////////////////////////
//// 1.0605 PAT 27.09.01 DRILL SPOT 2 ////
#define CDRILL_SPOT2	7
//// 1.0605 //////////////////////////////

//// 1.0625 PAT 07.01.02 DRILL RASTER ////
#define CDRILL_RASTER	8
//// 1.0625 //////////////////////////////

// Arc Types
#define CDRILL_BRA	0
#define CDRILL_BLA	1
#define CDRILL_TLA	2
#define CDRILL_TRA	3

// Vector Types // SHOULD NOT BE HERE
#define CDRILLVEC_MOVE		1
#define CDRILLVEC_LINE		2
#define CDRILLVEC_ARC		3
//// 1.0357 PAT 16.05.00 MOVE DRILL OBJECT ////
#define CDRILLVEC_VELMOVE	4
//// 1.0357 ///////////////////////////////////
#define CDRILLVEC_END		255

// Errors
#define CDRILL_NO_ERROR			0
#define CDRILL_ERROR_NOPASSES	1
#define CDRILL_ERROR_NOSIZE		2
#define CDRILL_ERROR_REV_DIA	3

// Constants
#define CDRILL_DEFAULT_VEL	10

//// 1.0509 PAT 27.02.01 TREPAN MODE ////
// Trepan modes
#define CDRILL_TREPANMODE_MIX		0
#define CDRILL_TREPANMODE_IN		1
#define CDRILL_TREPANMODE_OUT		2
//// 1.0509 /////////////////////////////

//// 1.0625 PAT 07.01.02 DRILL RASTER ////
struct DrillRasterData
{
	double
		dDeltaX,
		dDeltaY;
	BOOL
		bRowMajor;
	long
		lSizeX,
		lSizeY;
	BYTE
		*pData;
	int
		iPeriod,
		iPW,
		iMode;
	double
		dShiftX,
		dShiftY;
	int
		iOffsetX,
		iOffsetY;
	double
		dCfgSpeedJump,
		dCfgDelayJump;
};
//// 1.0625 //////////////////////////////

//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
struct DrillPageData
{
	int
		iType;
	double
		dX1,
		dY1;
	double
		dInnerRadius,
		dOuterRadius,
		dPitch;
	int
		iSpotPulses;
	double
		dSpotDuration;
	//// 1.0771 PAT 12.06.03 DRILL IN GUI PATCHES ////
	BOOL
		bSpotInputEnabled;
	BYTE
		bySpotInputBits,
		bySpotInputMask;
	//// 1.0771 //////////////////////////////////////
	BOOL
		bTrepanDefaultMode;
	int
		iTrepanMode;
	BOOL
		bSpiralOpen,
		bSpiralOut;

	//// 1.0795 PAT 19.09.03 DRILL SPOT PATCH ////
	BOOL
		bUseMaterialFile;
	double
		dVelocity;
	UINT
		nRepRate;
	//// 1.0795 //////////////////////////////////

};
//// 1.0699 /////////////////////////////////////


//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
//	class CDrillData
class CDrillData	:	public CObject
//// 1.0699 /////////////////////////////////////
{
// Attributes
public:
	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	UINT
		m_nVersion;
	//// 1.0699 /////////////////////////////////////
protected:
	UINT	m_nDrillType;

	long	m_lOuterRadius;
	long	m_lInnerRadius;

	long	m_lPitch;

	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	long	m_lVecListLongs;
	//// 1.0699 /////////////////////////////////////
	long	*m_pVecList;

	long	m_lDeltaX,
			m_lDeltaY;

	UINT	m_nNumberPasses;

	long double m_ldVel;
	long double m_ldFreq;

	//// 1.0285 PAT 07.02.00 DRILL OBJECTS GRENGINE CODE ////
	// These variables are set during creation and supply
	// the GREngine data
	// long *m_pVecList;  // declared above
	long
		m_lXAbs,		// Left most extent
		m_lYAbs;		// Bottom most extent
	long double
		m_ldRot,		// Rotation angle
		m_ldItal,		// Italic angle
		m_ldScale,		// Scale factor
		m_ldXComp;		// X compression
	_TUCHAR
		m_cChar;		// Character ordinal
	long
		m_lXCen,		// Center X
		m_lYCen;		// Center Y
	//// 1.0285 /////////////////////////////////////////////

	//// 1.0505 PAT 23.02.01 DRILL SPIRAL PATCH ////
	long
		m_lSpiralXStart,
		m_lSpiralYStart,
		m_lSpiralXEnd,
		m_lSpiralYEnd,
		m_lSpiralXPrevCen,
		m_lSpiralYPrevCen;
	UINT
		m_nArcType;
	BOOL
		m_bSpiralComplete,
		m_bRevSpiral;
	long
		m_lSpiralVecSize;
	long 
		m_lCurrRad;
	//// 1.0505 ////////////////////////////////////

	//// 1.0509 PAT 27.02.01 TREPAN MODE ////
	UINT
		m_nTrepanMode;
	//// 1.0509 /////////////////////////////

	//// 1.0605 PAT 27.09.01 DRILL SPOT 2 ////
	UINT
		m_nDuration;
	//// 1.0605 //////////////////////////////

	//// 1.0771 PAT 12.06.03 DRILL IN GUI PATCHES ////
	BOOL
		m_bSpotInputEnabled;
	BYTE
		m_bySpotInputBits,
		m_bySpotInputMask;
	//// 1.0771 //////////////////////////////////////

	//// 1.0625 PAT 07.01.02 DRILL RASTER ////
	DrillRasterData
		m_RasterData;
	//// 1.0625 //////////////////////////////

	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	DrillPageData
		m_DrillPage;

	BOOL
		m_bModified;
	//// 1.0699 /////////////////////////////////////


// Operators
public:
	CDrillData(void);
	~CDrillData(void);

	void Init(void);

	UINT CreateSpot(UINT nRepRate, UINT nPasses);
	//// 1.0605 PAT 27.09.01 DRILL SPOT 2 ////
	UINT CreateSpot2(UINT nDuration);
	//// 1.0605 //////////////////////////////
	UINT CreateLine(long lDeltaX, long lDeltaY, long lVel, UINT nRepRate, UINT nPasses);
	UINT CreateCircle(long lRadius, long lVel, UINT nRepRate, UINT nPasses);
	//// 1.0509 PAT 27.02.01 TREPAN VARIATIONS ////
	//	UINT CreateTrepan(long lDiameter, long lVel, UINT nRepRate, UINT nPasses);
	UINT CreateTrepan(long lDiameter, long lVel, UINT nRepRate, UINT nPasses, UINT nMode = CDRILL_TREPANMODE_MIX);
	//// 1.0509 ///////////////////////////////////
	//// 1.0505 PAT 23.02.01 DRILL SPIRAL PATCH ////
	//	UINT CreateSpiral(long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses);
	UINT CreateSpiral(long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses, BOOL bRev = FALSE);
	//// 1.0505 ////////////////////////////////////
	//// 1.0297 PAT 17.03.00 NEW SPIRAL2 DRILLDATA TYPE ////
	//// 1.0505 PAT 23.02.01 DRILL SPIRAL PATCH ////
	//	UINT CreateSpiral2(long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses);
	UINT CreateSpiral2(long lInnerDia, long lOuterDia, long lPitch, long lVel, UINT nRepRate, UINT nPasses, BOOL bRev = FALSE);
	//// 1.0505 ////////////////////////////////////
	//// 1.0297 ////////////////////////////////////////////
	//// 1.0357 PAT 16.05.00 MOVE DRILL OBJECT ////
	UINT CreateMove(long lDeltaX, long lDeltaY, long lVel, UINT nPasses);
	//// 1.0357 ///////////////////////////////////

	//// 1.0625 PAT 07.01.02 DRILL RASTER ////
	UINT CreateRaster(DrillRasterData *pRasterData);
	//// 1.0625 //////////////////////////////

	//// 1.0285 PAT 07.02.00 DRILL OBJECTS GRENGINE CODE ////
	UINT SetScalingData(long lXAbs, long lYAbs, long double ldRot, long double ldItal,
						long double ldScale, long double ldXComp,
						_TUCHAR cChar, long lXCen, long lYCen);
	void GetGrengineData(long **pVecList, long *pXAbs, long *pYAbs,
						 long double *pRot, long double *pItal,
						 long double *pScale, long double *pXComp,
						 _TUCHAR *pChar, long *pXCen, long *pYCen);
	//// 1.0285 /////////////////////////////////////////////


	long *GetVecList(void);
	UINT GetType(void);
	UINT GetPasses(void);
	long double GetVelocityLD(void);
	long double GetFrequencyLD(void);
	//// 1.0605 PAT 27.09.01 DRILL SPOT 2 ////
	UINT GetDuration(void);
	//// 1.0605 //////////////////////////////

protected:
	void BuildPattern (void);
	void ClearVecList(void);
	long AddLine(long lDeltaX, long lDeltaY, long lVecPos);
	long AddMove(long lDeltaX, long lDeltaY, long lVecPos);
	long AddArc(UINT nArc, long lRadius, long lVecPos);
	//// 1.0357 PAT 16.05.00 MOVE DRILL OBJECT ////
	long AddVelMove(long lDeltaX, long lDeltaY, long lVecPos);
	//// 1.0357 ///////////////////////////////////

	void SetFreqVel(UINT nRepRate, long lVel);

	//// 1.0365 PAT 19.05.00 DRILL DATA PATCH ////
	void BuildDefaultPattern(void);
	//// 1.0365 //////////////////////////////////

	//// 1.0493 PAT 24.01.01 DEFAULT OBJECT VALUES ////
public:
	void operator =( const CDrillData& src );
	// equivalence operator ==
	BOOL operator ==( const CDrillData& src );

	//// 1.0493 ///////////////////////////////////////

	//// 1.0505 PAT 23.02.01 DRILL SPIRAL PATCH ////
	double GetDistance(double dX0, double dY0, double dX1 = 0.0, double dY1 = 0.0);
	BOOL  GetIntersections(long double a, long double b, long double r, long double R,
						   long double *pX1, long double *pY1,
						   long double *pX2, long double *pY2);
	void ReverseSpiral(void);
	//// 1.0505 ////////////////////////////////////

	//// 1.0625 PAT 07.01.02 DRILL RASTER ////
	void GetRasterData(DrillRasterData *pRasterData);
	//// 1.0625 //////////////////////////////

	//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
	void SetType(UINT nType);
	UINT GetTrepanMode(void);
	void SetTrepanMode(UINT nMode);
	BOOL IsSpiralReversed(void);
	void SetSpiralReverse(BOOL bRev);
	BOOL IsSpiralClosed(void);
	void SetSpiralClosed(BOOL bClosed);
	double GetDeltaX(void);
	double GetDeltaY(void);
	void SetDeltaXY(double dX, double dY);
	double GetInnerRadius(void);
	void SetInnerRadius(double dRad);
	double GetOuterRadius(void);
	void SetOuterRadius(double dRad);
	double GetPitch(void);
	void SetPitch(double dPitch);

	void GetDrillPageData(DrillPageData *pData);
	void SetDrillPageData(DrillPageData *pData);


	void CreateFromDrillPageData(long X0, long Y0, double dAngle, double dAngleDelta, long lVel, UINT nRepRate, UINT nPasses);

	void GetBBoxInfo(CBBox *pBBox);

	void SetModified(void);
	void ClearModified(void);

	void SetDrillPageFromData(void);


	void Serialize( CArchive &ar);

	UINT GetRepRate(void);
	long GetVelocity(void);


	//// 1.0699 /////////////////////////////////////

	//// 1.0771 PAT 12.06.03 DRILL IN GUI PATCHES ////
	BOOL GetSpotInputEnabled(void);
	BYTE GetSpotInputBits(void);
	BYTE GetSpotInputMask(void);
	//// 1.0771 //////////////////////////////////////
	//// 1.0795 PAT 19.09.03 DRILL SPOT PATCH ////
	int GetSpotPulses(void);
	//// 1.0795 //////////////////////////////////

};