// Fixture.h
//
// Header file for the CFixture class
////////////////////////////////////////////
/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
/****1.0070*************************************/

#ifndef CFIXTURE
#define CFIXTURE

#ifdef _DLL
//	#include "DLL_CONST.h"
#else
	#include <afx.h>
#endif

#define CF_DEFAULT_FILE _T("DEFAULT.FX2")

#ifndef _PROLASEDLL
	#define DllExport
#else
	#define DllExport   __declspec( dllexport )
#endif // _PROLASEDLL

class DllExport CFixture
{
// Attributes
public:
	/*** 1.0106 1.4.99 TABLE STEP & REPEAT ***/
	// File version
	UINT	m_nVersion;
	/****1.0106*******************************/

	// File Data
	UINT	m_nArrayX,
			m_nArrayY;

	double	m_dDeltaX,
			m_dDeltaY;

	double	m_dOffsetX,
			m_dOffsetY;

	double	m_dFocus;

	double	m_dAngle;

	CString m_sFixtureName;

	// File Path name
	CString m_sPathName;


	// Mark Data
	long	m_lDeltaX,
			m_lDeltaY;
	long	m_lOffsetX,
			m_lOffsetY;

	long double m_ldOffsetAngle;

	long	m_lFixFocusAdjust;


	// Flag for state in tree
	BOOL	m_bOpenInTree;

	/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
	BOOL	m_bModified;
	/****1.0070*************************************/


	/*** 1.0106 1.4.99 TABLE STEP & REPEAT ***/
	// Table step and repeat data

	// File data
	UINT	m_nTableArrayX,
			m_nTableArrayY;

	double	m_dTableDeltaX,
			m_dTableDeltaY;

	double	m_dTableOffsetX,
			m_dTableOffsetY;

	// Mark data
	long	m_lTableDeltaX,
			m_lTableDeltaY;

	long	m_lTableOffsetX,
			m_lTableOffsetY;
	/****1.0106*******************************/

// Operators
public:
	CFixture(void);
	~CFixture(void);

	void Init(void);
	//// 1.0363 PAT 19.05.00 MATERIAL AND FIXTURE INIT ////
	void InitLoad(void);
	//// 1.0363 ///////////////////////////////////////////

	BOOL Load(CString sPathName);
	BOOL Save(CString sPathName = _T(""));

	void SetMarkValues(void);

	/*** 1.0070 2.9.98 FIXTURE MATERIAL MODELESS ***/
	void SetModified(void);
	/****1.0070*************************************/

	//// 1.0665 PAT 24.04.02 GROUP UNDO FIX ////
	void operator=( const CFixture& src );
	BOOL operator==( const CFixture& src);
	//// 1.0665 ////////////////////////////////

	//// 1.1409 PAT 02.01.08 MAT/FIX MISSING MSG ////
	BOOL CreateDefaultFile(CString sPathName);
	//// 1.1409 /////////////////////////////////////


};


#endif