// GBar.h
//
// Header file for the CGBar class
///////////////////////////////////////////////
#ifndef CGBAR
#define CGBAR

#include <afx.h>
#include <afxwin.h>

#ifdef _ALIUSE
	#include "..\GLibrary\GLibrary.h"
	#include "..\WSData\BarCode.h"
#else
	#include "GLibrary.h"
	#include "Barcode.h"
#endif

class CGBar : public CObject
{

// Attributes
public:

	// Fill information
	CString
		m_sName;
	BOOL
		m_bRev;
	long
		m_lBeamWidth,
		m_lBeamSpacing,
		m_lBarHeight,
		m_alBarWidth[BC_SIZES_MAX],
		m_alSpaceWidth[BC_SIZES_MAX],
		m_lLeftQZWidth,
		m_lRightQZWidth,
		m_lMiddleQZWidth,
		m_lICSpaceWidth,
		m_lBorderQZWidth;
	long
		m_lItemHeight,
		m_lItemLength;
	long double
		m_ldItemXComp;
	BOOL
		m_bTooDense;
	int
		m_iBarType;
	long
		m_lBarWidth;

	int
		m_iClass;
	BOOL
		m_bUse2D;
	
	// Fill character
	_TUCHAR
		m_cChar;
	
	// Pointer to the fill cyclopedia
	CCyclopedia	*m_pFills;

// Operators
public:
	// Contructor / Destructor
	CGBar(void);
	~CGBar(void);
	void Init(void);	// Initiallize
	
	CGSymbol * FillChar(int, long, long *, long *, long, long, long,
						long, long, BOOL, long, long double, long, long,
						_TUCHAR);
	int GetFillSize(void);
	int GetBarType(void);
	long GetBarWidth(void);
	BOOL Fill(long *);

	CGSymbol * FillChar2D(void);
	int GetFillSize2D(void);
	int GetBarType2D(void);
	long GetBarWidth2D(void);
	BOOL Fill2D(long *);
};

#endif //CGBar