// GlobalData.h
//
// Header file for CGlobalData class
/////////////////////////////////////////
/*** 1.0058 27.8.98 WSDATA ABS/REL FIX ***/
/*****************************************/
/*** 1.0060 31.8.98 GLOBAL DATA UNITS ADD ***/
/********************************************/


#ifndef CGLOBALDATA
#define CGLOBALDATA

#include <afx.h>
#include <afxwin.h>
#include <time.h>


//// 1.0429 PAT 06.09.00 QUEUE RECOVERY FILE ////
#define GD_TEMPDIRNAME		_T("TEMP")
//// 1.0429 /////////////////////////////////////

// Units defines
////////////////////////
#define	GD_INCHES_TEXT		_T("in.")
#define GD_FEET_TEXT		_T("ft.")
#define GD_CENTIMETERS_TEXT	_T("cm")
#define GD_METERS_TEXT		_T("m")

#define GD_INCHES		0
#define GD_FEET			1
#define GD_CENTIMETERS	2
#define GD_METERS		3


/*** 1.0203 PAT 01.07.99 RUN NEW PROCESS ***/
// Run new process
const int	RNP_WAIT_NOWAIT					=	0;
const int	RNP_WAIT_TIME					=	1;
const int	RNP_WAIT_COMPLETE				=	2;
const int	RNP_SHOW_HIDE					=	0;
const int	RNP_SHOW_SHOW					=	1;
/*** 1.0203 ********************************/
//// 1.1307 PAT 01.03.07 COM APPLETS ////
const int	RNP_SHOW_MIN					=	2;
const int	RNP_SHOW_MAX					=	3;
//// 1.1307 /////////////////////////////

//// 1.1129 PAT 18.04.06 USER CONTROL ABORT ////
const DWORD	RNP_EXITCODE_INVALID			=	0xFFFFFDED;
const DWORD RNP_EXITCODE_ABORTMARK			=	0x0000DEAD;
//// 1.1129 ////////////////////////////////////

//// 1.1155 PAT 13.06.06 USER CONTROL ABORT FILE ////
//	#define RNP_ABORTMARKFILE_NAME				"UCAbort.txt";
#define RNP_ABORTMARKFILE_NAME				_T("UCAbort.txt")
#define RNP_ABORTMARKFILE_TEXTFLAG			_T("USER CONTROL ABORT")
//// 1.1155 /////////////////////////////////////////


//// 1.0751 PAT 20.03.03 IMPORT PATCH CONT ////
const DWORD GD_FILETYPE_GRAPHIC_NATIVE				=	0x00000001;
const DWORD GD_FILETYPE_GRAPHIC_ALIIMP				=	0x00000002;
const DWORD GD_FILETYPE_GRAPHIC_IMAGESTREAM			=	0x00000004;
const DWORD GD_FILETYPE_GRAPHIC_KANDU				=	0x00000008;
const DWORD GD_FILETYPE_GRAPHIC_TEMP				=	0x00000010;
const DWORD GD_FILETYPE_GRAPHIC_OPT					=	0x00000020;
const DWORD GD_FILETYPE_GRAPHIC_RASTER				=	0x00000040;

const DWORD GD_FILETYPE_FONT_NATIVE					=	0x00000001;
const DWORD GD_FILETYPE_FONT_ALIIMP					=	0x00000002;
const DWORD GD_FILETYPE_FONT_TTF					=	0x00000004;
const DWORD GD_FILETYPE_FONT_TEMP					=	0x00000008;
const DWORD GD_FILETYPE_FONT_BARCODE				=	0x00000010;
const DWORD GD_FILETYPE_FONT_DOTMATRIX				=	0x00000020;
const DWORD GD_FILETYPE_FONT_TTFSTRING				=	0x00000040;
//// 1.0751 ///////////////////////////////////

//// 1.1397 PAT 03.12.07 RS232 CTRL CHAR +64 OPTION ////
const short ASCII_NULL		=	0x00;	// 0	null
const short ASCII_SOH		=	0x01;	// 1	start of heading
const short ASCII_STX		=	0x02;	// 2	start of text
const short ASCII_ETX		=	0x03;	// 3	end of text
const short ASCII_EOT		=	0x04;	// 4	end of tranmission
const short ASCII_ENQ		=	0x05;	// 5	enquiry
const short ASCII_ACK		=	0x06;	// 6	acknowledge
const short ASCII_BEL		=	0x07;	// 7	bell
const short ASCII_BS		=	0x08;	// 8	backspace
const short ASCII_HT		=	0x09;	// 9	horizontal tab
const short ASCII_LF		=	0x0a;	// 10	line feed
const short ASCII_VT		=	0x0b;	// 11	vertical tab
const short ASCII_FF		=	0x0c;	// 12	form feed
const short ASCII_CR		=	0x0d;	// 13	carriage return
const short ASCII_SO		=	0x0e;	// 14	shift out
const short ASCII_SI		=	0x0f;	// 15	shift in
const short ASCII_DLE		=	0x10;	// 16	data link escape
const short ASCII_DC1		=	0x11;	// 17	device control 1 (xon)
const short ASCII_DC2		=	0x12;	// 18	device control 2
const short ASCII_DC3		=	0x13;	// 19	device control 3 (xff)
const short ASCII_DC4		=	0x14;	// 20	device control 4
const short ASCII_NAK		=	0x15;	// 21	negative acknowledge
const short ASCII_SYN		=	0x16;	// 22	synchronous idle
const short ASCII_ETB		=	0x17;	// 23	end of transmission block
const short ASCII_CAN		=	0x18;	// 24	cancel
const short ASCII_EM		=	0x19;	// 25	end of medium
const short ASCII_SUB		=	0x1a;	// 26	substitute
const short ASCII_ESC		=	0x1b;	// 27	escape
const short ASCII_FS		=	0x1c;	// 28	file separator
const short ASCII_GS		=	0x1d;	// 29	group separator
const short ASCII_RS		=	0x1e;	// 30	record separator
const short ASCII_US		=	0x1f;	// 31	unit separator

const short ASCII_SPACE		=	0x20;	// 32	space
const short ASCII_0			=	0x30;	// 48	zero
const short ASCII_9			=	0x39;	// 57	nine
const short ASCII_A			=	0x41;	// 65	cap A
const short ASCII_Z			=	0x5A;	// 90	cap Z
const short ASCII_a			=	0x61;	// 97	lower a
const short ASCII_z			=	0x7a;	// 122	lower z
const short ASCII_DEL		=	0x7F;	// 127	delete
const short ASCII_EXTENDMAX	=	0xff;	// 255

const short ASCII_MIN		=	ASCII_NULL;
const short ASCII_MAX		=	ASCII_DEL;
const short ASCII_FIRSTPRINTABLE	=	ASCII_SPACE;
const short ASCII_LASTNONPRINTABLE	=	ASCII_US;
//// 1.1397 ////////////////////////////////////////////


//// 1.0749 PAT 03.03.03 IMPORT PATCH ////
#include "..\WSData\Item.h"
#include "..\Mark_Constants.h"
//// 1.0749 //////////////////////////////

/// 1.0550 DAN 4/29/05 DAN RTF ///
#include "RichTextRend.h"
////1.0550////////////////////////

//// 1.1089 PAT 19.12.05 BOOT LOG ////
#define BOOTLOG_FILENAME	_T("PROBOOT.LOG")
//// 1.1089 //////////////////////////
//// 1.1133 PAT 25.04.06 BOOT LOG ACTIVATION ////
#define BOOTLOG_ACTIVATE_FILE	_T("PROBOOT.TXT")
#define BOOTLOG_ACTIVATE_FLAG	_T("Enable boot log")
//// 1.1133 /////////////////////////////////////

//// PS090913B BAR CODE SCAN 2 ////
#include "BarCodeParser.h"
//// PS090913B ////////////////////

//// PS091123B DOC CONVERSION ////
#define DOC_LOAD_FAIL_NOFAILURE				0
#define DOC_LOAD_FAIL_WRONGPRODUCT			1
#define DOC_LOAD_FAIL_BADFILE				2
#define DOC_LOAD_FAIL_NEWERFAMILY			3
//// PS091123B ///////////////////


class CGlobalData
{
// Attributes
public:


	// Absolute / Relative Path attributes
	/////////////////////////////////////////
#ifndef _PROLASEDLL
//	static _TXCHAR m_acAppRoot[_MAX_PATH];	// Path to the applications root dir
	#ifdef _UNICODE
		static TCHAR m_acAppRoot[_MAX_PATH];	// Path to the applications root dir
	#else
		static char m_acAppRoot[_MAX_PATH];	// Path to the applications root dir
	#endif
#else
	#ifdef _UNICODE
		static TCHAR m_acAppRoot[_MAX_PATH];	// Path to the applications root dir
	#else
		static char m_acAppRoot[_MAX_PATH];	// Path to the applications root dir
	#endif
#endif // _PROLASEDLL


	// Units attributes
	//////////////////////////////
	static int	m_iUnits;

	static unsigned short m_nPIOInAddress,
				m_nPIOOutAddress,
				m_nPIOCAddress,
				m_nPIOCmdAddress,
				m_nCTRAddress,
				m_nXDACAddress,
				m_nYDACAddress,
				m_nPowerAddress,
				m_nFreqAddress,
				m_nFocusAddress,
				m_iBoardType;

	static CString m_sPIOInAddress,
			m_sPIOOutAddress,
			m_sPIOCAddress,
			m_sPIOCmdAddress,
			m_sCTRAddress,
			m_sXDACAddress,
			m_sYDACAddress,
			m_sPowerAddress,
			m_sFreqAddress,
			m_sFocusAddress;
	static BOOL m_bVick;
	static unsigned short m_nDateMode;
	static CString m_sCurrentTitle;
	/*** 1.0223 PAT 03.08.99 NO TEMP GRAPHIC OPTION ***/
	static CObject *m_pPref;
	/*** 1.0223 ***************************************/


	/// 1.0280 DAN 12/29/99 RUNTIME OS DETECTION ///
	static BOOL	m_bWindows95;
	static BOOL	m_bWindows98;
	static BOOL	m_bWindowsNT;
	static BOOL	m_bWindowsXP;
	static BOOL m_bWindowsAboveXP;
	//// PS091119A PROLASE7 FEATURE SET ////
	static BOOL m_bWindows7;
	static BOOL m_bWindowsAbove7;
	//// PS091119A /////////////////////////
	static UINT	m_nMajorVersion;
	static UINT	m_nMinorVersion;
	static UINT	m_nBuildNumber;
#ifdef _UNICODE
	static TCHAR m_acServicePack[200];
#else
	static char m_acServicePack[200];
#endif
	////1.0280//////////////////////////////////////

	//// PS20120109A OS VERSION FROM KERNEL ////
	static UINT m_nMajorVersionSDK;
	static UINT m_nMinorVersionSDK;
	static UINT m_nMajorVersionKernel;
	static UINT m_nMinorVersionKernel;
	//// PS20120109A ///////////////////////////

	//// 1.1105 PAT 13.02.06 VERSION INFO ////
	static BOOL m_bWinXP;
	static BOOL m_bWin2K;
	//// 1.1105 //////////////////////////////

	/// 1.0284 DAN 4/10/00 SECURITY CONTROLS ///
	static BOOL	m_bEditLock;
	////1.0284//////////////////////////////////

	//// 4/28/04 Security Flags///////////////////
	static int m_iBlock;
	static CString m_sTitle;
	////////////////////////////////////////////
	

	static BOOL m_bRunAutomated;
	static BOOL m_bSimpleMarkRun;

	/// 1.0286 DAN 4/18/00 SECURITY FIX ///
	static BOOL m_bSecure;
	static CString m_sPassword;
	////1.0286/////////////////////////////

	//// 1.0441 PAT 29.09.00 DRIVER BITNESS ////
	static CObject *m_pConfig;
	//// 1.0441 ////////////////////////////////

	//// 1.0667 PAT 29.04.02 CONFIRM LINKS UPDATE ////
	static CObject *m_pMarkEngine;
	static CObject *m_pGREngine;
	static CObject *m_pGLibrary;
	static CObject *m_pMainFrame;

	//// 1.0667 //////////////////////////////////////


	/// 1.0500 DAN 11/8/02 DAN PROLASE 2K ///
	static HANDLE	m_hndDriver;
	////1.0500///////////////////////////////

	//// 1.0719 PAT AUTOMATION PATCHES ////
	static BOOL m_bNoDlgUpdate;
	//// 1.0719 ///////////////////////////

	//// 1.0741 PAT 22.01.03 TTF AS STRINGS ////
	static BOOL m_bFeaturesJAN03;
	//// 1.0741 ////////////////////////////////

	//// 1.0745 PAT 30.01.03 ALTERNATE IMPORTER ////
	static BOOL m_bDebug;
	static BOOL m_bDemo;
	static BOOL m_bProLase2K;
	//// PS091119A PROLASE7 FEATURE SET ////
	static BOOL m_bProLase7;
	//// PS091119A /////////////////////////

	static DWORD m_dwImportModes;
	static int m_nPreviousImportType;
	static int m_nCurrentImportType;
	//// 1.0745 ////////////////////////////////////

	//// 1.0749 PAT 03.03.03 IMPORT PATCH ////
	static int m_nDefaultImportType;


	static CItem *m_pCurrentItem;
	static CString m_sCurrentItemName;
	static int m_iCurrentItemIndex;
	static int m_iCurrentLayerIndex;

	static CString m_sSNGVDefExt;
	static CString m_sSNGVDefName;
	static CString m_sSNGVFilter;

	static int m_iAbort;
	static int m_iMarkStatus;
	static int m_iDrawStatus;
	//// 1.0749 //////////////////////////////


	/// 1.0512 DAN 4/09/03 DAN PROLASE XP SCANLAB ///
	static BOOL	m_bALIDriverPresent;
	////1.0512///////////////////////////////////////

	//// 1.0781 PAT 30.06.03 IMPORT FLAGS ////
	static DWORD m_dwCurrentImportFlags;
	static DWORD m_dwCurrentImportFlagsSpecial;
	//// 1.0781 //////////////////////////////

	//// 1.0783 PAT 25.06.03 REGISTRY FLAGS FOR CONTROLS ////
	static DWORD m_dwCurrentImportFlagsSpecialMask;
	//// 1.0783 /////////////////////////////////////////////

	//// 1.0821 PAT 19.12.03 AUTOLAUNCH OF TABLE SERVER ////
	static BOOL m_bProPlus;
	static BOOL m_bPlusWorking;
	static BOOL m_bAnyAxisEnabled;
	//// 1.0821 ////////////////////////////////////////////


	//// 1.0873 PAT 18.05.04 CFG BACKUP PATCH ////
	static DWORD m_dwCfgDrvFlags1;
	static DWORD m_dwCfgDrvFlags2;
	//// 1.0873 //////////////////////////////////

	//// 1.0899 PAT 22.06.04 ALTERNATE SCALING MODE ////
	static BOOL m_bServer;

	static unsigned short int m_nScalingMode;
	static unsigned char m_ScalingData[100][5][4];
	static unsigned int m_nScalingIndex;
	static unsigned int m_nScalingLength;
	static BOOL m_bScalingOn;
	static unsigned int m_nScalingX;
	static unsigned int m_nScalingXMax;
	static unsigned int m_nScalingY;
	static unsigned int m_nScalingYMax;

	static unsigned int m_nScalingA;
	//// 1.0899 ////////////////////////////////////////

	//// 1.0973 PAT 04.01.05 _NPLPLUS FLAG ////
	static BOOL m_bDLL;
	static unsigned int m_nScalingDataCount;

	static BOOL m_bBatchImportStatus;
	//// 1.0973 ///////////////////////////////


	/// 1.0550 DAN 4/29/05 DAN RTF ///
	static CRichTextRend	m_RichTextRend;
	////1.0550////////////////////////

	//// 1.1089 PAT 19.12.05 BOOT LOG ////
#ifdef _UNICODE
	static TCHAR m_sBootLogPath[_MAX_PATH];
#else
	static char m_sBootLogPath[_MAX_PATH];
#endif
	
	//// 1.1089 //////////////////////////

	//// 1.1099 PAT 30.01.06 DLL SETROOTDIR ////
	static BOOL m_bBootLogEnabled;
	//// 1.1099 ////////////////////////////////
	//// 1.1103 PAT 13.02.06 BOOT LOG FIX ////
	static int m_iBootLogVersion;
	static int m_iBootLogCount;
	//// 1.1103 //////////////////////////////

	//// 1.1129 PAT 18.04.06 USER CONTROL ABORT ////
	static BOOL m_bRNPExitCodeValid;
	static DWORD m_dwRNPExitCode;
	//// 1.1129 ////////////////////////////////////

	//// 1.1155 PAT 13.06.06 USER CONTROL ABORT FILE ////
	static CString m_sLastRNPAbortMarkFileName;
	static BOOL m_bRNPAbortMarkFileState;
	//// 1.1155 /////////////////////////////////////////

	//// 1.1247 PAT 01.11.06 POWER CAL FREQ SETTING ////
	static double m_dPowerCalibrationFreq;
	//// 1.1247 ////////////////////////////////////////

	//// 1.1349 PAT 25.06.07 TAU MAX ////
	//	static double long m_dTauMax;
	static long double m_dTauMax;
	//// 1.1349 /////////////////////////

	//// 1.1337 PAT 20.06.07 CONFIG TYPES FUNCTIONS ////
	static int m_iConfigDriverType;
	//// 1.1337 ////////////////////////////////////////
	
	//// 1.1347 PAT 24.06.07 VICKERS CHANGES ////
	static BOOL m_bVickLocalFix;
	static BOOL m_bVickRemap;
	static CString m_sVickRemapA;
	static CString m_sVickRemapB;
	//// 1.1347 /////////////////////////////////
	
	
	//// PS090323A SERIAL NUMBER INCREMENT FUNCTION ////
	static int m_IST_iIncrement;
	static BOOL m_IST_bResetOnLimit;
	static CString m_IST_sResetOnLimitValue;
	static int m_IST_iIncMode;
	static int m_IST_iIncModeCase;
	static BOOL m_IST_bIncModeCarryThrough;

	static int m_IST_iCarryOver;
	static BOOL m_IST_bDidReset;
	//// PS090323A /////////////////////////////////////
	
	//// PS090913B BAR CODE SCAN 2 ////
	static CBarCodeParser m_BCParser;
	//// PS090913B ////////////////////

	//// PS091020A REMOVING FREE HARDWARE ACCESS ////
	static BOOL m_bGiveIOActive;
	//// PS091020A //////////////////////////////////
	
	//// PS091029A SIMPLE TEXT RTF ////
	static CRTFText m_RTFText;
	//// PS091029A ////////////////////
	
	//// PS091123B DOC CONVERSION ////
	static int m_nDocLoadFailureType;
	//// PS091123B ///////////////////

	//// PS091208A CALIBRATION LASER SETTINGS ////
	static double m_dIdlePower;
	//// PS091208A ///////////////////////////////


	//// PS20100316B ISO8601 WEEK OF YEAR ////
	static BOOL m_bDateCodeISO8601WeekEnabled;
	//// PS20100316B /////////////////////////



	
	// Operators
public:
	// Constructor
	CGlobalData();
	// Destructor
	~CGlobalData();


	// Absolute / Relative Path operators
	/////////////////////////////////////////
	static void SetAppPath (void);
	static void SetAppPath (LPCTSTR sPath);
	
	static CString GetAppRoot (void);
	static CString MakeRelative(CString sPath);
	static CString MakeAbsolute(CString sPath);

	// Units operators
	///////////////////////////////
	static void SetUnits (int iUnits);
	static void SetUnits (CString sUnits);
	static CString GetUnitsText(void);

	// Hardware Port operators
	static void SetPortAddresses(short Power, short Freq, short X, short Y, short Focus, short PIO, short CTM);


	// General Functions
	///////////////////////////////
	static CString ExtractFileName (CString sPath);
	static CString ExtractFolderName (CString sPath);
	static CString ExtractFileTitle (CString sPath);

	/*** 1.0203 PAT 01.07.99 RUN NEW PROCESS ***/
	static int RunNewProcess(CString sFileName, CString sCmdLine = _T(""), int iShow = RNP_SHOW_HIDE,
					  int iWaitMode = RNP_WAIT_COMPLETE, int iWaitTime = 0);
	/*** 1.0203 ********************************/

	/*** 1.0223 PAT 03.08.99 NO TEMP GRAPHIC OPTION ***/
	static void SetPrefPointer(CObject *pPref);
	static CObject* GetPrefPointer(void);
	/*** 1.0223 ***************************************/

	/// 1.0280 DAN 12/29/99 RUNTIME OS DETECTION ///
	static void SetOSVersion(void);
	//// PS20120109A OS VERSION FROM KERNEL ////
	static void SetOSVersion2(void);
	static void SetOSVersionSDK(void);
	static void SetOSVersionKernel(void);
	//// PS20120109A ///////////////////////////
	static BOOL IsWindows95(void);
	static BOOL IsWindows98(void);
	static BOOL IsWindowsNT(void);
	static BOOL IsWindows2000orXP(void);
	static BOOL IsWindowsAboveXP(void);
	static CString GetOSVersionString(void);
	static CString GetServicePackString(void);
	static CString GetBuildNumberString(void);
	////1.0280//////////////////////////////////////
	//// 1.1107 PAT 13.02.06 OS VERSION DATA ////
	static CString GetOSVersionNameString(void);
	//// 1.1107 /////////////////////////////////
	//// 1.1105 PAT 13.02.06 VERSION INFO ////
	static BOOL IsWindowsXP(void);
	static BOOL IsWindows2K(void);
	//// 1.1105 //////////////////////////////
	//// PS091119A PROLASE7 FEATURE SET ////
	static BOOL IsWindows7(void);
	static BOOL IsWindowsAbove7(void);
	//// PS091119A /////////////////////////

	/// 1.0284 DAN 4/10/00 SECURITY CONTROLS ///
	static void SetEditLock(BOOL bEditLock);
	static BOOL IsEditLock(void);
	////1.0284//////////////////////////////////
	/// 1.0286 DAN 4/18/00 SECURITY FIX ///
	static void SetSecure(BOOL bSecurityState);
	static BOOL IsSecure(void);
	static void SetPassword(CString sPassword);
	static CString GetPassword(void);
	////1.0286/////////////////////////////

	//// 1.0429 PAT 06.09.00 QUEUE RECOVERY FILE ////
	static CString GetTempDir(void);
	//// 1.0429 /////////////////////////////////////

	//// 1.0441 PAT 29.09.00 DRIVER BITNESS ////
	static CObject * GetConfig(void);
	static void SetConfig(CObject *pConfig);
	//// 1.0441 ////////////////////////////////

	//// 1.0493 PAT 24.01.01 DEFAULT OBJECT VALUES ////
	static BOOL GetDefaultItem(UINT nType, CObject *pItem);
	static BOOL SetDefaultItem(CObject *pItem);
	//// 1.0493 ///////////////////////////////////////

	//// 1.0667 PAT 29.04.02 CONFIRM LINKS UPDATE ////
	static CObject * GetMarkEngine(void);
	static void SetMarkEngine(CObject *pMarkEngine);

	static CObject * GetGREngine(void);
	static void SetGREngine(CObject *pGREngine);
	
	static CObject * GetGLibrary(void);
	static void SetGLibrary(CObject *pGLibrary);
	//// 1.0667 //////////////////////////////////////
	static long GetRealHeight(CString sFileName, BOOL bTPO);
	static long GetRealWidth(CString sFileName, BOOL bTPO);
	static long GetRealXPos(CString sFileName, BOOL bTPO);
	static long GetRealYPos(CString sFileName, BOOL bTPO);
	static BOOL IsRealGraphic(CString sFileName, BOOL bTPO);

	//// 1.0741 PAT 22.01.03 TTF AS STRINGS ////
	//// 1.0761 PAT 24.04.03 REAL SIZE/POS PATCH ////
	//	static BOOL GetFeaturesJAN03(void);
	static BOOL IsFeaturesJAN03(void);
	//// 1.0761 /////////////////////////////////////
	static void SetPreCompileFlags(void);
	//// 1.0741 ////////////////////////////////

		//// 1.0745 PAT 30.01.03 ALTERNATE IMPORTER ////
	static BOOL IsDebug(void);
	static BOOL IsDemo(void);
	static BOOL IsProLase2K(void);
	//// PS091119A PROLASE7 FEATURE SET ////
	static BOOL IsProLase7(void);
	//// PS091119A /////////////////////////

	static DWORD GetImporterModes(void);
	static void SetImporterModes(void);
	static int TestImporterImageStream(BOOL bFlag);
	static int TestImporterKandu(BOOL bFlag);

	static int GetPreviousImportType(void);
	static void SetPreviousImportType(int nType);

	static int GetCurrentImportType(void);
	static void SetCurrentImportType(int nType);

	static CString DecorateGraphicFileName(CString sName);
	static CString UnDecorateGraphicFileName(CString sName);

	static BOOL IsNativeImporterType(CString sName);
	static int TestImporterType(int iType);
	static int RectifyImporterType(CString sFile, int iType);
	//// 1.0745 ////////////////////////////////////

	//// 1.0749 PAT 03.03.03 IMPORT PATCH ////
	static int GetDefaultImportType(void);
	static void SetDefaultImportType(int nType);

	static BOOL SelectNewGraphicVector(CString& sName, BOOL *pReload, BOOL bWarn);
	
	static void SetCurrentItem(CItem *pItem);
	static void SetCurrentItemName(CString sName);
	static void SetCurrentItemIndex(int iItem);
	static void SetCurrentLayerIndex(int iLayer);

	static BOOL SetCurrentItemGraphicName(CString sFile);

	static int GetFileExtension(CString sFile, CString& sExt);
	
	static CString SNGVBuildFilter(CString sName);
	static CString SNGVBuildGraphicFilterIS(CString sName);
	static CString SNGVBuildGraphicFilterKandu(CString sName);
	static CString SNGVBuildGraphicFilterISAndKandu(CString sName);
	static BOOL SNGVVerifyType(CString sPath);
	static int SNGVRectifyImporterType(CString sName, int iType);
	static int SNGVValidateImporterType(int iType);

	static int GetAbortState(void);
	static int SetAbortState(int iType);
	static int ClearAbortState(void);

	static int GetMarkStatus(void);
	static int SetMarkStatus(int iStatus);
	static int GetDrawStatus(void);
	static int SetDrawStatus(int iStatus);

	static BOOL SelectVectorData(CItem *pItem, int iLayer, int iItem);
	//// 1.0749 //////////////////////////////

	//// 1.0751 PAT 20.03.03 IMPORT PATCH CONT ////
	static DWORD GetGraphicFileType(CString sFile);
	static DWORD GetFontFileType(CString sFile);
	//// 1.0751 ///////////////////////////////////

	/// 1.0512 DAN 4/09/03 DAN PROLASE XP SCANLAB ///
	static void SetALIDriverPresent(BOOL bPresent);
	static BOOL IsALIDriverPresent(void);

	static void ALIDriverMissingMsg(void);
	////1.0512///////////////////////////////////////

	//// 1.0781 PAT 30.06.03 IMPORT FLAGS ////
	static DWORD GetCurrentImportFlags(void);
	static void SetCurrentImportFlags(DWORD dwFlags);
	static DWORD GetCurrentImportFlagsSpecial(void);
	static void SetCurrentImportFlagsSpecial(DWORD dwFlags);
	//// 1.0781 //////////////////////////////

	//// 1.0783 PAT 25.06.03 REGISTRY FLAGS FOR CONTROLS ////
	static DWORD GetCurrentImportFlagsSpecialMask(void);
	static void SetCurrentImportFlagsSpecialMask(void);
	//// 1.0783 /////////////////////////////////////////////
	
	//// 1.0819 PAT 18.12.03 NEW RUN NEW PROCESS ////
	static int RunNewProcess2(CString sFileName, CString sCmdLine = _T(""), int iShow = RNP_SHOW_HIDE,
					  int iWaitMode = RNP_WAIT_COMPLETE, int iWaitTime = 0, BOOL bRedirOut = FALSE, CString sOutFile = _T(""));
	//// 1.0819 /////////////////////////////////////

	//// 1.0821 PAT 19.12.03 AUTOLAUNCH OF TABLE SERVER ////
	static BOOL IsPlus(void);
	static BOOL IsPlusWorking(void);
	static void SetPlusWorking(BOOL bWorking);
	static BOOL IsAnyAxisEnabled(void);
	static void SetAnyAxisEnabled(BOOL bEnabled);
	//// 1.0821 ////////////////////////////////////////////

	//// 1.0851 PAT 15.04.04 SECURITY UPGRADE ////
	static void TestSecurity(void);
	static void StoreCurrentTime(void);
	// KC Security //
	static CString SetTitle(CString Type);
	//// 1.0851 //////////////////////////////////

	//// 1.0873 PAT 18.05.04 CFG BACKUP PATCH ////
	static void SetCfgDrvFlags(DWORD dwFlags1, DWORD dwFlags2);
	static void GetCfgDrvFlags(DWORD *dwFlags1, DWORD *dwFlags2);
	//// 1.0873 //////////////////////////////////

	//// 1.0893 PAT 14.06.04 CAL MAX VOLT LIMIT ////
	static CString m_sUnitsPower;
	static CString GetUnitsPower(void);
	static void SetUnitsPower(CString sUnits);
	//// 1.0893 ////////////////////////////////////

	//// 1.0899 PAT 22.06.04 ALTERNATE SCALING MODE ////
	static BOOL IsServer(void);

	static void SetScalingMode(unsigned short int nMode);
	static unsigned short int GetScalingMode(void);

	static void *m_pScalingMatrix;
	static void *GetScalingMatrix(void);

	static void SetScalingData(void);
	static void GetScalingData(unsigned char Data1[], unsigned char Data2[], unsigned short int *Data3);

	static BOOL IsScaling(void);
	static BOOL IsScalingX(void);
	static BOOL IsScalingY(void);
	static BOOL IsScalingA(void);

	static void CleanUp(void);
	//// 1.0899 ////////////////////////////////////////

	//// 1.0973 PAT 04.01.05 _NPLPLUS FLAG ////
	static BOOL IsDLL(void);

	static void SetScalingDataType(int iType, int iValue);
	//// 1.0973 ///////////////////////////////

	//// 1.0981 PAT 26.01.05 GRAPHIC ASPECT RATIO UPDATE ////
	static long GetGraphicHeaderHeight(CString sFileName, BOOL bTPO);
	static long GetGraphicHeaderLength(CString sFileName, BOOL bTPO);
	//// 1.0981 /////////////////////////////////////////////

	//// 1.0995 PAT 07.03.05 BATCH GRAPHIC IMPORTER ////
	static CString m_sLastImportedGraphicSource;
	static CString m_sLastImportedGraphicTemp;

	static CString GetLastImportedGraphicSourceFilePath(void);
	static void SetLastImportedGraphicSourceFilePath(CString sPath);
	
	static CString GetLastImportedGraphicTempFilePath(void);
	static void SetLastImportedGraphicTempFilePath(CString sPath);


	static BOOL GetBatchImportStatus(void);
	static void SetBatchImportStatus(BOOL bStatus);
	//// 1.0995 ////////////////////////////////////////

	//// 1.0997 PAT 15.03.05 DEFAULT FOLDERS IN PREF ////
	static CString GetFileFolder(CString sPath);
	static CString GetFileName(CString sPath);
	static CString GetFileTitle(CString sPath);
	static CString GetFileExt(CString sPath);
	//// 1.0997 /////////////////////////////////////////

	//// 1.1011 PAT 30.04.05 TTF NAME WITH INVALID DOS FILE NAME CHAR ////
	static CString EncodeTTFName(CString sName);
	static CString DecodeTTFName(CString sName);
	//// 1.1011 //////////////////////////////////////////////////////////

	//// 1.1089 PAT 19.12.05 BOOT LOG ////
	static void UpdateBootLog(int iPos);
	//// 1.1089 //////////////////////////

	//// 1.1129 PAT 18.04.06 USER CONTROL ABORT ////
	static BOOL IsRNPExitCodeValid(void);
	static DWORD GetRNPExitCode(void);
	static void ClearRNPExitCode(void);
	//// 1.1129 ////////////////////////////////////

	//// 1.1155 PAT 13.06.06 USER CONTROL ABORT FILE ////
	static BOOL GetRNPAbortMarkFileState(void);
	static void ClearRNPAbortMarkFileState(void);
	static BOOL GetRNPAbortMarkFile(void);
	static void ClearRNPAbortMarkFile(void);
	//// 1.1155 /////////////////////////////////////////

	//// 1.1181 PAT 25.08.06 RS232 VAR TEXT ////
	static int EnumSerialPorts(char *sPortName, DWORD dwMaxLen, DWORD dwIndex);
	//// 1.1181 ////////////////////////////////

	//// 1.1247 PAT 01.11.06 POWER CAL FREQ SETTING ////
	static double GetPowerCalibrationFreq(void);
	static void SetPowerCalibrationFreq(double dFreq);
	//// 1.1247 ////////////////////////////////////////

	//// 1.1307 PAT 01.03.07 COM APPLETS ////
	static int RunNewProcess3(CString sFileName, CString sCmdLine = _T(""), int iShow = RNP_SHOW_HIDE,
					  int iWaitMode = RNP_WAIT_COMPLETE, int iWaitTime = 0,
					  STARTUPINFO *pSI = NULL, PROCESS_INFORMATION *pPI = NULL);
	//// 1.1307 /////////////////////////////

	//// 1.1337 PAT 20.06.07 CONFIG TYPES FUNCTIONS ////
	static int GetConfigDriverType(void);
	static void SetConfigDriverType(int iType);
	static BOOL IsUsingRTC(void);
	//// 1.1337 ////////////////////////////////////////

	//// 1.1347 PAT 25.06.07 VICKERS CHANGES ////
	static CString VickLocalFix(CString sOrig);
	static CString VickRemap(CString sOrig);
	//// 1.1347 /////////////////////////////////

	//// 1.1377 PAT 27.08.07 DEFAULT LAYER SETTINGS FROM PREF ////
	static BOOL GetDefaultLayer(CObject *pLayer);
	static BOOL SetDefaultLayer(CObject *pLayer);
	//// 1.1377 //////////////////////////////////////////////////

	//// 1.1405 PAT 11.12.07 POWER CAL TABLE TEXT FILE ////
	static BOOL IsNoMessageBoxes(void);
	//// 1.1405 ///////////////////////////////////////////


	//// PS090323A SERIAL NUMBER INCREMENT FUNCTION ////
	static CString IST_IncrementSerialText(CString sStartNum, int iInc);
	static UINT IST_IncrementCharacter(unsigned char *ch, int iInc);
	//// PS090323A /////////////////////////////////////

	//// PS090603B RE-BUILD FILES ////
	static int CreateRequiredFiles(void);
	//// PS090603B ///////////////////

	//// PS091002A SIMULATE SPEED FINISH ////
	static double GetSimSpeedFactorFromIndex(int iIndex);
	//// PS091002A //////////////////////////

	//// PS091020A REMOVING FREE HARDWARE ACCESS ////
	static OpenGiveIO(void);
	static BOOL IsGiveIO(void);
	//// PS091020A //////////////////////////////////

	//// PS20100309A PL95 HARDWARE BUG ////
	static BOOL IsIOAccessible(void);
	//// PS20100309A //////////////////////

	//// PS091123B DOC CONVERSION ////
	static int GetDocLoadFailureType(void);
	static void SetDocLoadFailureType(int nType);
	//// PS091123B ///////////////////

	//// PS091208A CALIBRATION LASER SETTINGS ////
	static double GetIdlePower(void);
	static void SetIdlePower(double dPower);
	//// PS091208A ///////////////////////////////

	//// PS100115A STATUS CODE UPGRADE ////
	static int GetProlaseVersion(void);
	//// PS100115A ////////////////////////

	//// PS20100208A RTFEDITDLG UNICODE UPDATE ////
	static int FileWriteData(CString sFileName, LPVOID pByte, int iSize);
	//// PS20100208A //////////////////////////////

#ifdef _UNICODE
	static char m_MBCSBuffer[0xffff];
	static wchar_t m_WideBuffer[0xffff];
	//	static char* Wide_to_MBCS(CString sWide);
	static char* Wide_to_MBCS(CString sWide, int *pSize = NULL);
	//// PS20100208A RTFEDITDLG UNICODE UPDATE ////
	static int Wide_to_MBCS_Size(CString sWide);
	//// PS20100208A //////////////////////////////
	static CString MBCS_to_Wide(char *pMBCS);
#else
#endif

	//// PS20100316B ISO8601 WEEK OF YEAR ////
	static BOOL GetDateCodeISO8601WeekEnabled(void);
	static void SetDateCodeISO8601WeekEnabled(BOOL bOn);
	//// PS20100316B /////////////////////////

	//// PS20100811A PREVIEW MODE ////
	static BOOL m_bMarkPreviewMode;
	//// PS20100811A /////////////////

private:

};

#endif


