// GSymbol.h
//
// Header file for the CGSymbol class
/////////////////////////////////////////////////
/*** 1.0036 DAN 9.6.98 GRAPHIC MEMORY REVISE ***/
/////////////////////////////////////////////////


#ifndef CGSYMBOL
#define CGSYMBOL

#include <afx.h>

#ifdef _ALIUSE
	#include "..\VGraph\lGHeader.h"
#else
	#include "lgHeader.h"
#endif

/// 1.0244 DAN 9/7/99 GRAPHIC LIBRARY STATISTIC INFORMATION ///
#include "GSymbolInfo.h"
////1.0244/////////////////////////////////////////////////////

class CGSymbol : public CObject
{
// Attributes
private:

	// The vector list
	long	*m_paVecList;

	// Size of vector list
	long	m_lVecListSize;

	// Utilization flag (used for cleanup)
	BOOL	m_bUsed;

	// Header information (so the vec list is just (and only) that)
	ClGHeader
			m_Header;

/// 1.0244 DAN 9/7/99 GRAPHIC LIBRARY STATISTIC INFORMATION ///
public:
	CGSymbolInfo	m_SymbolInfo;
////1.0244/////////////////////////////////////////////////////

// Operators
public:

	// Construction / Destruction
	CGSymbol(void);
	void Init(void);				// Intitializes variables

	~CGSymbol(void);
	void ClearVectorList(void);		// Clears the vector list



	// Data member access
	long GetSize(void);				// Returns the size

	BOOL IsUsed(void);				// Returns the used flag
	void SetUsed(BOOL bUsed);		// Sets the used flag

	long* GetVecList(void);			// Return a pointer to the vec list

	BOOL AllocateVecList(long lSize);

	BOOL SetVecList(long *pVectors, long lSize);

	/// 1.0242 DAN 9/2/99 NEW HATCHFILL ADDITION FIRST REVISION ///
	BOOL SetVecList(CMemFile *pfVectors, long lSize);
	////1.0242/////////////////////////////////////////////////////

	ClGHeader * GetHeader(void);	// Return a pointer to the header

	long GetSymbolType(void);		// Returns the symbol type

	void SetHeader(ClGHeader&);		// Set the header values

	/*** 1.0046 DAN 10.7.98 GRAPHIC MEM SAVE ***/
	void WriteSymbol(CFile *pFile);
	void ReadSymbol(CFile *pFile);
	/*******************************************/


	//// 1.0732 DAN 06.04.07 CROSS HATCH ////
	void RotateVecList(long lAngle);
	void ConcatSymbol(CGSymbol *pNewSym);
	//// 1.0732 /////////////////////////////

};

#endif