// LayerTab.h
//
// Header file for the CLayerTab class
/////////////////////////////////////////
/*** 1.0013 DAN 4/25/98 LAYER SELECTION BUTTONS ***/
//Created During This update

#define LT_NONE		-1
#define LT_ROOT		1
#define LT_TAB		2
#define LT_LAYER	3

#ifndef LAYERTAB
#define LAYERTAB


//// PS090824B LAYER TAB LIMIT ////
//	#define LT_MAXLAYERS	100
//	#define VER_TABINFO		100	
//	#define VER_LAYERTAB	100
//	
#define LT_MAXLAYERS				1000

#define LT_MAXLAYERS_ORIG			100
#define VER_TABINFO_ORIG			100
#define VER_LAYERTAB_ORIG			100
// This had been set to echo VER_ITEM, so
// we set it beyond the current VER_ITEM value (2030)
#define TABINFO_20090824			2222
#define LAYERTAB_20090824			2222

#define VER_TABINFO					TABINFO_20090824
#define VER_LAYERTAB				LAYERTAB_20090824
//// PS090824B ////////////////////

class CTabInfo : public CObject
{

	DECLARE_SERIAL( CTabInfo )

public:
// Attributes
	UINT	m_nVersion;

	// The name of this tab
	CString m_sTabName;

	// Using this for now... assumes that there are only 100 layers
	int		m_aiLayers[LT_MAXLAYERS];
	int		m_iNumberLayers;

	// These are the tab controls to be sent to the view
	// Don't bother to archive
	TC_ITEM			m_TabItem;

	// Flag to say if this is opened in the tree structure
	BOOL	m_bOpen;

// Operators
	CTabInfo(void);

	//// PS20100310A LAYERTAB CORRUPTION ////
	void Init(void);
	//// PS20100310A ////////////////////////

	// Serialization
    void Serialize( CArchive& ar );


	// Determines if a layer is in the tab
	int IsIn(int iLayer);

	// Adds a layer to the tab
	void AddLayer(int iLayer);

	// Delete a layer from the tab
	void DeleteLayer(int iLayer);

	/// 1.0332 DAN 10/23/00 LAYER TAB / LAYER DELETION CRASH TRY 2 ///
	void ReorderLayers(int iLayer);
	////1.0332////////////////////////////////////////////////////////


};


class CLayerTab : public CObject
{

	DECLARE_SERIAL( CLayerTab )

public:
// Attributes

	UINT	m_nVersion;

	CObArray	m_Tabs;

	// A pointer to the Mainframes LayerTabFltDlg TreeCtrl class
	// No need to archive
	CTreeCtrl	*m_pLTabTree;

	// A pointer to the document (used to get doc title)
	// No need to archive
	CDocument	*m_pDoc;

	// A pointer to the WSData structure (used to get layer names)
	// No need to archive
	CObject		*m_pData;

	// Flag to tell if creation has occured
	// No need to archive
	BOOL		m_bCreated;

	// Flag to tell if the root is open
	BOOL		m_bRootOpen;

// Operators

	// Construction / Destruction
	CLayerTab(void);
	~CLayerTab(void);

	// Serialization
    void Serialize( CArchive& ar );


	// Creation functions
	void Create(CTreeCtrl *pLTabTree);

	// Layer Addition / Deletion
	void AddTab(CString sTabName);
	void DeleteTab(CString sTabName);
	
	void AddLayerToTab(int iTab, int iLayer);
	void DeleteLayerFromTab(int iTab, int iLayer);
	
	void AddLayerToTabName(CString sTabName, int iLayer);
	void DeleteLayerFromTabName(CString sTabName, int iLayer);

	void DeleteAllTabs(void);


	// Access Operators
	int IsIn(CString sTabName);
	int GetTabPosition(CString sTabName);


	// Display functions
	void UpdateTree(void);


	// Attribute Updates
	void SetTabState(CString sTabName, BOOL bOpen);
	void BuildTabItems();
	void SetFirstTab();
	void OnDeleteLayer(int iLayer);
	void SetLayerFlags(int iTab);

	/*** 1.0080 12.9.98 Distortion Corr On/Off ***/
	void MoveTab (int iSrc, int iDst);
	/****1.0080***********************************/


	//// PS090316A MORE MASTERPHRASING ////
	CString m_sDefaultTabText;
	//// PS090316A ////////////////////////

	//// PS090824B LAYER TAB LIMIT ////
	int m_iCount;
	//// PS090824B ////////////////////

};


#endif