// ListFiles.h
//
// Header file for the CListFiles Class
////////////////////////////////////////

#ifndef CLISTFILE
#define CLISTFILE

#ifdef _ALIUSE
	#include "WSData\WSData.h"
#else
	#include "WSData.h"
#endif


class CListFile
{
public:
	// Attributes
	CString m_sFileName;
	FILE	*m_fp;
	UINT	m_nEntriesPerRecord;
	UINT	m_nCurrentLine;

	/*** 1.0003 DAN 4/17/98 LIST FILE RESET AT EOF ***/
	BOOL	m_bLoopFile;
	/*************************************************/

	/// 1.0220 DAN 6/1/99 Data Monitor Dlg ///

	/// 1.0226 DAN 7/19/99 LIST FILE PREFETCH DATA FIXES ///
	CStringArray m_asData;
	////1.0226//////////////////////////////////////////////

	int		m_iEntries;
	int		m_iLastValidEntry;
	int		m_iCurrentEntry;

	int		m_iCurrentDataMonEntry;

	int		*m_aiEntriesPerLayer;
	////1.0220////////////////////////////////

	// Operators
	/// 1.0220 DAN 6/1/99 Data Monitor Dlg ///
	CListFile(int iTotalLayers);
	////1.0220////////////////////////////////
	void Initialize(void);
	~CListFile(void);

	int OpenFile(void);
	void CloseFile(void);

	/// 1.0220 DAN 6/1/99 Data Monitor Dlg ///
/// 1.0226 DAN 7/19/99 LIST FILE PREFETCH DATA FIXES ///
	BOOL PrefetchData(int iLayer, int iArrayParts);
////1.0226//////////////////////////////////////////////
	CString GetNextEntry(UINT *bStatus = NULL);
	CString ReadNextEntry(UINT *bStatus = NULL);
	////1.0220////////////////////////////////

	/// 1.0220 DAN 6/1/99 Data Monitor Dlg ///
	void SetEntriesPerRecord(UINT nEntriesPerRecord, int iLayer);
	void IncrementEntriesPerRecord(UINT nArraySize, int iLayer);
	void SetRecord(UINT nRecord = 0);
	////1.0220////////////////////////////////

	void Reset(void);

	//// PS080521A LIST FILE RICH TEXT ////
	BOOL m_bRTFFile;
	CString ReadNextEntryRTF(UINT *bStatus = NULL);
	//// PS080521A ////////////////////////

};


class CListFiles : public CObArray
{
public:

	// Operators
	CListFiles(void);
	void Initialize(void);
	~CListFiles(void);

	CListFile *GetListFile(CString sFileName);
	/// 1.0220 DAN 6/1/99 Data Monitor Dlg ///
	CListFile *AddListFile(CString sFileName, UINT nItemArraySize, int iLayer, int iTotalLayers);
	////1.0220////////////////////////////////


	void GetFiles(CWSData *pWSData);
	void ReleaseFiles();

	void OpenFiles();
	void CloseFiles();

	void PromptStartRecords(void);

	/*** 1.0003 DAN 4/17/98 LIST FILE RESET AT EOF ***/
	void UpdateItems(CWSData *pWSData);
	/*************************************************/

/// 1.0226 DAN 7/19/99 LIST FILE PREFETCH DATA FIXES ///
	/// 1.0220 DAN 6/1/99 Data Monitor Dlg ///
	BOOL PrefetchData(int iLayer, int iArrayParts);
	////1.0220////////////////////////////////
////1.0226//////////////////////////////////////////////

	//// PS080521A LIST FILE RICH TEXT ////
	//// PS080521A ////////////////////////

	//// PS080905A LIST FILE START RECORD OPTIONS ////
	void PromptStartRecords2(int iMode, int iStartNum, int iEOFAction);
	//// PS080905A ///////////////////////////////////

};

#endif
