// LM50CalTable.h

// Header file for the CLM50CalTable class.
//
// Pat Summers
// American Laserware, Inc.


#ifndef	LM50CALTABLE
#define LM50CALTABLE

const int		LM50CALTABLE_MAX				=	150;
const double	LM50CALTABLE_DEFAULT_YINT		=	5.00;
const double	LM50CALTABLE_DEFAULT_SLOPE		=	0.200;

// Define the class
class CLM50CalTable
{
public:
	// Constructor
	CLM50CalTable(void);
	// Destructor
	~CLM50CalTable(void);

public:
	void Init(void);
	UINT GetVersion(void);
	void operator = (const CLM50CalTable src);
	BOOL operator == (const CLM50CalTable src);
	
	double GetMinValue(void);
	double GetMaxValue(void);

	int GetNearest(double dDesired, double *pNearest = NULL);
	double GetValue(int iIndex);
	void SetValue(int iIndex, double dValue);

	BOOL FinishTable(int iLast);

	double * GetData(void);
	

protected:
	UINT
		m_nVersion;
	double
		m_dValues[LM50CALTABLE_MAX+1];
	BOOL
		m_bLoaded;
};

#endif	// LM50CALTABLE


