// Header file for CLongList class
//
// American LaserWare, Inc
// Pat Summers
// 19 AUG 1997
//
//	The CLongList class is used to hold all the vector
//	graphic data found in the GRAPHIC (*.ALG) and FONT
//	(*.ALF) files required to properly render their
//	images.	Data are stored as longs sequentially, thus
//	mimicing a simple array.  Member functions serve to
//	monitor the size and status of this "array" and to
//	modify and retrieve the data stored in it.
///////////////////////////////////////////////////////////

// longlist.h

#ifndef CLONGLIST
#define CLONGLIST

// LongList specific constant definitions
//// 1.1013 PAT 02.05.05 LARGE GRAPHICS ////
//#define LL_LIST_MAX			1000000
#define LL_LIST_MAX			10000000
//// 1.1013 ////////////////////////////////
//#define LL_LIST_MAX			11460
#define LL_INDEX_MIN		0
#define LL_INDEX_MAX		LIST_MAX - 1

// Include header files required for members
#include "vgconst.h"

class CLongList : public CObject
{

	DECLARE_SERIAL (CLongList)
		
// Attributes
protected:
	long
		m_lSize,
		m_nIndex,
		m_alList[LL_LIST_MAX];
	/*** 1.0053 PAT 21.05.98 LONGLIST OVERRUN FIX ***/
	BOOL
		m_bFull;
	/************************************************/
// Implementations
public:
	CLongList(void);			// Constructor
	~CLongList(void);			// Destructor
	void Init(void);			// Initialize members
	void Serialize(CArchive&);	// Load / Save routines
	long GetAt(long);			// Gets a value at index
	BOOL SetAt(long,long);		// Sets a value at index
	long* GetVecList(long);		// Returns a pointer to the
									// value of the list at
									// the specifed index
	/*** 1.0053 PAT 21.05.98 LONGLIST OVERRUN FIX ***/
	BOOL IsFull(void);			// Tells is list is filled
	/************************************************/

// Operators
public:

};

#endif


