// Header file for CThumbnail class
//
// American LaserWare, Inc
// Pat Summers
// 19 AUG 1997
//
//	The Thumbnail class serves to allow fast,low-res
//	pre-viewing of a GRAPHIC symbol.  During file creation
//	the GRAPHIC file (*.ALG) will imbed a low-res monochome
//	bitmap of the rendered vector graphic data.
///////////////////////////////////////////////////////////

// thumb.h

#ifndef CTHUMBNAIL
#define CTHUMBNAIL

// Include headers for members
#include <afxwin.h>

// Include version info
#ifdef _ALIUSE
	#include "..\Versions\versions.h"
#else
	#include "versions.h"
#endif

// version number
//#define CT_VER_1			1
	// 4 AUG 97

// bitmap resolution in pixels
#define CT_PIX_H			64
#define CT_PIX_W			64
// memory required for bitmap
#define CT_BYTES_W			8

class CThumbnail : public CObject
{
	DECLARE_SERIAL (CThumbnail)

	//Attributes
	public:
		// CThumbnnail class version info
		UINT
			m_nVersion;

		// bitmap size info
		int
			m_iH,		// height
			m_iW,		// width
			m_iWBytes;	// width in bytes
	
		// monochrome bitmap
		unsigned char
			m_aBitmap[CT_PIX_H][CT_BYTES_W];

	
	// Operations

	//Implementations
	public:
		CThumbnail(void);		// Constructor
		~CThumbnail(void);		// Destructor
		void Init(void);		// Initializes members
		void Serialize( CArchive&);	
								// Load / Save routines
		void RenderToDC(CDC *, int = 0, int = 0, COLORREF = RGB(0,0,0));
								// Draws image to DC bitmap
		void MakeFromDC(CDC *, int = 0, int = 0, COLORREF = RGB(0,0,0));
								// Creates image from a DC bitmap
};

#endif

