// Header file with version information for CItem class
//
// ver_item.h
//

/*** 1.0105 PAT 02.09.98 NEW TEXT ASPECT MODES ***/


/*
	Version 0	-	Date pre 1998.04.30

Original version of the CItem class archive.
*/
#define ITEM_1998_04_29		100

/*
	Version 1	-	Date 1998.05.01

This version added only to standardize.
It has the same value as the previous one.
*/
#define ITEM_1998_05_01		100

/*
	Version 2	-	Date 1998.06.15

This version adds the CImageData m_Image member to the archive.
*/
#define ITEM_1998_06_15		200


/*
	Version 3	-	Date 1998.09.02

  This version incorperates changes made for new text modes.
  The m_bFixedAspect variable is REMOVED from the achive.
  At that location, two new variables are inserted:
	m_iAspectMode,
	m_dAspectRatio

*/
#define ITEM_1998_09_02		300


/*
	Version 4	-	Date 1998.10.08

  This version simply indicates the replacement of one of the
  temporary flags with the m_bModifiedLength flag.  It is not
  a required version increment, but is added for completeness.
  
*/
#define ITEM_1998_10_08		400


/*
	Version 5	-	Date 1998.10.13

  This version simply adds a BOOL for the flag to supress leading
  zeros on serial text after the other variable data and immediately
  before the prompt in the archive.
  The m_sVarText variable for holding the source variable text string
  is also added.
   
*/
#define ITEM_1998_10_13		500

/*
	Version 6 - Date 1998 10 16
	
	This version includes the Item members for b_UseMaterialFile, m_fSpeed2, m_fPower2, and m_fFreq2.
	These are used to allow each item to have a set of laser paramters independent of the material
	file.

*/
#define ITEM_1998_10_16		600

/*
	Version 7 - Date 1998 12 21

  This version is really just a re-application of version 2 with the
  re-introduction of the bitmap code into ProLase following the final
  adoption of Dan's new memory.
  Hence, this version adds CImageData m_Image to the archive.
*/
#define ITEM_1998_12_21		700

/* 
	Version 8 - Date 1999 01 18
	adds List File Auto Reset function
*/
#define ITEM_1999_01_18		800	


// Adds new Passes logic
#define ITEM_1999_03_06		900


/*
	Version 10 - Date 1999 07 05

	This version adds two variables for the Object PET.
	m_bPETEnable flag and m_sPETName string.
*/
#define ITEM_1999_07_05		1000

/*
	Version 11 - Date 2001 06 20

  Adds m_dWobbleFreq
*/
#define ITEM_2001_06_20		1100

/*
	Version 12 - Date 2001 07 02

  Adds m_bVarSerialAbortOnReset
*/
#define ITEM_2001_07_02		1200


/*
	Version 13 - Dte 2002 01 28

  Adds m_bFillAfterOutline

*/
#define ITEM_2002_01_28		1210

/*
	Version 14 - Date 2002 03 28
	
  Adds a dummy int value following the m_bFillAfterOutline
  value.  This is to ensure that future additions to the archive
  are stable following the patch to fix the Fill After Outline
  error.
*/
#define ITEM_2002_03_28		1220

/*
	Version 15 - Date 2002 07 24

	Adds m_bUseDotMatrixFont
*/
#define ITEM_2002_07_24		1221

/*
	Version 16 - Date 2002 11 14

  Adds variables to store graphic real-size data
		m_iRealSizeUnits,
		m_dRealSizeExtraScale
*/
#define ITEM_2002_11_14		1222

/*
	Version 17 - Date 2002 12 04

  Adds m_bLocked
*/
#define ITEM_2002_12_04		1223

/*
	Version 18 - Date 2003 01 22

	Adds only m_bTTFNaturalKerning. Other newly added
	variables are determined at run time;
*/
#define ITEM_2003_01_22		1224

/*
	Version 19 - Date 2003 01 30

	Adds m_nVectorImporterType
*/
#define ITEM_2003_01_30		1225

/*
	Version 20 - Date 2003 04 24

	Adds m_bUseRealSize, m_bUseRealPos
*/
#define ITEM_2003_04_24		1226

/*
	Version 21 - Date 2003 06 01
	Adds m_DrillData class
*/
#define ITEM_2003_06_01		2000

/*
	Version 21 - Date 2003 06 30

	Adds variables for importer options
		m_dwVectorImporterFlags,
		m_dwVectorImporterFlagsSpecial
*/
#define ITEM_2003_06_30		2001

/*
	Version 22 - Date 2004 04 30

	Adds m_lMarkFlags
*/
#define ITEM_2004_04_30		2002
/*
	Version 23- Date 2005 02 25
	Adds m_tLastDateMarked to implement Reset serial number on date change
*/
#define ITEM_2005_02_25		2003

/*
	Version 24 - Date 2005 06 23
	Adds rich text item type (Dynamic File only)
*/
#define ITEM_2005_06_23		2004

/*
	Version 25 - Date 2006 04 14
	Adds Dynamic List file attributes
		m_iDynFileMode
		m_iDynFileLines
*/
#define ITEM_2006_04_14		2005


/*
	Version 26 - Date 2006 09 21
	Adds m_bNoUpdate to limit var text updates
	for display and mark
*/
#define ITEM_2006_09_21		2006

/*
	Version 27 - Date 2006 11 01
	Adds variables for addition data linkages:
		m_bLinkText
		m_bLinkFont
		m_bLinkGeometry
		m_bLinkFill
		m_bLinkLaser
*/
#define ITEM_2006_11_01		2007

/*
	Version 28 - Date 2006 11 06
	Updates last version.  Only LinkGeometry
	is kept.  All other linkages are gone.
	File still saves/loads 5 BOOLs, but
	only 3rd one is used.
	This version actually add NO data to
	the file.  It is added solely to bring
	attention the the change in the last version.
*/
#define ITEM_2006_11_06		2008

/*
	Version 29 - Date 2006 12 05
	Adds m_iChecksum
*/
#define ITEM_2006_12_05		2009

/*
	Version 30 - Date 2007 01 19
	Adds m_iChecksumMode
*/
#define ITEM_2007_01_19		2010

/*
	Version 31 - Date 2008 06 19
	Adds variables for new serial number
	modes and cases:
		m_iVarSerialIncMode
		m_iVarSerialIncModeCase
*/
#define ITEM_2008_06_19		2020

/*
	Version 32 - Date 2008 08 06
	Adds variables to allow Serial Numbers
	to NOT be incremented when conditionally
	NOT marked.
		m_bVarSerialIncWhenSkipped
*/
#define ITEM_2008_08_06		2030


/*
	Version 33 - Date 2009 10 29
	Adds variables for Simple or RTF Fixed Text modes
		m_iFixedTextMode
		m_FixedRTFText
*/
#define ITEM_2009_10_29		2040

// Now define the current version
#define VER_ITEM			ITEM_2009_10_29
//#define VER_ITEM			ITEM_2008_08_06
//#define VER_ITEM			ITEM_2008_06_19
//#define VER_ITEM			ITEM_2007_01_19
//#define VER_ITEM			ITEM_2006_12_05
//#define VER_ITEM			ITEM_2006_11_06
//#define VER_ITEM			ITEM_2006_11_01
//#define VER_ITEM			ITEM_2006_09_21
//#define VER_ITEM			ITEM_2006_04_14
//#define VER_ITEM			ITEM_2005_06_23
//#define VER_ITEM			ITEM_2005_02_25
//#define VER_ITEM			ITEM_2004_04_30
//#define VER_ITEM			ITEM_2003_06_30
//#define VER_ITEM			ITEM_2003_06_01
//#define VER_ITEM			ITEM_2003_04_24
//#define VER_ITEM			ITEM_2003_01_30
//#define VER_ITEM			ITEM_2003_01_22
//#define VER_ITEM			ITEM_2002_12_04
//#define VER_ITEM			ITEM_2002_11_14
//#define VER_ITEM			ITEM_2002_07_24
//#define VER_ITEM			ITEM_2002_03_28
//#define VER_ITEM			ITEM_2001_07_02
//#define VER_ITEM			ITEM_2001_07_02
//#define VER_ITEM			ITEM_2001_06_20
//#define VER_ITEM			ITEM_1999_07_05

//// 1.0561 PAT 20.06.01 RTC WOBBLE ADDITIONS ////
//// 1.0571 PAT 02.07.01 NO ROLLOVER SERIAL NUMBER ////
//// 1.0629 PAT 28.01.02 OUTLINE-FILL ORDER OPTION ////
//// 1.0647 PAT 28.03.02 OUTLINE FIRST SAVE PATCH ////
//// 1.0687 PAT 22.07.02 DOT MATRIX ADDITIONS ////
//// 1.0723 PAT 14.11.02 REAL SIZE PATCH ////
//// 1.0733 PAT 04.12.02 LOCKED ITEM ////
//// 1.0741 PAT 22.01.03 TTF AS STRINGS ////
//// 1.0745 PAT 30.01.03 ALTERNATE IMPORTER ////
//// 1.0761 PAT 24.04.03 REAL SIZE/POS PATCH ////
//// 1.0699 PAT 12.08.02 DRILL OBJECT IN GUI ////
//// 1.0781 PAT 30.06.03 IMPORT FLAGS ////
//// 1.0863 PAT 30.04.04 FILE VERSION UPDATES ////
//// 1.1127 PAT 14.04.06 DYN LIST VAR TEXT ////
//// 1.1201 PAT 21.09.06 3 WAY LAYER & OBJECTS ////
//// 1.1245 PAT 31.10.06 GEOMETRY LINKAGE ////
//// 1.1253 PAT 06.11.06 LINKED DUPLICATE ////
//// 1.1273 PAT 05.12.06 TEXT CHECKSUM ////
//// 1.1281 PAT 19.01.07 NO APPEND CHECKSUM MODE ////
//// PS080619A HEX SERIAL NUMBER ////
//// PS080806B NO SERIAL INC WHEN SKIPPED ////
//// PS091029A SIMPLE TEXT RTF ////
