// vector graphic constants header file
//
// American LaserWare, Inc
// Pat Summers
// 19 AUG 1997
//
// Definitions for Vector graphic size and type values 
/////////////////////////////////////////////////////////

// vgconst.h

#ifndef VG_CONSTANTS
#define VG_CONSTANTS

// Include version info
#ifdef _ALIUSE
	#include "..\Versions\versions.h"
#else
	#include "versions.h"
#endif

// Enumerate header types
#define	VG_HT_GRAPHIC				1		// 102202
#define	VG_HT_FONT					2
#define VG_HT_FILL					3
#define VG_HT_NEWGRAPHIC			4		// 102202

// Set GlHeader size (number of longs in the header)
#define VG_HS_GRAPHIC				3		// added REALHEIGHT, REALWIDTH 102202
#define VG_HS_FONT					9                               
#define VG_HS_FILL					3   
#define VG_HS_NEWGRAPHIC			7                            

// Set header parameters
#define VG_XCOMP_FACTOR				10000
#define VG_SCALE_FACTOR				10000


/// It sure seems like all of these are off by 1
// Set GlHeader default values
///#define VG_HV_TYPE					1
///#define	VG_HV_XTOTAL				2
///#define VG_HV_YTOTAL				3
///#define VG_HV_REALHEIGHT			4         // graphic only  102202
///#define	VG_HV_XCELL					4
///#define VG_HV_REALWIDTH				5		  // graphic only  102202
///#define	VG_HV_YCELL					5
///#define VG_HV_ASCEND				6
///#define VG_HV_DESCEND				7
///#define VG_HV_LKERN					8
///#define VG_HV_RKERN					9

#define VG_HV_TYPE					0
#define	VG_HV_XTOTAL				1
#define VG_HV_YTOTAL				2
#define VG_HV_REALHEIGHT			3         // graphic only  102202
#define	VG_HV_XCELL					3
#define VG_HV_REALWIDTH				4		  // graphic only  102202
#define	VG_HV_YCELL					4
#define VG_HV_ASCEND				5
#define VG_HV_DESCEND				6
#define VG_HV_LKERN					7
#define VG_HV_RKERN					8

	
// Set GlVector size (number of longs in the vector)
#define	VG_VS_MOVEBY				3
#define	VG_VS_LINEBY				3
#define	VG_VS_RUNLINEBY				3
#define	VG_VS_ARCBY					5
//// 1.1285 PAT 24.01.07 GRAPHIC EMBEDDED SPOTS ////
#define VG_VS_SPOT					1
//// 1.1285 ////////////////////////////////////////
#define	VG_VS_STOP					1

// Set GlVector commands
#define VG_VC_MOVEBY				1
#define VG_VC_LINEBY				2
#define VG_VC_ARCBY					3
#define VG_VC_RUNLINEBY				4
//// 1.1285 PAT 24.01.07 GRAPHIC EMBEDDED SPOTS ////
#define VG_VC_SPOT					5
//// 1.1285 ////////////////////////////////////////
#define VG_VC_STOP					255

#ifndef PI
#define PI 3.141592653589793285
#endif


#endif

